C     Output of FBtoFO from GEFSUB.BAS
      PROGRAM MAIN
      IMPLICIT NONE
C     ' 
C     ' 
C     '    Copyright 2009,2010,2011,2012,2013,2014,2015,2016,2017,2018, 
C     '              2019,2020,2021,2022: 
C     '       Dr. Karl-Heinz Schmidt,Rheinstrasse 4,64390 Erzhausen,Germany 
C     '       and 
C     '       Dr. Beatriz Jurado,Centre d'Etudes Nucleaires de Bordeaux-Gradignan, 
C     '       Chemin du Solarium,Le Haut Vigneau,BP 120,33175 Gradignan,Cedex, 
C     '       France 
C     ' 
C     '    This program is free software: you can redistribute it and/or modify 
C     '    it under the terms of the GNU General Public License as published by 
C     '    the Free Software Foundation,either version 3 of the License,or 
C     '    (at your option) any later version. 
C     ' 
C     '    This program is distributed in the hope that it will be useful, 
C     '    but WITHOUT ANY WARRANTY; without even the implied warranty of 
C     '    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
C     '    GNU General Public License for more details. 
C     ' 
C     '    You should have received a copy of the GNU General Public License 
C     '    along with this program.  If not,see <http://www.gnu.org/licenses/>. 
C     ' 
C     ' 
C     /' Documentation: '/ 
C     /' (1) K.-H. Schmidt and B. Jurado,Contribution to '/ 
C     /'     ESNT Workshop "The scission process",Saclay (France),April 12-16,2010 '/ 
C     /' (2) B. Jurado and K.-H. Schmidt,Contribution to '/ 
C     /'     Seminar an fission,Gent (Belgium),May 17-20,2010 '/ 
C     /' (3) B. Jurado and K.-H. Schmidt,Contribution to '/ 
C     /'     EFNUDAT Workshop,Paris (France),May 25-27,2010 '/ 
C     /' (4) K.-H. Schmidt and B. Jurado,Contribution to '/ 
C     /'     EFNUDAT Workshop,Paris (France),May 25-27,2010 '/ 
C     /' (5) K.-H. Schmidt and B. Jurado,'/ 
C     /'     Final Report to EFNUDAT,October,2010 '/ 
C     /' (6) K.-H. Schmidt and B. Jurado,Phys. Rev. Lett. 104 (2010) 21250 '/ 
C     /' (7) K.-H. Schmidt and B. Jurado,Phys. Rev. C 82 (2011) 014607 '/ 
C     /' (8) K.-H. Schmidt and B. Jurado,Phys. Rev. C 83 (2011) 061601 '/ 
C     /' (9) K.-H. Schmidt and B. Jurado,arXiv:1007.0741v1[nucl-th] (2010) '/ 
C     /' (10) K.-H. Schmidt and B. Jurado,JEF/DOC 1423,NEA of OECD,2012 '/ 
C     /' (11) K.-H. Schmidt and B. Jurado,Phys. Rev. C 86 (2012) 044322 '/ 
C     /' (12) K.-H. Schmidt,B. Jurado,Ch. Amouroux,JEFF-Report 24,NEA of OECD,2014 '/ 
C     /' (13) B. Jurado,K.-H. Schmidt,J. Phys. G: Nucl. Part. Phys. 42 (2015) 055101 '/ 
C     /' (14) K.-H. Schmidt,B. Jurado,Eur. Phys. J. A 51 (2015) 176 '/ 
C     /' (15) K.-H. Schmidt,B. Jurado,C. Amouroux,C. Schmitt,Nucl. Data Sheets 131 (2016) 107 '/ 
C     /' (16) K.-H. Schmidt,B. Jurado,Rep. Progr. Phys. 81 (2018) 106301 '/ 
C     /' (17) K.-H. Schmidt et al.,Nucl. Data Sheets 173 (2021) 54 '/ 
C     ' 
C     /' Further documentation and the newest version of the GEF code are '/ 
C     /' available from                                                   '/ 
C     /' http://www.cenbg.in2p3.fr/GEF and http://www.khs-erzhausen.de/ . '/ 
C     ' 
C     ' 
C     '    The development of the GEF code has been supported by the European Union, 
C     '    EURATOM 6 in the Framework Program "European Facilities for Nuclear Data 
C     '    Measurements" (EFNUDAT),contract number FP6-036434,the Framework 
C     '    Program "European Research Infrastructure for Nuclear Data Applications 
C     '    (ERINDA),contract number FP7-269499,by the OECD Nuclear Energy Agency 
C     '    (from 2010 to 2016),and by the University Nantes (2018). 
C     ' 
C     ' 
C     ' Technical remark: The code contains commented sections with 
C     ' produce a deterministic version of the GEF code as a subroutine from this 
C     ' source with a dedicated pre-processor,named ExtractSub.bas. 
C     ' are used in the deterministic GEF version. 
C     ' ExtractSub.bas produces the deterministic code GEFSUB.bas in FreeBASIC. 
C     ' The translator FBtoFO.bas can be used to translate this code into FORTRAN99. 
C     ' In order to enable this translation,GEF.bas contains already some additional 
C     ' that are only used by the translator to provide some specific 
C     ' FORTRAN statements that cannot be produced automatically. 
C     ' 
C     ' 
C     /' K.-H. Schmidt / B. Jurado,07/Feb./2009 '/ 
C     /' SEFI9 is taken as a basis and extended by new features in SEFI14 (May 2010),KHS '/ 
C     /' Several improvements (even-odd effect,charge polarization etc. (June 2010),KHS '/ 
C     /' SEFI15 converted from PL/I to FreeBASIC on 04/July/2010,KHS '/ 
C     /' Error in LyPair corrected (26/July/2010) KHS '/ 
C     /' Indices corrected in U_Shell inside Eva (1/Aug/2010) KHS '/ 
C     /' Major developments,sigma_E*(scission),sigma_Z(A) etc. (14/Aug/2010) KHS '/ 
C     /' Macroscopic masses from Thomas-Fermi model (Myers & Swiatecki) (17/Aug/2010) KHS '/ 
C     /' 3 reference options for energy input (4/Sept/2010) KHS '/ 
C     /' Graphic output of mass distribution added (if there are problems with the X11 
C     installation on LINUX,the graphics may be suppressed by simply commenting 
C     the line  -> #Include Once "DCLPlotting.bas" <- )  (5/Sept/2010) KHS '/ 
C     /' Comparison with ENDF compilation in graphic output (12/Sept/2010) KHS '/ 
C     /' Super-long fission channel included (14/Sept/2010) KHS '/ 
C     /' Overlap of S1 and S2 fission channels in both fragments included (18/Oct/2010) KHS '/ 
C     /' Output of neutron multiplicity distribution added (20/Oct/2010) KHS '/ 
C     /' Decreasing curvature of shells with increasing E* (24/Oct/2010) KHS '/ 
C     /' Angular momenta of fission fragments added (18/Dec/2010) KHS '/ 
C     /' CN angular momentum considered (14/Jan/2011) KHS '/ 
C     /' Numerical stability improved (28/Jan/2011) KHS '/ 
C     /' Output in ENDF format (optional) (4/Feb/2011) KHS '/ 
C     /' Input list from file supported (31/Jan/2011) KHS '/ 
C     /' Multiprocessing supported (5/Feb/2011) KHS '/ 
C     /' Polarization for symmetric fission channel improved (12/Feb/2011) KHS '/ 
C     /' GUI for input (23/Feb/2011) KHS '/ 
C     /' Calculation of fission-fragment angular momentum refined (5/May/2011) KHS '/ 
C     /' Neutron inverse cross section modified (5/August/2011) KHS '/ 
C     /' Even-odd staggering in neutron emission improved (5/August/2011) KHS '/ 
C     /' Slight modifications in angular-momentum distributions (19/October/2011) KHS '/ 
C     /' Gamma emission added (23/November/2011) KHS '/ 
C     /' TKE added (24/November/2011) KHS '/ 
C     /' Neutron spectrum added (25/November/2011) KHS '/ 
C     /' Neutron-gamma competition added (4/December/2011) KHS '/ 
C     /' Composite level density (Egidy + Ignatyuk) refined (31/January/2012) KHS '/ 
C     /' Treatment of GDR refined (14/February/2012) KHS '/ 
C     /' Deformation of S3 channel changed (27/February/2012) KHS '/ 
C     /' Z=44 deformed shell added (supports S1 around Pu) (27/February/2012) KHS '/ 
C     /' Uncertainties from perturbed fission yields (3/March/2012) KHS '/ 
C     /' Validity range extended to Z=120 (with a warning message) (8/March/2012) KHS '/ 
C     /' Neutron emission during fragment acceleration (18/March/2012) KHS '/ 
C     /' Several optimizations (15/April/2012) KHS '/ 
C     /' TF masses of Myers & Swiatecki corrected (pairing shift) (29/May/2012) KHS '/ 
C     /' Correction on intrinsic excitation energy (05/June/2012) KHS '/ 
C     /' Correction on gamma emission (25/September/2012) KHS '/ 
C     /' Free choice of listmode values (13/October/2012) KHS '/ 
C     /' Excitation-energy distribution from file (14/October/2012) KHS '/ 
C     /' Transfer of input from GUI corrected (02/November/2012) KHS '/ 
C     /' Parameters of perturbed calculations modified (02/November/2012) KHS '/ 
C     /' Model parameters je-adjusted (08/November/2012) KHS '/ 
C     /' Input options for isomeric target nuclei (09/November/2012) KHS '/ 
C     /' Random initialisation of the random generator (26/November/2012) KHS '/ 
C     /' Covariance matrix for Z,Apre,Apost,ZApre,ZApost (06/December/2012) KHS '/ 
C     /' Output file in XML format (06/December/2012) KHS '/ 
C     /' Multi-chance fission supported (13/December/2012) KHS '/ 
C     /' Pre-compound emission for (n,f) included (13/December/2012) KHS '/ 
C     /' Some technical corrections and modifications (17/December/2012) KHS '/ 
C     /' Transition from asymmetric to symmetric fission around Fm improved (19/December/2012) KHS '/ 
C     /' Influence of S2 channel on S1 channel in the other fragment included (20/December/2012) KHS'/ 
C     /' List-mode output of pre-fission neutron energies (21/December/2012) KHS '/ 
C     /' Parameterisation for EB-EA from fit to data in Dahlinger et al. (21/December/2012) KHS '/ 
C     /' Fission channel at Z=42 added (seen around Pu in light fragment and around Hg) (23/Dec./2012) KHS '/ 
C     /' Gamma-n / Gamma-f according to Moretto (IAEA Rochester) (23/December/2012) KHS '/ 
C     /' Pre-compound neutron energies modified (24/December/2012) KHS '/ 
C     /' Some technical revisions to avoid crashes in covariances (26/December/2012) KHS '/ 
C     /' Influence of shells on yrast line from Deleplanque et al. (26/December/2012) KHS '/ 
C     /' Fission threshold in multi-chance fission modified (30/December/2012) KHS '/ 
C     /' Output of energies at fission for multi-chance fission (30/December/2012) KHS '/ 
C     /' Several revisions (15/January/2013) KHS '/ 
C     /' New optical model fit (3/February/2013) KHS '/ 
C     /' Gamma-f / Gamma-n modified (3/February/2013) KHS '/ 
C     /' Handling for reading input from file corrected (5/February/2013) KHS '/ 
C     /' Data transfer from GUI corrected (6/February/2013) KHS '/ 
C     /' Input dialog re-organized (6/February/2013) KHS '/ 
C     /' Mass-dependent deformation and charge polarization revised (9/February/2013) KHS '/ 
C     /' Calculation of combined fission channels S12,S22 revised (10/February/2013) KHS '/ 
C     /' Extension of validity range to heavier nuclei (10/February/2013) KHS '/ 
C     /' Improved description of prompt-neutron spectra (21/February/2013) KHS '/ 
C     /' Several technical corrections and developments (April-May/2013) KHS '/ 
C     /' Pre-fission emission of protons considered (14/Mai,2013) KHS '/ 
C     /' Structure of energy list in input file modified (26/May/2013) KHS '/ 
C     /' Option "local fit" added (26/May/2013) KHS '/ 
C     /' Neutron evaporation corrected (more realistic even-odd effect in isotonic distr.) (21/June(2013) KHS '/ 
C     /' Even-odd effect in TKE added (23/June/2013) KHS '/ 
C     /' Calculation of Z-A-covariance matrix corrected (16/July/2013) KHS '/ 
C     /' Output of multi-variate distributions corrected for input from file (24/July/2013) KHS '/ 
C     /' New global fit (most important: Energy gain from saddle to scission reduced) (15/September/2013) KHS '/ 
C     /' Even-odd effect in neutron number of fragments modified (17/September/2013) KHS '/ 
C     /' Curvatures of fission valleys adjusted to experimental shells around 132Sn (18/September/2013) KHS '/ 
C     /' Width of S0 corrected: Fit of Rusanov (18/September/2013) KHS '/ 
C     /' Random generator Box with asymmetric diffuseness for S2 (18/September/2013) KHS '/ 
C     /' Gaussian random generator revised (20/September/2013) KHS '/ 
C     /' Mass shift of fission channels with E* modified (22/September/2013) KHS '/ 
C     /' Energy dependence of S1 position corrected,slightly modified parameters (25/September/2013) KHS '/ 
C     /' Initial angular momentum introduced as an input parameter (02/October/2013) KHS '/ 
C     /' Calculation of prompt-neutron emission improved,some model parameters modified (12/October/2013) KHS '/ 
C     /' Technical error,causing incomplete covariance matrices on output corrected  (17/October/2013) KHS '/ 
C     /' Washing of shell effects considerd in shape fluctuations (26/October/2013) KHS '/ 
C     /' Post-scission neutrons added to list-mode output (8/November/2013) KHS '/ 
C     /' Fission-gamma competition refined (10/November/2013) KHS '/ 
C     /' New global fit of model parameters (18/November/2013) KHS '/ 
C     /' Multi-chance fission modified (18/November/2013) KHS '/ 
C     /' A numerical instability removed (20/November/2013) KHS '/ 
C     /' Calculation of multi-chance fission: corrected and modified (28/November/2013) KHS '/ 
C     /' Spurious even-odd effect in fission probabilities (from Moeller's shells) removed (4/December/2013) KHS '/ 
C     /' More precise calculation of E* in n-induced fission (6/December/2013) KHS '/ 
C     /' Pre-fission gamma strength increased (adjusted to Pf(E*) of 238U (22/December/2013) KHS '/ 
C     /' Kinetic energy of prompt neutrons in cm system (fragment-neutron) (10/Janurary/2014) KHS '/ 
C     /' Binnig of prompt-neutron spectra corrected (shift by 50 keV) (10/January/2014) KHS '/ 
C     /' Description of fission barriers modified (15/January/2014) KHS '/ 
C     /' Description of energy-dependent fission probability modified (17/January/2014) KHS '/ 
C     /' E* at scission modified for fission below Bf (4/February/2014) KHS '/ 
C     /' Influence of Z=44 shell on deformation of light fragment (4/February/2014) KHS '/ 
C     /' Tunneling for S1 enhanced (16/February/2014) KHS '/ 
C     /' New global fit of fission channels (strength and position) (19/March/2014) KHS '/ 
C     /' Normalization of distributions for deterministic version corrected (23/May/2014) KHS '/ 
C     /' Calculation of "corrected sample variance" revised (05/September/2014) KHS '/ 
C     /' Uncertainties calculated with "corrected sample variance" (05/September/2014) KHS '/ 
C     /' Shape of "S22" fission channel modified (08/December/2014) KHS '/ 
C     /' Binsize for prompt neutrons set to 1 keV (09/December/2014) KHS '/ 
C     /' Binsize for prompt gammas set to 1 keV (09/December/2014) KHS '/ 
C     /' Fragment excitation energies in listmode (10/December/2014) KHS '/ 
C     /' Shell in symmetric fission channel included in GEFSUB (12/December/2014) KHS '/ 
C     /' Ground-state spin of fragments is taken into account (22/January/2015) KHS '/ 
C     /' Pre-fission gamma emission included (20/February/2015) KHS '/ 
C     /' VMI model for E2 gammas developed and implemented (15/March/2015) KHS '/ 
C     /' Binning of spectrum EN corrected (28/March/2015) KHS '/ 
C     /' Energetics of symmetric fission channel revised (5/April/2015) KHS '/ 
C     /' Output of isomeric yields extended (# of events added) (10/April/2015) KHS '/ 
C     /' Control-output for progress of calculation (17/April/2015) KHS '/ 
C     /' Angular-momentum dependence of pairing gap in eva (7/May/2015) KHS '/ 
C     /' Angular-momentum dependent Gf: influence of fissility and temperature (13/May/2015) KHS '/ 
C     /' Influence of angular momentum on mass width by increasing fissiliy (14/May/2015) KHS '/ 
C     /' Mass distribution truncated at zero and A_CN (14/May/2015) KHS '/ 
C     /' Yields of fission modes also for multi-chance fission (7/August/2015) KHS '/ 
C     /' Tentative description of structure in FF distributions around A_CN = 180-200 (8/August/2015) KHS '/ 
C     /' Improved description of asymmetric fission in light nuclei (A_CN < 220) (9/August/2015) KHS '/ 
C     /' Extension of the validity range to lighter nuclei (9/August/2015) KHS '/ 
C     /' Adaptions of ERF function to new FreeBASIC compiler (12/Sept(2015) KHS '/ 
C     /' Allowance for calculations with very large number of events (15/Sept(2015) KHS '/ 
C     /' Slight adjustement of parameters to "repair" deterioation for low E* (21/Sept/2015) KHS '/ 
C     /' Correction of some formatting issues (03/Oct/2015) KHS '/ 
C     /' Calculation of covariances for independent yields corrected (6/Nov/2015) KHS '/ 
C     /' Calculation of covariances between two systems corrected (6/Nov/2015) KHS '/ 
C     /' Output of correlations matrices added (6/Nov/2015) KHS '/ 
C     /' Espectrum.in can now also provide the CN spin (13/Nov/2015) KHS '/ 
C     /' Output for parallel computing better protected (1/March/2016) KHS '/ 
C     /' Output of random files provided (4/March/2016) KHS '/ 
C     /' Prompt-neutron spectrum with variable bin size added (6/April/2016) KHS '/ 
C     /' Overflow problem in tanh and coth corrected (11/April/2016) KHS '/ 
C     /' Experimental masses in evaporation routine (not yet finished) (23/April/2016) KHS '/ 
C     /' Subscriptrange problem in output of neutron energies corrected (29/April/2016) KHS '/ 
C     /' Gamma spectra with conditions on pre-neutron mass (29/Mai/2016) KHS '/ 
C     /' Relation between energies: experimental masses used (07/Sept/2016) KHS '/ 
C     /' Partial support of p-induced fission (up to Ep = 30 MeV) 
C     (pre-equilibrium emission not yet implemented,preliminary l-distribution) (07/Sept/2016) KHS '/ 
C     /' Model parameters of fission channels optimized (20/Sept/2016) KHS '/ 
C     /' Neutrons emitted between outer saddle and scission added (21/Sept/2016) KHS '/ 
C     /' Output of delayed-neutron multiplicities added (25/Sept/2016) KHS '/ 
C     /' New adjustment of model parameters (13/Oct/2016) KHS '/ 
C     /' Output of delayed-neutron emitters added (13/Oct/2016) KHS '/ 
C     /' Uncertainty range of angular momentum added (24/Oct/2016) KHS '/ 
C     /' Uncertainties of prompt-gamma and prompt-neutron characteristics added (24/Oct/2016) KHS '/ 
C     /' Uncertainty of TKE (pre and post) added (06/Nov/2016) KHS '/ 
C     /' Normalization of Maxwell distribution corrected (07/Nov/2016) KHS '/ 
C     /' Declaration of some variables changed to prevent overflow (24/Nov/2016) KHS '/ 
C     /' Energy dependence of shape fluctuations modified (26/Nov/2016) KHS '/ 
C     /' Formatting of output slightly modified (15/Dec/2016,15/May/2017) KHS '/ 
C     /' Fission probabilities added to output (01/Jul/2017) KHS '/ 
C     /' Calculation of correlations between two systems allowed from input file (25/Jul/2017) KHS '/ 
C     /' Input options from file implemented (27/July/2017) KHS '/ 
C     /' Fluctuation of E_intr modified (only E* over Bf considered) (22/Sept/2017) KHS '/ 
C     /' Fluctuation of neck distance introduced (22/Sept/2017) KHS '/ 
C     /' New adjustment of fit parameters with special care for 235U(nth,f), 
C     data point for A=129 from ENDF replaced by other measurement (23/Sept/2017) KHS '/ 
C     /' Adjustment of mass-dependent prompt-neutron multiplicities,new general fit (27/Sept./2017) KHS '/ 
C     /' Extension of energy range for energy sorting (27/Sept/2017) KHS '/ 
C     /' New fit with shape of S2 closer to a Gaussian (3/Oct/2017) KHS '/ 
C     /' Symmetric fission channel at low energies revised (7/Oct/2017) KHS '/ 
C     /' New comprehensive fit of model parameters (18-31/Oct/2017) KHS '/ 
C     /' Spurious structure at symmetry in pre-neutron yields removed (30/Oct/2017) KHS '/ 
C     /' Odd-even effect on Pf modified (31/Oct/2017) KHS '/ 
C     /' Numerical problem in odd-even effect in Z and A of light nuclei corrected (16/Nov/2017) KHS '/ 
C     /' Minimum collective temperature reduced (16/Nov/2017) KHS '/ 
C     /' Improved parameters of the Z=38 shell (16-22/Nov/2017) KHS '/ 
C     /' Sequence of energy values from file allowed for options "GS" and "EB" (24/Nov/2017) KHS '/ 
C     /' Shell effect in fission probability revised (27/Nov/2017) KHS '/ 
C     /' Calculation of fission probabilities modified (5-20/Dec/2017) KHS '/ 
C     /' Scaling factor for variation of perturbed parameters introduced (20/Jan/2018) KHS '/ 
C     /' Hbar-Omeaga of charge polarization modified (better agreement with radiochemical data) (24/Jan/2018) KHS '/ 
C     /' Model parameters better adjusted to independent yields of 235U(nth,f) (28/Jan/2018) KHS '/ 
C     /' Calculation of covariances/correlations between 2 systems corrected (29/Jan/2018) KHS '/ 
C     /' New optimization of model parameters (27/Mar/2018) KHS '/ 
C     /' Several simultaneous calculations of the same systems with different energies enabled (27/Mar/2018) KHS '/ 
C     /' Several systems from JEFF 3.1.1 and JEFF 3.3 added to DCLPlotting.bas (28/Mar/2018) KHS '/ 
C     /' Energies and spins for calculation of isomeric yields from NUBASE (31/Mar/2018) KHS '/ 
C     /' Input dialog (Linux) revised (10/Apr/2018) KHS '/ 
C     /' New optimization of model parameters (28/Apr/2018) KHS '/ 
C     /' Assumed uncertainties of parameter values reduced by a factor of 0.6 (28/Apr/2018) KHS '/ 
C     /' Neutron emission between saddle and scission corrected (10/June/2018) KHS '/ 
C     /' Overflow problem in calculation of fission chances solved (09/July/2018) KHS '/ 
C     /' Shell effect at symmetry is washed out in Getyield with increasing E* (9/Aug/2018) KHS '/ 
C     /' More flexible handling of plotting (15/Dec/2018) KHS '/ 
C     /' More options for calculations from file (e.g. energy spectrum) (15/Dec/2018) KHS '/ 
C     /' NucpropNUBASE.bas: estimated data included (16/Dec/2018) KHS '/ 
C     /' Windows version: Technical problem with GUI corrected (18/Dec/2018) KHS '/ 
C     /' File name for energy spectrum on input can be freely chosen in dialog and batch mode (17/Dec/2018) KHS '/ 
C     /' Output of prompt-neutron mean energies extended (30/Dec/2018) KHS '/ 
C     /' Protection of validity range softened (28/Jan/2019) KHS '/ 
C     /' Influence of N=50 shell on charge polarisation introduced (30/Jan/2019) KHS '/ 
C     /' Spread of gamma energy due to spin of statistical photons introduced (03/Feb/2019) KHS '/ 
C     /' Calculation of fission probability revised (04/Feb/2019) KHS '/ 
C     /' Options "delayed processes" and "ENDF output" separated (09/Feb/2019) KHS '/ 
C     /' Option E* distribution from file with multi-chance fission introduced (17/Feb/2019) KHS '/ 
C     /' Mass-dependent modification of symmetric fission valley around 229Th introduced (05/Mar/2019) KHS '/ 
C     /' Parametrization of the S3 fission channel modified (11/Mar/2019) KHS '/ 
C     /' Delta_S0 parameter values revised (15/Mar/2019) KHS '/ 
C     /' Output of E*-dependent Pfis for option "EM" (15/Apr/2019) KHS '/ 
C     /' Momentum of incident particle: effect on pre-fission particle emission and fragments 
C     (17/Apr/2019) KHS '/ 
C     /' Direction in space of pre-scission particles and fragments included in 
C     list-mode output (17/Apr/2019) KHS '/ 
C     /' List-mode output of particle kinematics extended (06/May/2019) KHS '/ 
C     /' Option PnCN in GUI corrected (05/June/2019) KHS '/ 
C     /' Excitation energy used for fission from multi-chance section corrected (06/June/2019) KHS '/ 
C     /' Emission angle for prompt neutrons with very low E_kin revised (06/June/2019) KHS '/ 
C     /' P_fis revised: energy-dependent collective enhancement (04/September/2019) KHS '/ 
C     /' Error in calculation of kinematics (causing subscript-range violation) corrected (12/September/2019) KHS '/ 
C     /' Deformation of heavy fragment in fission of nuclei around mercury like 
C     deformation of light fragments in S1 and S2 in the actinides. 
C     Deformation of light fragment in fission of nuclei around mercury = 0 
C     (From new experimental data of Christelle Schmitt et al.,2019)   (preliminary: 20/December/2019) KHS '/ 
C     /' Data structure for correlation/covariance matrices simplified (02/February/2020) KHS '/ 
C     /' Initial energy added to name of lmd file in batch mode (02/February/2020) KHS '/ 
C     /' Option: locally adjusted (=default) or global model parameters in batch mode added (27/February/2020) KHS '/ 
C     /' Calculation and output of Chi-square vs. different evaluations and LOHENGRIN data (06/April/2020) KHS '/ 
C     /' List-mode output of state after prompt-gamma emission added (27/April/2020) KHS '/ 
C     /' Correlations and covariances of cumulative yields,also for 2 different systems,implemented (30/April/2020) KHS '/ 
C     /' Filter on specific fission modes introduced (18/July/2020) KHS '/ 
C     /' Nuclear properties for NucProp and DCLbranching extracted from JEFF-3.3 decay file (20/March/2020) Kilian Kern '/ 
C     /' Nuclear properties from JEFF-3.3 included in GEF (26/July/2020) KHS '/ 
C     /' Technical correction: Clearing of spectra for particles and gammas from CN shifted before multi-chance block (09/August/2020) KHS '/ 
C     /' More elaborate calculation of threshold for switching on the calculation of multi-chance fission (01/September/2020) KHS '/ 
C     /' Re-organization of the reading of spectroscopic and decay data in DCLbranchingxxx.bas and Nucpropxxx.bas (05/September/2020) KHS '/ 
C     /' Revision of the S4 fission channel (energy dependence from C 102,054611 (2020)) (04/December/2020) KHS '/ 
C     /' Error messages revised (03/January/2021) KHS '/ 
C     /' Composed level-density formula (const. temp - Fermi gas) exactly matched by adjusted shell in FG regime (20/April/2021) KHS '/ 
C     /' Cumulation process starting from external post-neutron fission yields implemented (16/May/2021) KHS '/ 
C     /' Output of A-dependent gamma multiplicities: extended to N=0 (19/May/2021) KHS '/ 
C     /' More consistent description of S4 (Z around 38) for pre-actinides 
C     (dE_Defo_S4 adjusted to mass yields ad low E*) (01/June/2021) KHS '/ 
C     /' T_Rusanov limited in pairing regime (24/Sept/2021) KHS '/ 
C     /' Output of potential energy near outer fission barrier in mode-pockets in /dmp folder (16/January/2022) KHS '/ 
C     /' Option for input of average angular momentum for batch mode (CN fission) added (07/April/2022) KHS '/ 
C     /' Z and A at saddle added to list-mode output (23/May/2022) KHS '/ 
C     /' alpha-induced fission introduced (05/June/2022) KHS '/ 
C     /' User-defined parameters from data file introduced (17/June/2022) KHS '/ 
C     /' Treatment of angular momentum revised (20/June/2022) KHS '/ 
C     /' Comprehensive Monte-Carlo fit implemented (21/December/2022) KHS '/ 
C     /' Value of HOMPOL increased,adjusted to delayed-neutron yields (21/December/2022) KHS '/ 
C     /' Parameter values determined by comprehensive fit (8/January/2023) KHS '/ 
C     ' 
C     ' 
C     /' FreeBASIC is available from http://www.freebasic.net/ '/ 
C     /' FreeBASIC runs on Windows,Linux,and DOS. '/ 
C     /' FreeBASIC runs also under Wine on MAC OS. '/ 
C     /' FreeBASIC compiles a binary code that uses the C run-time library. '/ 
C     ' 
C     ' 
C     '  #Include "utilities.bi" 
C     ' 
C     ' 
C     /' Functions and subroutines '/ 
C     ' 
      	 
      CALL GEFSUB(92,236,6.,0.0) 
C     ' 
C     ' The following section prints the results of GEFSUB. 
C     ' 
C     /' 
C     ' 
C     Dim As Single Zsum 
C     ' 
C     'Print 
C     'Print "Z,A,Yield" 
C     For I = 10 To 190 
C     For J = 10 To 140 
C     If NZPRE(I,J) > 0.0001 Then 
C     '      Print J,I+J,NZPRE(I,J)*200 
C     End If 
C     Next 
C     Next 
C     ' 
C     ' 
C     'Print 
C     'Print "Z yields" 
C     For J = 10 To 140 
C     Zsum = 0 
C     For I = 10 To 190 
C     Zsum = Zsum + NZpre(I,J) 
C     Next 
C     If Zsum > 0.0 Then 
C     '    Print J,Zsum * 200 
C     End If 
C     Next '/ 
C     ' 
C     ' 
C     /' 
C     Dim As Single Asum 
C     'Print 
C     'Print "N yields" 
C     For I = 10 To 140 
C     Asum = 0 
C     For J = 10 To 190 
C     Asum = Asum + NZpre(I,J) 
C     '   If NZPRE(I,J) > 0.001 Then 
C     '     Print J,I+J,NZPRE(I,J)*200 
C     '   End If 
C     Next 
C     '  Print I,Asum * 200 
C     Next   '/ 
C     ' 
      End 
C     ' 
C     ' 
      SUBROUTINE GEFSUB(P_Z_CN,P_A_CN,P_E_EXC,P_J_CN)
      IMPLICIT NONE
      INTEGER*4 P_Z_CN
      INTEGER*4 P_A_CN
      REAL*4 P_E_EXC
      REAL*4 P_J_CN
C     /' Input parameters: '/ 
C     /' Atomic number,mass number,excitation energy/MeV,spin/h_bar of CN '/ 
C     /' Results are stored in external arrays. '/ 
C     ' 
      INCLUDE "GEFSUBdcl2.FOR" 
C     /' This is the place for the statements of Parameters.FOR '/ 
C     '  Emax_valid = 100      /' Maximum allowed excitation energy '/ 
C     '  Eexc_min_multi = 3            /' Threshold for calc. of multi-chance fission '/ 
C     ' _Delta_S0 = 0         /' Shell effect for SL,for individual systems '/ 
C     '  EOscale = 1.0  /' Scaling factor for even-odd structure in yields '/ 
C     '  Emode = 1      /' 0: E over BF_B; 1: E over gs; 2: E_neutron; 12: E_proton '/ 
C     ' 
      xP_DZ_Mean_S1 = -0.1710014 
      xP_corr_S1 = 0.07004809 
      xP_DZ_Mean_S2 = -0.5337825 
      xP_DZ_Mean_S3 = 0.3737403 
C     /' Shift of mean Z of Mode 3 '/ 
      xP_DZ_Mean_S4 = 0.0298693 
C     /' Shell for structure at A around 190 '/ 
      ZC_Mode_4L = 44.4 
C     /' Maximum at Pu,higher ZC_Mode_4L -> towards Am etc. '/ 
      xP_Z_Curv_S1 = 0.3814453 
      P_Z_Curvmod_S1 = 1.75 
C     /' Scales energy-dependent shift '/ 
      xP_Z_Curv_S2 = 0.09044272 
      xS2leftmod = 0.8047901 
C     /' Asymmetry in diffuseness of S2 mass peak '/ 
      P_Z_Curvmod_S2 = 10 
C     /' Scales energy-dependent shift '/ 
      xP_A_Width_S2 = 11.63902 
C     /' A width of Mode 2 (box) '/ 
      xP_Z_Curv_S3 = 0.08252484 
      P_Z_Curvmod_S3 = 10 
C     /' Scales energy-dependent shift '/ 
      P_Z_Curv_SL4 = 0.07 
      P_Z_Sigma_SL4 = 1.15 
      xP_Z_Curv_S4 = 0.05258834 
      P_Z_Curvmod_S4 = 10 
C     /' Scales energy-dependent shift '/ 
      xP_Shell_S1 = -3.243825 
C     /' Shell effect for Mode 1 (S1) '/ 
      xP_Shell_S2 = -4.517141 
C     /' Shell effect for Mode 2 (S2) '/ 
      xP_Shell_S3 = -7.128624 
C     /' Shell effect for Mode 3 (SA) '/ 
      P_Shell_SL4 = -0.4 
      xP_Shell_S4 = -1.145348 
      P_S4_mod = -0.035 
      xPZ_S3_olap_pos = 39.64489 
C     /' Pos. of S3 shell in light fragment (in Z) '/ 
      xPZ_S3_olap_curv = 0.003991976 
      ETHRESHSUPPS1 = 10.85 
      ESIGSUPPS1 = 1.0 
      Level_S11 = 3.0 
C     /' Level for mode S11 (higher values means more symmetric fission) '/ 
      Shell_fading = 50 
C     /' fading of shell effect with E* '/ 
      xT_low_S1 = 0.3158501 
      xT_low_S2 = 0.294624 
C     /' Slope parameter for tunneling '/ 
      xT_low_S3 = 0.3174517 
C     /' Slope parameter for tunneling '/ 
      xT_low_S4 = 0.3121705 
C     /' Slope parameter for tunneling '/ 
      xT_low_SL = 0.2886375 
C     /' Slope parameter for tunneling '/ 
      T_low_S11 = 0.36 
C     /' Slope parameter for tunneling '/ 
      xP_att_pol = 2.578573 
      P_att_pol2 = 0 
      P_att_pol3 = 0 
      xP_att_rel = 1 
C     /' Relative portion of attenuation '/ 
      xdE_Defo_S1 = -4.254451 
C     /' Deformation energy expense for Mode 1 '/ 
      xdE_Defo_S2 = -0.7485108 
C     /' Deformation energy expense for Mode 2 '/ 
      xdE_Defo_S3 = 0.601014 
C     /' Deformation energy expense for Mode 3 '/ 
      xdE_Defo_S4 = -0.6219091 
C     /' Deformation energy expense for Mode 4 '/ 
      xbetaL0 = 27.88452 
      xbetaL1 = 0.7099661 
      xbetaH0 = 45.67577 
C     /' Offset for deformation of heavy fragment '/ 
C     ' _betaH0 = 48.2      ' This value in combination with EDISSFRAC = 0.35 gets nu-bar correct for U235T and Cf252SF 
      xbetaH1 = 0.5417268 
      xdbeta_S3 = 0.3975313 
      kappa = 0 
C     /' N/Z dedendence of A-asym. potential '/ 
      TCOLLFRAC = 0.04 
C     /' Tcoll per energy gain from saddle to scission '/ 
      xECOLLFRAC = 0.02141861 
C     /' Fraction of pot. energy gain from saddle to scission,going into coll. excitations '/ 
      TFCOLL = 0.034 
      TCOLLMIN = 0.12 
      ESHIFTSASCI_intr = -67 
C     /' Shift of saddle-scission energy '/ 
      ESHIFTSASCI_coll = -90 
C     /' Shift of saddle-scission energy '/ 
      xEDISSFRAC = 0.3791646 
      Epot_shift = 0 
      SIGDEFO = 0.165 
      SIGDEFO_0 = 0.165 
      SIGDEFO_slope = 0 
      SIGENECK = 5.0 
C     /' Width of TXE by fluctuation of neck length '/ 
      EexcSIGrel = 0.7 
      DNECK = 1 
C     /' Tip distance at scission / fm '/ 
      FTRUNC50 = 1 
C     /' Truncation near Z = 50 '/ 
      ZTRUNC50 = 50 
C     /' Z value for truncation '/ 
      FTRUNC28 = 0.56 
C     /' Truncation near Z = 28 '/ 
      ZTRUNC28 = 30.5 
C     /' Z value for truncation '/ 
      ZMAX_S2 = 60 
C     /' Maximum Z of S2 channel in light fragment '/ 
      NTRANSFEREO = 6 
C     /' Steps for E sorting for even-odd effect '/ 
      NTRANSFERE = 12 
C     /' Steps for E sorting for energy division '/ 
      Csort = 0.5 
C     /' Smoothing of energy sorting '/ 
      PZ_EO_symm = 2.6 
C     /' Even-odd effect in Z at symmetry '/ 
      PN_EO_Symm = 2.6 
C     /' Even-odd effect in N at symmetry '/ 
      R_EO_THRESH = 0.398 
C     /' Threshold for asymmetry-driven even-odd effect'/ 
      R_EO_SIGMA = 2.0 
      R_EO_Max = 0.6 
      xPOLARadd = 0.3741641 
C     /' Offset for enhanced polarization '/ 
      POLARfac = 1 
C     /' Enhancement of polarization of liqu. drop '/ 
      T_POL_RED = 0.01 
C     /' Reduction of temperature for sigma(Z) '/ 
      xHOMPOL = 2.38018 
C     /' hbar omega of polarization oscillation '/ 
      ZPOL1 = 0 
C     /' Extra charge polarization of S1 '/ 
      P_n_x = 0 
C     /' Enhanced inverse neutron x section '/ 
      Tscale = 1 
      Econd = 2.0 
C     /' Pairing condenstation energy '/ 
      Etrans = 7.0 
C     /' Matching energy (const. temp to Fermi gas level denstiy '/ 
      T_orbital = 0 
C     /' From orbital ang. momentum '/ 
      xJscaling = 1.0 
C     /' General scaling of fragment angular momenta '/ 
      Spin_odd = 0.4 
C     /' RMS Spin enhancement for odd Z '/ 
C     /' Value of 0.4 adjusted to data. In conflict with Naik! '/ 
      Esort_extend = 1.5 
C     /' Extension of energy range for E-sorting '/ 
      Esort_slope = 0.04 
C     /' Onset of E-sorting around symmetry '/ 
      Esort_slope_S0 = 0.2 
C     /' Onset of E-sorting around symmetry for S0 channel '/ 


      xDelta_S0 = U_Delta_S0(P_Z_CN,P_A_CN) 
C     ' default values 
C     ' 
C     ' Use nominal parameter values: 
      P_DZ_Mean_S1 = xP_DZ_Mean_S1 
      P_corr_S1 = xP_corr_S1 
      P_DZ_Mean_S2 = xP_DZ_Mean_S2 
      P_DZ_Mean_S3 = xP_DZ_Mean_S3 
      P_DZ_Mean_S4 = xP_DZ_Mean_S4 
      P_Z_Curv_S1 = xP_Z_Curv_S1 
      P_Z_Curv_S2 = xP_Z_Curv_S2 
      S2leftmod = xS2leftmod 
      P_A_Width_S2 = xP_A_Width_S2 
      P_Z_Curv_S3 = xP_Z_Curv_S3 
      P_Z_Curv_S4 = xP_Z_Curv_S4 
      PZ_S3_olap_pos = xPZ_S3_olap_pos 
      PZ_S3_olap_curv = xPZ_S3_olap_curv 
      Delta_S0 = xDelta_S0 
      P_Shell_S1 = xP_Shell_S1 
      P_Shell_S2 = xP_Shell_S2 
      P_Shell_S3 = xP_Shell_S3 
      P_Shell_S4 = xP_Shell_S4 
      dE_Defo_S1 = xdE_Defo_S1 
      dE_Defo_S2 = xdE_Defo_S2 
      dE_Defo_S3 = xdE_Defo_S3 
      dE_Defo_S4 = xdE_Defo_S4 
      betaL0 = xbetaL0 
      betaL1 = xbetaL1 
      betaH0 = xbetaH0 
      betaH1 = xbetaH1 
      dbeta_S3 = xdbeta_S3 
      T_low_S1 = xT_low_S1 
      T_low_S2 = xT_low_S2 
      T_low_S3 = xT_low_S3 
      T_low_S4 = xT_low_S4 
      T_low_SL = xT_low_SL 
      ECOLLFRAC = xECOLLFRAC 
      EDISSFRAC = xEDISSFRAC 
      P_att_pol = xP_att_pol 
      P_att_rel = xP_att_rel 
      HOMPOL = xHOMPOL 
      POLARadd = xPOLARadd 
      Jscaling = xJscaling 
C     ' 
      R_E_exc_used = P_E_exc 
      I_A_CN = P_A_CN 
      I_Z_CN = P_Z_CN 
C     ' 
C     /' Central Z values of fission modes '/ 
C     ' 
C     /' Test of barrier height for compact fission '/ 
C     /'   Dim As Single Fbarr_shell 
C     Dim As Single Fbarr_macro 
C     Fbarr_shell = 1.44 * (I_C_CN/2)^2 / (1.4 * 2 * (I_A_CN/2)^(1/3)) 
C     Fbarr_macro = 1.44 * (I_C_CN/2)^2 / (1.4 * 2 * (I_A_CN/2)^(1/3)) '/ 
C     ' 
C     /' Fit to positions of fission channels (Boeckstiegel et al.,2008) '/ 
C     /' P_DZ_Mean_S1 and P_DZ_Mean_S2 allow for slight adjustments '/ 
C     '    Scope 
      R_Z_mod = REAL(I_Z_CN) 
      R_A_mod = REAL(I_A_CN) 
      R_corr1 = P_corr_S1 * (R_Z_mod - 92.0) 
C     '      R_corr1 = 0.07 * (R_Z_mod - 92.0)             ' additional corrections w.r. to 236U(nth,f) 
      R_corr2 = 0.055 * (R_A_mod - R_Z_mod*236/92) 
C     '                 " 
C     ' 
C     ' * SL (S0) : * 
      ZC_Mode_0 = R_Z_mod * 0.5E0 
C     /' Central Z value of SL mode '/ 
C     ' 
C     ' * S1 : * 
      ZC_Mode_1 = (55.8E0 - 54.5E0) / (1.56E0 - 1.50E0) * 
     *(R_Z_mod**1.3E0 / R_A_mod - 1.50E0) + 51.5E0 + P_DZ_Mean_S1 + 
     *R_corr1 
C     ' 
C     ' * S2: * 
      ZC_Mode_2 = (55.8E0 - 54.5E0) / (1.56E0 - 1.50E0) * 
     *(R_Z_mod**1.3E0 / R_A_mod - 1.50E0) + 54.5E0 + P_DZ_Mean_S2 + 
     *R_corr2 
C     ' 
C     ' * S3: * 
C     '      ZC_Mode_3 = ZC_Mode_2 + 4.5E0 + P_DZ_Mean_S3 
C     ' 
      ZC_Mode_3 = ZC_Mode_2 + 4.87E0 + P_DZ_Mean_S3 
      ZC_Mode_3_shift = - 0.015 * (ZC_Mode_3 - ZC_Mode_0) 
C     ' 
      ZC_Mode_3 = ZC_Mode_2 + 5.5E0 + P_DZ_Mean_S3 
      ZC_Mode_3_shift = - 0.035 * (ZC_Mode_3 - ZC_Mode_0) 
C     ' 
      ZC_Mode_3 = ZC_Mode_3 + ZC_Mode_3_shift 
C     ' To account for ZCN-dependent shift of S3 towards minimum of mac. potential 
C     ' 
C     ' 
C     ' * S4: * 
C     ' Do not delete these lines (,because this is a very good fit!): 
C     '    ZC_Mode_4 = 38.5 + (I_A_CN-I_Z_CN-110)*0.12 - (I_A_CN-I_Z_CN-110)^2 * 0.009   '                - (I_Z_CN-77)*0.34 + P_DZ_Mean_S4 
C     ' assumption: mode position moves with Z and A (adjusted to exp. data 
C     ' of Itkis and Andreyev et al. 
C     '  ZC_Mode_4 = - (55.8E0 - 54.5E0) / (1.56E0 - 1.50E0) *      '              (R_Z_mod^1.3E0 / I_A_CN - 1.50E0) + 37.5 + P_DZ_Mean_S4  - R_corr2      '                + 0.035 * (I_A_CN- I_Z_CN - 100)   'fits Tl201 (itkis),but not so well Po194,196 (Andreyev) 
C     ' corresponding P_DZ_Mean_S4 = -0.5 
      ZC_Mode_4 = 35.5 + REAL(I_A_CN - I_Z_CN - 100) * 0.11 + 
     *P_DZ_Mean_S4 
C     ' mean Z of light fragment in Mode 4 
C     ' 
C     ' Print "R_corr2: ",R_corr2 
C     ' Print "Mode 2,Z and N:",ZC_Mode_2,ZC_Mode_2 / P_Z_CN * (P_A_CN-P_Z_CN) 
C     ' Print "Mode 4,Z and N:",ZC_Mode_4,ZC_Mode_4 / P_Z_CN * (P_A_CN-P_Z_CN) 
C     ' sleep 
C     '    End Scope 
C     ' 
C     ' 
C     ' 
      I_N_CN = I_A_CN - I_Z_CN 
C     /' Mean deformation at scission as a function of mass '/ 
C     ' 
C     /' Mode 0: liquid drop '/ 
      beta1_prev = 0.3 
      beta2_prev = 0.3 
      beta1_opt = beta1_prev 
      beta2_opt = beta2_prev 
      DO I_short = 10 , I_Z_CN - 10 
      IZ1 = I_short 
      Z1 = REAL(IZ1) 
      IZ2 = I_Z_CN - IZ1 
      Z2 = REAL(IZ2) 
      A1 = Z1 / REAL(I_Z_CN) * REAL(I_A_CN) 
      A2 = I_A_CN - A1 
C     ' 
C     ' Deformed shell below Z=50,valid for S0 at low E* 
      Beta(-1,1,IZ1) = beta_light(IZ1,betaL0,betaL1) - 0.1 
C     ' Lower deformation than S1/S2,because Coulomb repulsion from deformed heavy fragment is weaker. 
      Beta(-1,2,IZ2) = beta_light(IZ2,betaL0,betaL1) - 0.1 
C     '          " 
      E_defo = Lymass(Z1,A1,Beta(-1,1,IZ1)) - Lymass(Z1,A1,0.0) 
      Edefo(-1,1,IZ1) = E_defo 
      E_defo = Lymass(Z2,A2,Beta(-1,2,IZ2)) - Lymass(Z2,A2,0.0) 
      Edefo(-1,2,IZ2) = E_defo 
C     ' 
      CALL Beta_Equi(A1,A2,Z1,Z2,dneck,beta1_prev,beta2_prev,beta1_opt,
     *beta2_opt) 
C     ' 
C     ' Deformation by macroscopic model,valid for S0 at high E* 
C     'Print "Mode 0,Z1,Z2,beta1,beta2 ";Z1;" ";Z2;" ";beta1_opt,beta2_opt 
C     'Print Z1;" ";Z2;" ";beta1_opt,beta2_opt 
      Beta(0,1,IZ1) = beta1_opt 
C     /' "light" fragment '/ 
C     '      Beta(4,1,IZ1) = beta1_opt 
      Beta(0,2,IZ2) = beta2_opt 
C     /' "heavy" fragment '/ 
C     '      Beta(4,2,IZ2) = beta2_opt 
      beta1_prev = beta1_opt 
      beta2_prev = beta2_opt 
      E_defo = Lymass(Z1,A1,beta1_opt) - Lymass(Z1,A1,0.0) 
      Edefo(0,1,IZ1) = E_defo 
C     /' "light" fragment '/ 
C     '      Edefo(4,1,IZ1) = E_defo 
      E_defo = Lymass(Z2,A2,beta2_opt) - Lymass(Z2,A2,0.0) 
      Edefo(0,2,IZ2) = E_defo 
C     /' "heavy" fragment '/ 
C     '      Edefo(4,2,IZ2) = E_defo 
      END DO 
C     ' 
C     /' Mode 1: deformed shells (light) and spherical (heavy) '/ 
      DO I_short = 10 , I_Z_CN - 10 
      Z1 = REAL(I_short) 
      Z2 = REAL(I_Z_CN) - Z1 
      A1 = (Z1 - 0.5E0) / REAL(I_Z_CN) * REAL(I_A_CN) 
C     /' polarization roughly considered '/ 
      A2 = REAL(I_A_CN) - A1 
      IF (  I_Z_CN * 0.5 .LT. ZC_Mode_1  ) THEN 
C     ' Beta_opt_light(A1,A2,Z1,Z2,dneck,0,rbeta_ld) 
C     /' nu_mean of Cf requires shells in the light fragment: '/ 
C     '     rbeta = beta_light(I,betaL0,betaL1) - 0.1 
C     ' smaller than general deformation of light fragment 
C     '        (less neck influence due to spherical heavy fragment) 
      rbeta = beta_light(I_short,betaL0,betaL1) 
      IF (  rbeta .LT. 0  )  rbeta = 0 
      Else 
      rbeta = beta_heavy(I_short,betaH0,betaH1) 
C     ' equal to S2 channel 
      IF (  rbeta .LT. 0  )  rbeta = 0 
      End If 
      Beta(1,1,I_short) = rbeta 
C     /' "light" fragment '/ 
      E_defo = Lymass(Z1,A1,rbeta) - Lymass(Z1,A1,0.0) 
      Edefo(1,1,I_short) = E_defo 
C     /' "light" fragment '/ 
      END DO 
C     ' 
      DO I_short = 10 , I_Z_CN - 10 
      rbeta = 0 
      Beta(1,2,I_short) = rbeta 
      Edefo(1,2,I_short) = 0 
C     /' "heavy" fragment (at S1 shell) '/ 
      END DO 
C     ' 
C     /' Mode 2: deformed shells (light and heavy) '/ 
      DO I_short = 10 , I_Z_CN - 10 
      Z1 = REAL(I_short) 
      Z2 = REAL(I_Z_CN) - Z1 
      A1 = (Z1 - 0.5E0) / REAL(I_Z_CN) * REAL(I_A_CN) 
C     /' polarization roughly considered '/ 
      A2 = REAL(I_A_CN) - A1 
      IF (  I_Z_CN * 0.5 .LT. ZC_Mode_2  ) THEN 
C     ' Beta_opt_light(A1,A2,Z1,Z2,dneck,beta_heavy(Z2),rbeta_ld) 
      rbeta = beta_light(I_short,betaL0,betaL1) 
C     ' general deformation of light fragment 
      IF (  rbeta .LT. 0  )  rbeta = 0 
C     ' negative values replaced by 0 
      Else 
      rbeta = beta_heavy(I_short,betaH0,betaH1) 
C     ' equal to S2 channel 
      End If 
      Beta(2,1,I_short) = rbeta 
      E_defo = Lymass(Z1,A1,rbeta) - Lymass(Z1,A1,0.0) 
      Edefo(2,1,I_short) = E_defo 
      END DO 
      DO I_short = 10 , I_Z_CN - 10 
      rbeta = beta_heavy(I_short,betaH0,betaH1) 
C     /' "heavy" fragment (at S2 shell)'/ 
      IF (  rbeta .LT. 0  )  rbeta = 0 
C     ' negative values replaced by 0 
      Beta(2,2,I_short) = rbeta 
      Z1 = REAL(I_short) 
      A1 = (Z1 + 0.5E0) / REAL(I_Z_CN) * REAL(I_A_CN) 
C     /' polarization roughly considered '/ 
      E_defo = Lymass(Z1,A1,rbeta) - Lymass(Z1,A1,0.0) 
      Edefo(2,2,I_short) = E_defo 
      END DO 
C     ' 
C     /' Mode 3 '/ 
      DO I_short = 10 , I_Z_CN - 10 
      Z1 = REAL(I_short) 
      Z2 = REAL(I_Z_CN) - Z1 
      A1 = (Z1 - 0.5E0) / REAL(I_Z_CN) * REAL(I_A_CN) 
C     /' polarization roughly considered '/ 
      A2 = REAL(I_A_CN) - A1 
      rbeta = beta_light(I_short,betaL0,betaL1) 
      rbeta = Max(rbeta-0.10,0.0) 
C     /' for low nu-bar of lightest fragments '/ 
C     '  Beta_opt_light(A1,A2,Z1,Z2,dneck,beta_heavy(Z2,betaH0,betaH1),rbeta) 
      Beta(3,1,I_short) = rbeta 
      E_defo = Lymass(Z1,A1,rbeta) - Lymass(Z1,A1,0.0) 
      Edefo(3,1,I_short) = E_defo 
      END DO 
      DO I_short = 10 , I_Z_CN - 10 
      rbeta = beta_heavy(I_short,betaH0,betaH1) + dbeta_S3 
C     ' Shift from isotopic distributions of S3 nuclei in 239Pu(nth,f) 
      IF (  rbeta .LT. 0  )  rbeta = 0 
      Beta(3,2,I_short) = rbeta 
      Z1 = REAL(I_short) 
      A1 = (Z1 + 0.5E0) / REAL(I_Z_CN) * REAL(I_A_CN) 
C     /' polarization roughly considered '/ 
      E_defo = Lymass(Z1,A1,rbeta) - Lymass(Z1,A1,0.0) 
      Edefo(3,2,I_short) = E_defo 
      END DO 
C     ' 
C     /' Mode 4: (Channel S4,(fissioning nucleus in the Z=80 region),Zfrag around 38 '/ 
      DO I_short = 10 , I_Z_CN - 10 
C     ' heavy fragment 
      Z1 = REAL(I_short) 
      A1 = Z1 / REAL(I_Z_CN) * REAL(I_A_CN) 
C     /' charge polarization neglected '/ 
      rbeta = Beta(2,1,I_short) 
C     ' Deformation like the light fragment of S2 in the actinides 
      IF (  rbeta .LT. 0  )  rbeta = 0 
      Beta(4,1,I_short) = rbeta 
      Beta(4,2,I_short) = rbeta 
      E_defo = Lymass(Z1,A1,rbeta) - Lymass(Z1,A1,0.0) 
      Edefo(4,1,I_short) = E_defo 
C     /' light fragment '/ 
      Edefo(4,2,I_short) = E_defo 
C     /' heavy fragment '/ 
      END DO 
C     ' 
C     /' Mode 5: (Channel ST1 in both fragments) '/ 
      DO I_short = 10 , I_Z_CN - 10 
      Z1 = REAL(I_short) 
      Z2 = REAL(I_Z_CN) - Z1 
      rbeta = Beta(1,2,I_short) 
      IF (  rbeta .LT. 0  )  rbeta = 0 
      Beta(5,1,Int(Z1)) = rbeta 
      Beta(5,2,Int(Z1)) = rbeta 
      END DO 
C     ' 
C     /' Mode 6: (Channel ST2 in both fragments) '/ 
      DO I_short = 10 , I_Z_CN - 10 
      Z1 = REAL(I_short) 
      Z2 = REAL(I_Z_CN) - Z1 
      rbeta = Beta(2,2,I_short) 
      IF (  rbeta .LT. 0  )  rbeta = 0 
      Beta(6,1,Int(Z1)) = rbeta 
      Beta(6,2,Int(Z1)) = rbeta 
      END DO 
C     ' 
C     ' 
C     /' Mean Z as a function of mass '/ 
C     ' 
C     /' Mode 0 '/ 
      DO I_short = 10 , I_A_CN - 10 
      ZUCD = REAL(I_short) / REAL(I_A_CN) * REAL(I_Z_CN) 
      beta1 = Beta(0,1,Int(ZUCD + 0.5)) 
      beta2 = Beta(0,2,Int(I_Z_CN - ZUCD + 0.5)) 
      Z1 = Z_equi(I_Z_CN,I_short,I_A_CN - I_short,beta1,beta2,dneck,0) 
      Zmean(0,1,I_short) = Z1 
      Zshift(0,1,I_short) = Z1 - ZUCD 
      Zmean(0,2,I_A_CN - I_short) = I_Z_CN - Z1 
      Zshift(0,2,I_A_CN - I_short) = ZUCD - Z1 
      END DO 
C     ' 
C     /' Mode 1 '/ 
      DO I_short = 10 , I_A_CN - 10 
      ZUCD = REAL(I_short) / REAL(I_A_CN) * REAL(I_Z_CN) 
      Z = ZUCD + ZPOL1 
C     /' Charge polarisation is considered in a crude way '/ 
      beta1 = Beta(1,1,NINT(Z)) 
C     /' "light" fragment '/ 
      Z = ZUCD - ZPOL1 
      beta2 = Beta(1,2,NINT(I_Z_CN-Z)) 
C     /' "heavy" fragment  at S1 shell '/ 
      IF (  REAL(I_Z_CN) * 0.5 .LT. ZC_Mode_1  ) THEN 
      Z1 = Z_equi(I_Z_CN,I_short,I_A_CN - I_short,beta1,beta2,dneck,1) 
      Z1 = Z1 + Polaradd 
      Else 
      Z1 = Z_equi(I_Z_CN,I_short,I_A_CN - I_short,beta1,beta2,dneck,1) 
      End If 
      Z1 = Z1 + ZPOL1 
C     /' Charge polarization by shell '/ 
C     ' 
      IF (  I_Z_CN - Z1 .LT. 50. .AND. (REAL(I_Z_CN) - Z1) .GT. Z1  ) 
     *THEN 
      Z1 = REAL(I_Z_CN) - 50. 
C     /' Z of mean heavy fragment not below 50 '/ 
      END IF 
C     ' 
      Zmean(1,1,I_short) = Z1 
      Zshift(1,1,I_short) = Z1 - ZUCD 
C     ' neutron-deficient 
      Zmean(1,2,I_A_CN - I_short) = REAL(I_Z_CN) - Z1 
      Zshift(1,2,I_A_CN - I_short) = ZUCD - Z1 
C     ' neutron rich at shell 
      END DO 
C     ' 
C     /' Mode 2 '/ 
      DO I_short = 10 , I_A_CN - 10 
      ZUCD = REAL(I_short) / REAL(I_A_CN) * REAL(I_Z_CN) 
      Z = ZUCD 
C     /' Charge polarisation is here neglected '/ 
      beta1 = Beta(2,1,NINT(Z)) 
      beta2 = Beta(2,2,NINT(I_Z_CN-Z)) 
      IF (  REAL(I_Z_CN) * 0.5 .LT. ZC_Mode_2  ) THEN 
      Z1 = Z_equi(I_Z_CN,I_short,I_A_CN-I_short,beta1,beta2,dneck,2) 
      Z1 = Z1 + POLARadd 
C     ' Polarization caused by N=50 shell (assumption) 
      Z1 = Z1 - 0.55 * Bell(REAL(I_short)-Z1,45.0,49.5) 
      Else 
      Z1 = Z_equi(I_Z_CN,I_short,I_A_CN-I_short,beta1,beta2,dneck,2) 
      End If 
C     ' 
      Zmean(2,1,I_short) = Z1 
      Zshift(2,1,I_short) = Z1 - ZUCD 
C     ' neutron deficient 
      Zmean(2,2,I_A_CN - I_short) = REAL(I_Z_CN) - Z1 
      Zshift(2,2,I_A_CN - I_short) = ZUCD - Z1 
C     ' neutron rich at shell 
      END DO 
C     ' 
C     /' Mode 3 '/ 
      DO I_short = 10 , I_A_CN - 10 
      ZUCD = REAL(I_short) / REAL(I_A_CN) * REAL(I_Z_CN) 
      Z = ZUCD 
C     /' Charge polarisation is here neglected '/ 
      beta1 = Beta(3,1,NINT(Z)) 
      beta2 = Beta(3,2,I_Z_CN-NINT(Z)) 
      Z1 = Z_equi(I_Z_CN,I_short,I_A_CN - I_short,beta1,beta2,dneck,3) 
      Z1 = Z1 + POLARadd 
C     ' Polarization caused by N=50 shell (assumption) 
      Z1 = Z1 - 0.55 * Bell(REAL(I_short)-Z1,45.0,49.5) 
C     '           POLARadd+0.15,POLARfac)   ' Stronger charge polarization in S3,heavy fragment  '!!! KHS 
C     '           POLARadd+0.4,POLARfac)   ' Stronger charge polarization in S3,heavy fragment 
      Zmean(3,1,I_short) = Z1 
      Zshift(3,1,I_short) = Z1 - ZUCD 
      Zmean(3,2,I_A_CN - I_short) = REAL(I_Z_CN) - Z1 
      Zshift(3,2,I_A_CN - I_short) = ZUCD - Z1 
      END DO 
C     ' 
C     /' Mode 4 (Charge polarization of heavy fragment assumed to be equal to light fragment in S2 in the actinides) '/ 
      DO I_short = 10 , I_A_CN - 10 
C     ' Loop is over the "second" (heavy) fragment! 
      ZUCD = REAL(I_short) / REAL(I_A_CN) * REAL(I_Z_CN) 
      Z = ZUCD 
C     /' Charge polarisation is here neglected '/ 
      beta1 = Beta(4,1,NINT(I_Z_CN-Z)) 
C     ' light fragment 
      beta2 = Beta(4,2,NINT(Z)) 
C     ' heavy fragment 
      Z2 = Z_equi(I_Z_CN,I_short,I_A_CN-I_short,beta2,beta1,dneck,4) 
      Z2 = Z2 + POLARadd 
C     ' Polarization caused by N=50 shell (assumption) 
C     '  Z2 = Z2 - 0.55 * Bell(Csng(I_short)-Z1,45.0,49.5) 
C     ' 
      Zmean(4,2,I_short) = Z2 
C     'Print "Z2UCD,Z2",ZUCD,Z2-POLARadd,Z2 
      Zshift(4,2,I_short) = Z2 - ZUCD 
C     ' neutron deficient 
      Zmean(4,1,I_A_CN - I_short) = REAL(I_Z_CN) - Z2 
      Zshift(4,1,I_A_CN - I_short) = ZUCD - Z2 
C     ' neutron rich at shell 
C     ' 
C     /' 
C     '  Print "I","Zshift(2,1,I)",I,Zshift(2,1,I) 
C     '  Print "I","Zshift(2,2,I)",I,Zshift(2,2,I) 
C     '  Print "I","Zshift(4,1,I)",I,Zshift(4,1,I) 
C     '  Print "I","Zshift(4,2,I)",I,Zshift(4,2,I) 
C     Next 
C     Sleep '/ 
C     ' 
      END DO 
C     'Sleep 
C     ' 
C     ' 
C     /' General relations between Z and A of fission channels '/ 
C     ' Mode 0 
      RZpol = 0 
      DO I_short = 1 , 3 
      RA = (ZC_Mode_0 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(0,2,NINT(RA)) 
C     ' heavy fragment 
      END DO 
      AC_Mode_0 = (ZC_Mode_0 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
C     /' mean position in mass '/ 
      NC_Mode_0 = AC_Mode_0 - ZC_Mode_0 
C     ' 
C     ' Mode 1 
      RZpol = 0 
      DO I_short = 1 , 3 
      RA = (ZC_Mode_1 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(1,2,NINT(RA)) 
C     ' heavy fragment 
      END DO 
      AC_Mode_1 = (ZC_Mode_1 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      NC_Mode_1 = AC_Mode_1 - ZC_Mode_1 
C     ' 
C     ' Mode 2 
      RZpol = 0 
      DO I_short = 1 , 3 
      RA = (ZC_Mode_2 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(2,2,NINT(RA)) 
C     ' heavy fragment 
      END DO 
      AC_Mode_2 = (ZC_Mode_2 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      NC_Mode_2 = AC_Mode_2 - ZC_Mode_2 
C     ' 
C     ' Mode 3 
      RZpol = 0 
      DO I_short = 1 , 3 
      RA = (ZC_Mode_3 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(3,2,NINT(RA)) 
C     ' heavy fragment 
      END DO 
      AC_Mode_3 = (ZC_Mode_3 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      NC_Mode_3 = AC_Mode_3 - ZC_Mode_3 
C     ' 
C     ' Mode 4 
      RZpol = 0 
      DO I_short = 1 , 3 
      RA = (ZC_Mode_4 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(4,1,NINT(RA)) 
C     ' light fragment 
      END DO 
      AC_Mode_4 = (ZC_Mode_4 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
C     ' light fragment 
      NC_Mode_4 = AC_Mode_4 - ZC_Mode_4 
C     ' light fragment 
C     ' 
C     /' Potential curvatures of fission modes '/ 
C     ' 
C     ' For the width of the mass distribution (potential between saddle and scission): 
C     ' Print Spin_CN,P_I_rms_CN 
      R_Z_Curv_S0 = 8.E0 / REAL(I_Z_CN)**2 * Masscurv(REAL(I_Z_CN),
     *REAL(I_A_CN),Spin_CN,kappa) 
C     ' For the yields of the fission channels (potential near saddle): 
      R_Z_Curv1_S0 = 8.E0 / REAL(I_Z_CN)**2 * Masscurv1(REAL(I_Z_CN),
     *REAL(I_A_CN),0.0,kappa) 
      R_A_Curv1_S0 = 8.E0 / REAL(I_A_CN)**2 * Masscurv1(REAL(I_Z_CN),
     *REAL(I_A_CN),0.0,kappa) 
C     'Print 5229,"R_A_Curv1_S0",R_A_Curv1_S0 
C     'sleep 
C     ' 
C     /' Energy transformation '/ 
      Select CASE( Emode) 
      CASE( 0) 
C     ' Energy above outer barrier given 
      R_E_exc_Eb = R_E_exc_used 
      R_E_exc_GS = R_E_exc_used + BFTFB(REAL(I_Z_CN),REAL(I_A_CN),1) 
      CASE( 1,3,-1) 
C     ' Energy above ground state given 
      R_E_exc_Eb = R_E_exc_used - BFTFB(REAL(I_Z_CN),REAL(I_A_CN),1) 
      R_E_exc_GS = R_E_exc_used 
      CASE( 2) 
C     ' kinetic energy of neutron given (SN = neutron separation energy) 
C     '    SN = (U_Mass(Csng(I_Z_CN),Csng(I_A_CN-1)) + Lypair(I_Z_CN,I_A_CN-1))       '       -(U_Mass(Csng(I_Z_CN),Csng(I_A_CN)) + Lypair(I_Z_CN,I_A_CN)) 
C     '    R_E_exc_GS = R_E_exc_used + SN 
      SN = AME2012(I_Z_CN,I_A_CN-1) - AME2012(I_Z_CN,I_A_CN) 
      R_E_exc_GS = R_E_exc_used * ((I_A_CN-1) / I_A_CN) + SN 
C     ' 
      R_E_exc_Eb = R_E_exc_GS - BFTFB(REAL(I_Z_CN),REAL(I_A_CN),1) 
      CASE( 12) 
C     ' kinetic energy of proton given (Sprot = proton separation energy) 
C     '    Sprot = (U_Mass(Csng(I_Z_CN-1),Csng(I_A_CN-1)) + Lypair(I_Z_CN-1,I_A_CN-1))       '       -(U_Mass(Csng(I_Z_CN),Csng(I_A_CN)) + Lypair(I_Z_CN,I_A_CN)) 
C     '    R_E_exc_GS = R_E_exc_used + Sprot 
      Sprot = AME2012(I_Z_CN-1,I_A_CN-1) - AME2012(I_Z_CN,I_A_CN) 
      R_E_exc_GS = R_E_exc_used * ((I_A_CN-1) / I_A_CN) + Sprot 
      R_E_exc_Eb = R_E_exc_GS - BFTFB(REAL(I_Z_CN),REAL(I_A_CN),1) 
      CASE( 22) 
C     ' kinetic energy of alpha given (Salpha = alpha separation energy) 
      Salpha = AME2012(I_Z_CN-2,I_A_CN-4) - AME2012(I_Z_CN,I_A_CN) - 
     *28.295 
      R_E_exc_GS = R_E_exc_used * ((I_A_CN-4) / I_A_CN) + Salpha 
      R_E_exc_Eb = R_E_exc_GS - BFTFB(REAL(I_Z_CN),REAL(I_A_CN),1) 
      CASE( 13) 
C     ' list of excitation energies from file 
      R_E_exc_Eb = R_E_exc_used - BFTFB(REAL(I_Z_CN),REAL(I_A_CN),1) 
      R_E_exc_GS = R_E_exc_used 
      End Select 
C     ' 
C     /' Fission barriers -> global parameters '/ 
C     ' 
      B_F = BFTF(REAL(I_Z_CN),REAL(I_A_CN),1) 
      B_F_ld = BFTF(REAL(I_Z_CN),REAL(I_A_CN),0) 
      E_B = BFTFB(REAL(I_Z_CN),REAL(I_A_CN),1) 
      E_B_ld = BFTFB(REAL(I_Z_CN),REAL(I_A_CN),0) 
C     ' 
C     ' 
C     /' Barriers and excitation energies of the fission modes '/ 
C     ' 
      E_exc_S0_prov = R_E_exc_Eb 
C     ' 
C     /' Additional influence of N=82 assumed '/ 
      Delta_NZ_Pol = 82.E0/50.E0 - REAL(I_N_CN)/REAL(I_Z_CN) 
      R_Shell_S1_eff = P_Shell_S1 * (1.0 - P_Att_rel * P_Att_Pol * 
     *Abs(Delta_NZ_Pol)) 
C     ' 
C     '   R_Shell_S1_eff = P_Shell_S1 *  '           max(1.0 - P_att_rel,(1.0 - P_att_rel*  '                   ( Abs(Delta_NZ_Pol)/P_Att_Pol  + (Delta_NZ_Pol/P_Att_Pol2)^2  '                   + Abs(Delta_NZ_Pol/P_Att_Pol3)^3))) 
C     ' Print "4335 "; max(1.0 - P_att_rel,(1.0 - P_att_rel*  '                   ( Abs(Delta_NZ_Pol)/P_Att_Pol  + (Delta_NZ_Pol/P_Att_Pol2)^2  '                   + Abs(Delta_NZ_Pol/P_Att_Pol3)^3))) 
C     ' Print  Abs(Delta_NZ_Pol)/P_Att_Pol,'         (Delta_NZ_Pol/P_Att_Pol2)^2,'        Abs(Delta_NZ_Pol/P_Att_Pol3)^3 
C     'sleep 
C     ' 
C     /' In Pu,the Z=50 shell meets Z=44 in the light fragment. '/ 
C     /' A deformed shell at Z=44 is assumed to explain the enhancement        of the S1 channel around Pu '/ 
C     /' This very same shell automatically produces the double-humped '/ 
C     /' mass distribution in 180Hg '/ 
C     '    S1_enhance = P_Shell_SL4 + '            (Csng(I_Z_CN) - ZC_Mode_1 - ZC_Mode_4L)^2 * P_Z_Curv_SL4 
C     ' 50 instead of ZC_Mode_1,to eliminate the influenc of the mass 
C     '(in agreement with experiment,e.g. 238U(nfast,f) ): 
      S1_enhance = P_Shell_SL4 + (REAL(I_Z_CN) - 50.0 - ZC_Mode_4L)**2 
     ** P_Z_Curv_SL4 
C     ' 
C     '   S1_enhance = P_Shell_SL4 *  '       U_Gauss_abs(Csng(I_Z_CN) - 50.0 - 0.3 - ZC_Mode_4L,P_Z_Sigma_SL4) 
C     'Print "4396: U_Gauss_abs";S1_enhance/P_Shell_SL4,R_SHell_S1_eff 
C     'sleep 
C     ' 
C     '   S1_enhance = P_Shell_SL4 +  '           (Csng(I_Z_CN) - ZC_Mode_1 - ZC_Mode_4L)^2 * P_Z_Curv_SL4 
      IF (  S1_enhance .GT. 0  )  S1_enhance = 0 
C     ' 
      IF (  P_Z_CN .EQ. 91  )  S1_enhance = S1_enhance + 0.3 
      IF (  P_Z_CN .EQ. 90  )  S1_enhance = S1_enhance + 0.6 
C     ' 
C     'Print "4384 "; P_Shell_SL4,U_Gauss(Csng(I_Z_CN) - 50.0 - ZC_Mode_4L,0.3),S1_enhance 
C     'sleep 
C     ' 
C     ' Print "3933" 
C     ' Print "ZC_Mode_1,ZC_Mode_4",ZC_Mode_1,ZC_Mode_4 
C     ' Print "Delta-Z S1-S4,S1_enhance",I_Z_CN-ZC_Mode_1 - ZC_Mode_4L,S1_enhance 
C     ' Print "3951" 
      R_Shell_S1_eff = R_Shell_S1_eff + S1_enhance 
C     ' Print I_Z_CN-ZC_Mode_1-ZC_Mode_4L,S1_enhance,R_Shell_S1_eff 
C     ' 
C     /' The high TKE of S1 in 242Pu(sf) (and neighbours) is obtained by assuming '/ 
C     /' that the Z=44 shell reduces the deformation of the light fragment. '/ 
      DO I = 10 , I_Z_CN - 10 
      Z1 = REAL(I) 
      A1 = (Z1 - 0.5E0) / REAL(I_Z_CN) * REAL(I_A_CN) 
C     /' polarization roughly considered '/ 
C     '    Beta(1,1,Z1) = Beta(1,1,Z1) + 0.15 * S1_enhance   /' "light" fragment '/ 
      Beta(1,1,I) = exp(S1_enhance) * Beta(1,1,I) + 
     *(1.E0-exp(S1_enhance)) * (Beta(1,1,I)-0.25) 
      Beta(1,1,I) = Max(Beta(1,1,I),0.0) 
      E_defo = Lymass(Z1,A1,Beta(1,1,I)) - Lymass(Z1,A1,0.0) 
      Edefo(1,1,I) = E_defo 
C     /' "light" fragment '/ 
      END DO 
C     ' 
C     ' Influence of S2 shell in complementary fragment 
C     ' May be called "S12 fission channel" 
      T_Asym_Mode_2 = 0.5 
      SigZ_Mode_2 = SQRT(0.5E0 * T_Asym_Mode_2/(P_Z_Curv_S2)) 
      SigA_Mode_2 = SigZ_Mode_2 * REAL(I_A_CN) / REAL(I_Z_CN) 
      S1_enhance_S2 = P_Shell_S2 * U_Box(REAL(P_A_CN) - AC_Mode_2 - 
     *AC_Mode_1,SigA_Mode_2,P_A_Width_S2) *P_A_Width_S2 
C     ' 
      IF (  S1_enhance_S2 .LT. 0.01  ) THEN 
C     '  Print "S1_enhance_S2 ";S1_enhance_S2 
      R_Shell_S1_eff = R_Shell_S1_eff + S1_enhance_S2 
      End If 
C     ' 
      R_Shell_S2_eff = P_Shell_S2 
C     ' 
C     ' Overlap of S3 and shell in light fragment 
      R_Shell_S3_eff = P_Shell_S3 * (1.0 - 0.8* PZ_S3_olap_curv         
     * * (REAL(I_Z_CN) - ZC_Mode_3 - PZ_S3_olap_pos)**2) 
C     '  Print "4450 "; P_Shell_S3 * (1.0 - 0.8 * PZ_S3_olap_curv '         * (Csng(I_Z_CN) - ZC_Mode_3 - PZ_S3_olap_pos)^2),ZC_Mode_3 
C     '  sleep 
C     '  R_Shell_S3_eff = -5.605 
C     '        * (Csng(I_Z_CN) - 60.5E0 - PZ_S3_olap_pos)^2) 
      R_Shell_S3_eff = Min(R_Shell_S3_eff,0.0) 
C     ' 
C     ' Additional empirical dependence on N/Z 
C     ' R_Shell_S3_eff = R_Shell_S3_eff - '       1 * ( (I_A_CN-I_Z_CN)/I_Z_CN - (236-92)/92) 
C     '       5 * ( (I_A_CN-I_Z_CN)/I_Z_CN - (236-92)/92) 
C     ' 
      R_Shell_S4_eff = 2.0 * (P_Shell_S4 + P_Z_Curv_S4 * (ZC_Mode_4 - 
     *ZC_Mode_0)**2) 
C     ' overlap of S4 in both fragments 
      IF (  R_Shell_S4_eff .GT. P_Shell_S4  )  R_Shell_S4_eff = 
     *P_Shell_S4 
C     ' no overlap at large distance 
C     ' 
      E_ld_S1 = R_A_Curv1_S0 * (REAL(I_A_CN)/REAL(I_Z_CN)*(ZC_MODE_1 - 
     *ZC_MODE_0) )**2 
      B_S1 = E_ld_S1 + R_Shell_S1_eff 
      E_exc_S1_prov = E_Exc_S0_prov - B_S1 
C     'Print 5384,"E_ld_S1,R_Shell_S1_eff,B_S1",E_ld_S1,R_Shell_S1_eff,B_S1 
C     'Print 5385,"R_A_Curv1_S0",R_A_Curv1_S0 
C     'Sleep 
C     ' 
      E_ld_S2 = R_A_Curv1_S0 * (REAL(I_A_CN)/REAL(I_Z_CN)*(ZC_MODE_2 - 
     *ZC_MODE_0) )**2 
      B_S2 = E_ld_S2 + R_Shell_S2_eff 
      E_exc_S2_prov = E_Exc_S0_prov - B_S2 
C     ' 
      E_ld_S3 = R_A_Curv1_S0 * (REAL(I_A_CN)/REAL(I_Z_CN)*(ZC_MODE_3 - 
     *ZC_MODE_0) )**2 
      B_S3 = E_ld_S3 + R_Shell_S3_eff 
      E_exc_S3_prov = E_Exc_S0_prov - B_S3 
C     ' 
C     ' 
      IF (  I_A_CN .LT. 220  ) THEN 
C     ' Only here S4 is close enough to symmetry to have a chance 
      E_ld_S4 = R_A_Curv1_S0 * (REAL(I_A_CN)/REAL(I_Z_CN)*(ZC_MODE_4 - 
     *ZC_MODE_0) )**2 
C     ' 
      R_Shell_S4_eff = R_Shell_S4_eff * (1.0 + P_S4_mod * 
     *(REAL(I_A_CN-I_Z_CN) - (112)) ) 
C     ' variation with N 
C     ' 
      B_S4 = E_ld_S4 + R_Shell_S4_eff 
      E_exc_S4_prov = E_Exc_S0_prov - B_S4 
      Else 
      B_S4 = 9999 
      E_exc_S4_prov = - 9999 
      End If 
C     ' 
C     ' 
C     /' Mode 11 (overlap of channel 1 in light and heavy fragment '/ 
C     /' Potential depth with respect to liquid-drop potential: B_S11 '/ 
C     '    B_S11 = 2.E0 * (R_Shell_S1_eff + De_Defo_S1 '             + P_Z_Curv_S1 * (ZC_Mode_1 - ZC_Mode_0)^2 ) - De_Defo_S1 
      B_S11 = 2.E0 * (R_Shell_S1_eff               + P_Z_Curv_S1 * 
     *(ZC_Mode_1 - ZC_Mode_0)**2 ) 
C     ' Sum of S1 shells in both fragments exact at symmetry 
C     ' 
C     ' Print "5421 ";R_Shell_S1_eff,B_S11 
C     ' Print ZC_Mode_0,ZC_Mode_1,P_Z_Curv_S1 * (ZC_Mode_1 - ZC_Mode_0)^2 
C     ' sleep 
C     ' 
C     ' If B_S11 (see above) is higher than the shell at symmetry from only one fragment 
C     '  If B_S11 > R_Shell_S1_eff + P_Z_Curv_S1 * (ZC_Mode_1 - ZC_Mode_0)^2 Then 
C     '    B_S11 = Min(B_S11,R_Shell_S1_eff + P_Z_Curv_S1 * (ZC_Mode_1 - ZC_Mode_0)^2 ) 
C     '  End If 
C     ' 
      DES11ZPM = 0 
C     ' The S1 shells in the two fragments must be rather close to form  one pocket: 
      IF (  B_S11 .LT. R_Shell_S1_eff + Level_S11  ) THEN 
C     ' Lowering of the zero-point motion grows with the width of the potential pocket: 
C     '      DES11ZPM = -0.8 * Abs(ZC_Mode_1 - ZC_Mode_0)  ' Fits the mass distr. of 258Fm(sf) 
      DES11ZPM = -1.45 * Abs(ZC_Mode_1 - ZC_Mode_0) 
C     ' Fits the mass distr. of 258Fm(sf) 
      End If 
C     ' 
C     'Print 5699,"B_S2; B_S11; R_Shell_S1_eff; Level_S11"; B_S2; B_S11; R_Shell_S1_eff; Level_S11 
C     'Print 5699,R_Shell_S1_eff + Level_S11; DES11ZPM 
C     'Print  "ZC_Mode_1,ZC_Mode_0";ZC_Mode_1; ZC_Mode_0 
C     ' 
C     /' Lowering of effective barrier by lower ZPM due to larger width in 
C     partial overlap region (shells in light and heavy fragment) '/ 
C     '   DES11ZPM = Level_S11 * Min(Abs(ZC_Mode_1 - ZC_Mode_0),4.E0*P_Z_Curv_S1) 
C     '   DES11ZPM = -0.2 * Abs(ZC_Mode_1 - ZC_Mode_0) 
C     ' 
C     ' Print "4473: "; R_Shell_S1_eff,B_S11,DES11ZPM 
C     ' Sleep 
C     ' 
      B_S11 = B_S11 + DES11ZPM 
C     'Print "B_S2;B_S11";B_S2;B_S11 
C     ' 
C     ' 
C     '  If B_S11 > R_Shell_S1_eff + 0.5E0 Then 
C     '   If B_S11 > R_Shell_S1_eff + Level_S11 Then 
C     '     B_S11 = 100   ' S1 and S11 are exclusive 
C     '   Else 
C     '     B_S11 = Min(B_S11,R_Shell_S1_eff) 
C     '   End If 
C     ' 
C     ' 
      E_exc_S11_prov = E_Exc_S0_prov - B_S11 
C     ' 
C     'Print "5725,E_exc_S11_prov",E_exc_S11_prov 
C     'Print "E_exc_S2_prov",E_exc_S2_prov 
C     'Print "E_exc_S3_prov",E_exc_S3_prov 
C     ' 
C     ' 
C     /' Mode 22 (overlap of channel 2 in light and heavy fragment '/ 
C     /' Potential depth with respect to liquid-drop potential: B_S22 '/ 
C     ' 
C     '   B_S22 = 2.E0 * (E_ld_S2 + P_Shell_S2)  '       + 2.E0 * P_Z_Curv_S2 * (ZC_Mode_2 - ZC_Mode_0)^2   /' Parabola '/ 
C     'Print E_ld_S2,P_Shell_S2,P_Z_Curv_S2,ZC_Mode_2,ZC_Mode_0 
      B_S22 = 2.E0 * R_Shell_S2_eff * U_Box(REAL(I_A_CN)/2.0 - 
     *AC_Mode_2,SigA_Mode_2,P_A_Width_S2) * P_A_Width_S2 
C     ' The integral of U_Box is normalized,not the height! 
C     '    If Abs((P_A_CN/2.E0) - AC_Mode_2) > P_A_Width_S2 Then B_S22 = 9999 
      IF (  I_A_CN .LT. 226  )  B_S22 = 9999 
C     ' 
      E_exc_S22_prov = E_Exc_S0_prov - B_S22 
C     ' 
      E_Min_Barr = Min(0.0,B_S1) 
      E_Min_Barr = Min(E_Min_Barr,B_S2) 
      E_Min_Barr = Min(E_Min_Barr,B_S3) 
      E_Min_Barr = Min(E_Min_Barr,B_S4) 
      E_Min_Barr = Min(E_Min_Barr,B_S11) 
      E_Min_Barr = Min(E_Min_Barr,B_S22) 
C     'Print 5473,"B_S1 ... B_S22",B_S1,B_S2,B_S3,B_S4,B_S11,B_S22 
C     'sleep 
C     ' 
C     /' Energy minus the height of the respective fission saddle '/ 
      E_exc_S0 = E_exc_S0_prov + E_Min_Barr - Delta_S0 
C     'Print 5403,"E_exc_S0_prov,E_Min_Barr,Delta_S0",E_exc_S0_prov,E_Min_Barr,Delta_S0 
C     'sleep 
      E_exc_S1 = E_exc_S1_prov + E_Min_Barr 
      E_exc_S2 = E_exc_S2_prov + E_Min_Barr 
      E_exc_S3 = E_exc_S3_prov + E_Min_Barr 
      E_exc_S4 = E_exc_S4_prov + E_Min_Barr 
      E_exc_S11 = E_exc_S11_prov + E_Min_Barr 
      E_exc_S22 = E_exc_S22_prov + E_Min_Barr 
C     ' 
C     'Print 5765,"E_exc_S1"; E_exc_S1 
C     'Print 5765,E_exc_S2 
C     'Print 5765,E_exc_S3 
C     'Print 5765,E_exc_S4 
C     'Print 5765,E_exc_S11 
C     'Print 5765,"E_exc_S22"; E_exc_S22 
C     ' 
C     /' Energy above the lowest fission saddle '/ 
      E_exc_Barr = Max(E_Exc_S0,E_Exc_S1) 
      E_exc_Barr = Max(E_exc_Barr,E_Exc_S2) 
      E_exc_Barr = Max(E_exc_Barr,E_Exc_S3) 
      E_exc_Barr = Max(E_exc_Barr,E_Exc_S4) 
      E_exc_Barr = Max(E_exc_Barr,E_exc_S11) 
      E_exc_Barr = Max(E_exc_Barr,E_exc_S22) 
C     ' 
C     ' 
C     /' Collective temperature used for calculating the widths 
C     in mass asymmetry and charge polarization '/ 
C     ' 
      IF (  E_Exc_S0 .LT. 0  ) THEN 
      E_tunn = -E_Exc_S0
      Else
      E_tunn = 0
      END IF
      R_E_exc_eff = Max(0.1,E_Exc_S0) 
C     '  T_Coll_Mode_0 = TFCOLL * R_E_exc_eff + _  /' empirical,replaced by TRusanov '/ 
      T_Coll_Mode_0 = TCOLLFRAC * (De_Saddle_Scission(REAL(I_Z_CN),
     *REAL(I_A_CN),ESHIFTSASCI_coll) - E_tunn) 
      T_Coll_Mode_0 = Max(T_Coll_Mode_0,0.0) 
C     ' 
C     'Print "5502: De_SS,E_tunn,T_Coll ";De_Saddle_Scission(I_Z_CN^2/I_A_CN^0.3333,ESHIFTSASCI_coll),E_tunn,T_Coll_Mode_0 
C     'Sleep 
C     ' 
C     /' Temperature description fitting to the empirical systematics of Rusanov et al. '/ 
C     /' Here from Ye. N. Gruzintsev et al.,Z. Phys. A 323 (1986) 307 '/ 
C     /' Empirical description of the nuclear temperature according to the '/ 
C     /' Fermi-gas description. Should be valid at higher excitation energies '/ 
      T_Rusanov = TRusanov(R_E_exc_eff,REAL(I_A_CN)) 
C     'Print "Temperatures,(GEF,Total,Rusanov): ",T_Coll_Mode_0,TFCOLL * R_E_exc_eff,T_Rusanov 
C     'Print "R_E_exc_eff ",R_E_exc_eff 
C     ' 
      T_Coll_Mode_0 = Max(T_Coll_Mode_0,T_Rusanov) 
C     /' Transition vom const. temp. to Fermi gas occurs around 20 MeV by MAX function '/ 
C     '    T_Pol_Mode_0 = T_Pol_Red * T_Coll_Mode_0 
C     ' 
C     ' Application of the statistical model,intrinsic temperature at saddle 
      T_Pol_Mode_0 = U_Temp(0.5 * REAL(I_Z_CN),0.5 *REAL(I_A_CN),
     *R_E_exc_eff,0,0,Tscale,Econd,Etrans) 
C     '    T_Asym_Mode_0 = Sqr(T_Coll_Mode_0^2 + (6E0*TCOLLMIN)^2) 
      T_Asym_Mode_0 = SQRT(T_Coll_Mode_0**2 + (1.0*TCOLLMIN)**2) 
C     'Print "4124: T_Coll_Mode_0,TCOLLMIN"; T_Coll_Mode_0,TCOLLMIN 
C     'sleep 
C     ' 
      E_pot_scission = (De_Saddle_Scission(REAL(I_Z_CN),REAL(I_A_CN),
     *ESHIFTSASCI_intr) - E_tunn) + Epot_shift 
      E_diss_Scission = EDISSFRAC * E_pot_scission 
C     'Print "4054:";EDISSFRAC,E_pot_scission,E_diss_Scission 
C     ' 
C     /' Suppression of S1 fission channel at very low excitation energy at scission '/ 
C     /' The idea behind is that the binding energy at scission is such that the 
C     scission configuration cannot be reached with the available excitation energy. '/ 
C     '   EeffS1 = Max(E_exc_S1,0.0) + EDISSFRAC * E_pot_scission 
C     '   EeffS1 = Max(0.0,EeffS1) 
C     ' 
C     ' Print "4104",U_Mass(I_Z_CN,I_A_CN); '       2 * U_Mass(I_Z_CN/2.0,I_A_CN/2.0) + 1.44*(I_Z_CN/2.0)^2 / '               (1.5 * ( (I_A_CN/2)^0.333333 + (I_A_CN/2)^0.333333) + dneck ); EeffS1,'        - 2 * U_Mass(I_Z_CN/2.0,I_A_CN/2.0) - 1.44*(I_Z_CN/2.0)^2 / '               (1.5 * ( (I_A_CN/2)^0.333333 + (I_A_CN/2)^0.333333) + dneck ) + '         + Max(E_exc_S1,0.0) + EDISSFRAC * E_pot_scission '         + U_Mass(I_Z_CN,I_A_CN) 
C     '   EeffS1 = - 2 * U_Mass(I_Z_CN/2.0,I_A_CN/2.0) - 1.44*(I_Z_CN/2.0)^2 /  '              (1.6 * ( (I_A_CN/2)^0.333333 + (I_A_CN/2)^0.333333) + dneck ) +  '          Max(E_exc_S1,0.0) + EDISSFRAC * E_pot_scission  '        + U_Mass(I_Z_CN,I_A_CN) 
C     '   If EeffS1 < ETHRESHSUPPS1 Then 
C     '                + 2.E0 * ESIGSUPPS1 Then 
C     '     E_exc_S1 = E_exc_S1 + EeffS1 - ETHRESHSUPPS1 
C     '        0.5E0 * 1.5 * 12.E0 / Sqr(132.E0) * Gaussintegral(ETHRESHSUPPS1 - EeffS1,ESIGSUPPS1) 
C     ''         0.5E0 * 4.E0 * 12.E0 / Sqr(132.E0) * Gaussintegral(ETHRESHSUPPS1 - EeffS1,ESIGSUPPS1) 
C     '   End If 
C     '   If EeffS2 < ETHRESHSUPPS1 + 2.E0 * ESIGSUPPS1 Then 
C     '     E_exc_S1 = E_exc_S1 -  '        0.5E0 * 1.5 * 12.E0 / Sqr(132.E0) * Gaussintegral(ETHRESHSUPPS1 - EeffS2,ESIGSUPPS1) 
C     '        0.5E0 * 4.E0 * 12.E0 / Sqr(132.E0) * Gaussintegral(ETHRESHSUPPS1 - EeffS2,ESIGSUPPS1) 
C     '   EndIf 
C     ' 
      T_low_S1_used = T_low_S1 
C     ' 
      T_Coll_Mode_1 = TFCOLL * Max(E_exc_S1,0.E0) + TCOLLFRAC * 
     *(De_Saddle_Scission(REAL(I_Z_CN),REAL(I_A_CN),ESHIFTSASCI_coll) - 
     *E_tunn) 
      T_Coll_Mode_1 = Max(T_Coll_mode_1,0.0) 
C     '    T_Pol_Mode_1 = T_Pol_Red * T_Coll_Mode_1 
      T_Pol_Mode_1 = T_Pol_Mode_0 
      T_Asym_Mode_1 = SQRT(T_Coll_Mode_1**2 + (4.0*TCOLLMIN)**2) 
C     ' TCOLLMIN for ZPM 
C     ' 
      T_Coll_Mode_2 = TFCOLL * Max(E_exc_S2,0.E0) + TCOLLFRAC * 
     *(De_Saddle_Scission(REAL(I_Z_CN),REAL(I_A_CN),ESHIFTSASCI_coll) - 
     *E_tunn) 
      T_Coll_Mode_2 = Max(T_Coll_mode_2,0.0) 
C     '    T_Pol_Mode_2 = T_Pol_Red * T_Coll_Mode_2 
      T_Pol_Mode_2 = T_Pol_Mode_0 
C     '    T_Asym_Mode_2 = Sqr(T_Coll_Mode_2^2 + TCOLLMIN^2) 
      T_Asym_Mode_2 = SQRT(T_Coll_Mode_2**2 + 4*TCOLLMIN**2) 
C     ' 
C     '    Dim As Single T_Asym_Mode_2_dyn  ' Collective dynamical effect ? 
C     '    T_Asym_Mode_2_dyn = 0.009 * (I_Z_CN^2/(I_A_CN^0.333333) - 92.0^2/(238^0.333333) ) 
C     '    T_Asym_Mode_2 = Sqr(T_Asym_Mode_2^2 + T_Asym_Mode_2_dyn^2) 
C     ' 
C     /'    T_Coll_Mode_3 = TFCOLL * Max(E_exc_S3,0.E0) +           TCOLLFRAC * (De_Saddle_Scission(Csng(I_Z_CN),Csng(I_A_CN),ESHIFTSASCI_coll) - E_tunn) 
C     'Print 4954,TFCOLL * Max(E_exc_S3,0.E0),TCOLLFRAC * (De_Saddle_Scission(Csng(I_Z_CN),Csng(I_A_CN),ESHIFTSASCI_coll) - E_tunn),TCOLLFRAC * (De_Saddle_Scission(Csng(I_Z_CN),Csng(I_A_CN),ESHIFTSASCI_coll) ),E_exc_S3,TCOLLFRAC * 0.03 * (De_Saddle_Scission(Csng(I_Z_CN),Csng(I_A_CN),ESHIFTSASCI_coll) )^2 
C     sleep '/ 
C     'T_coll_Mode_3 = 0.2     ' for 239Pu(nth,f) 
C     'T_coll_Mode_3 = 0.7     ' for 252Cf(sf) 
C     ' Fit to 239Pu(nth,f) and 252Cf(sf) ( unexpectedly large variation with Z^2/A^(1/3) ) 
      T_Coll_Mode_3 = TFCOLL * Max(E_exc_S3,0.E0) + TCOLLFRAC * 0.03 * 
     *(De_Saddle_Scission(REAL(I_Z_CN),REAL(I_A_CN),ESHIFTSASCI_coll) 
     *)**2 
      T_Coll_Mode_3 = Max(T_Coll_mode_3,0.0) 
C     '    T_Pol_Mode_3 = T_Pol_Red * T_Coll_Mode_3 
      T_Pol_Mode_3 = T_Pol_Mode_0 
      T_Asym_Mode_3 = SQRT(T_Coll_Mode_3**2 + TCOLLMIN**2) 
C     '!!! 
C     '    Dim As Single T_Asym_Mode_3_dyn 
C     ' Adjusted to the width of Mode 3 in 252Cf(sf) 
C     ' May be,this is a collective dynamic effect along the fission path 
C     '    T_Asym_Mode_3_dyn = 0.009 * (I_Z_CN^2/(I_A_CN^0.333333) - 92.0^2/(238^0.333333) ) 
C     ' T_Asym_Mode_3_dyn = 0 
C     '    T_Asym_Mode_3 = Max(T_Asym_Mode_3,T_Asym_Mode_3_dyn) 
C     '    T_Asym_Mode_3 = Sqr(T_Asym_Mode_3^2 + T_Asym_Mode_3_dyn^2) 
C     ' 
C     'Print "4619: ";T_Coll_Mode_3,TCOLLMIN,T_Asym_Mode_3 
C     'sleep 
C     ' 
      T_Coll_Mode_4 = TFCOLL * Max(E_exc_S4,0.E0) + TCOLLFRAC * 
     *(De_Saddle_Scission(REAL(I_Z_CN),REAL(I_A_CN),ESHIFTSASCI_coll) - 
     *E_tunn) 
      T_Coll_Mode_4 = Max(T_Coll_mode_4,0.0) 
C     '    T_Pol_Mode_4 = T_Pol_Red * T_Coll_Mode_4 
      T_Pol_Mode_4 = T_Pol_Mode_0 
      T_Asym_Mode_4 = SQRT(T_Coll_Mode_4**2 + 4.0*TCOLLMIN**2) 
C     ' ZPM like S1 
C     ' 
C     /' Stiffness in polarization '/ 
C     ' 
      RZ = REAL(I_Z_CN) * 0.5E0 
      RA = REAL(I_A_CN) * 0.5E0 
      beta1 = Beta(0,1,NINT(RZ)) 
      beta2 = Beta(0,2,NINT(RZ)) 
      R_Pol_Curv_S0 = ( LyMass( RZ - 1.E0,RA,beta1 ) +              
     *LyMass( RZ + 1.0E0,RA,beta2 ) +              LyMass( RZ + 1.0E0,
     *RA,beta1 ) +              LyMass( RZ - 1.0E0,RA,beta2 ) +         
     *     ecoul( RZ - 1.0E0,RA,beta1,RZ + 1.0E0,RA,beta2,dneck) +      
     *        ecoul( RZ + 1.0E0,RA,beta1,RZ - 1.0E0,RA,beta2,dneck) -   
     *       2.0E0*ecoul( RZ,RA,beta1,RZ,RA,beta2,dneck) -          
     *2.0E0*LyMass( RZ,RA,beta1 ) -          2.0E0*LyMass( RZ,RA,beta2) 
     *) * 0.5E0 
C     ' 
      P_Pol_Curv_S0 = R_Pol_Curv_S0 
C     ' 
C     ' Assumption: stiffenss is dominated (and thus well represented) by the macroscopic potential 
      R_Pol_Curv_S1 = R_Pol_Curv_S0 
      R_Pol_Curv_S2 = R_Pol_Curv_S0 
      R_Pol_Curv_S3 = R_Pol_Curv_S0 
      R_Pol_Curv_S4 = R_Pol_Curv_S0 
C     ' 
C     ' 
C     ' 
C     /' Mean values and standard deviations of fission modes '/ 
C     ' 
      SIGZ_Mode_0 = SQRT(0.5E0 * T_Asym_Mode_0/R_Z_Curv_S0) 
C     'Print "5455: SIGZ_Mode_0,T_Asym_Mode_0,R_Z_Curv_S0)";SigZ_Mode_0,T_Asym_Mode_0,R_Z_Curv_S0 
C     'sleep 
C     ' 
      IF (  T_Pol_Mode_0 .GT. 1.E-2  ) THEN 
      SigPol_Mode_0 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S0 /            
     *          Tanh(HOMPOL/(2.E0 * T_Pol_Mode_0))) 
      Else 
      SigPol_Mode_0 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S0) 
C     /' including influence of zero-point motion '/ 
      END IF 
C     ' 
      R_E_intr_S1 = Max(E_Exc_S1+Lypair(I_Z_CN,I_A_CN),0.0) 
      R_Att(1) = exp(-R_E_intr_S1/Shell_fading) 
      R_Att(5) = R_Att(1) 
      R_Att_Sad(1) = exp(-R_E_intr_S1/Shell_fading) 
      R_Att_Sad(5) = R_Att_Sad(1) 
      SIGZ_Mode_1 = SQRT(0.5E0 * 
     *T_Asym_Mode_1/(P_Z_Curv_S1*SQRT(R_Att(1)))) 
      IF (  T_Pol_Mode_1 .GT. 1.E-2  ) THEN 
      SigPol_Mode_1 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S1 /            
     *          Tanh(HOMPOL/(2.E0 * T_Pol_Mode_1))) 
      Else 
      SigPol_Mode_1 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S1) 
      END IF 
C     ' 
      R_E_intr_S2 = Max(E_Exc_S2+Lypair(I_Z_CN,I_A_CN),0.0) 
      R_Att(2) = exp(-R_E_intr_S2/Shell_fading) 
      R_Att(6) = R_Att(2) 
      R_Att_Sad(2) = exp(-R_E_intr_S2/Shell_fading) 
      R_Att_Sad(6) = R_Att_Sad(2) 
      SIGZ_Mode_2 = SQRT(0.5E0 * 
     *T_Asym_Mode_2/(P_Z_Curv_S2*SQRT(R_Att(2)))) 
C     ' 
      SIGZ_SL4 = SQRT(0.5E0 * 
     *T_Asym_Mode_2/(P_Z_Curv_SL4*SQRT(R_Att(2)))) 
C     ' 
      IF (  T_Pol_Mode_2 .GT. 1.E-2  ) THEN 
      SigPol_Mode_2 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S2 /            
     *          Tanh(HOMPOL/(2.E0 * T_Pol_Mode_2))) 
      Else 
      SigPol_Mode_2 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S2) 
      End If 
C     ' 
      R_E_intr_S3 = Max(E_exc_S3+Lypair(I_Z_CN,I_A_CN),0.0) 
      R_Att(3) = exp(-R_E_intr_S3/Shell_fading) 
      R_Att_Sad(3) = exp(-R_E_intr_S3/Shell_fading) 
      SIGZ_Mode_3 = SQRT(0.5E0 * 
     *T_Asym_Mode_3/(P_Z_Curv_S3*SQRT(R_Att(3)))) 
      IF (  T_Pol_Mode_3 .GT. 1.E-2  ) THEN 
      SigPol_Mode_3 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S3 /            
     *          Tanh(HOMPOL/(2.E0 * T_Pol_Mode_3))) 
      Else 
      SigPol_Mode_3 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S3) 
      End if 
C     ' 
      R_E_intr_S4 = Max(E_exc_S4+Lypair(I_Z_CN,I_A_CN),0.0) 
      R_Att(4) = exp(-R_E_intr_S4/Shell_fading) 
      R_Att_Sad(4) = exp(-R_E_intr_S4/Shell_fading) 
      SIGZ_Mode_4 = SQRT(0.5E0 * 
     *T_Asym_Mode_4/(P_Z_Curv_S4*SQRT(R_Att(4)))) 
      IF (  T_Pol_Mode_4 .GT. 1.E-2  ) THEN 
      SigPol_Mode_4 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S4 /            
     *          Tanh(HOMPOL/(2.E0 * T_Pol_Mode_4))) 
      Else 
      SigPol_Mode_4 = SQRT(0.25E0 * HOMPOL / R_Pol_Curv_S4) 
      End if 
C     ' 
C     ' 
C     ' 
C     /' Energy-dependent shift of fission channels '/ 
C     '    Scope 
      P_Z_Curv_S1_eff = P_Z_Curv_S1 * P_Z_Curvmod_S1 
      P_Z_Curv_S2_eff = P_Z_Curv_S2 * P_Z_Curvmod_S2 
      P_Z_Curv_S3_eff = P_Z_Curv_S3 * P_Z_Curvmod_S3 
      P_Z_Curv_S4_eff = P_Z_Curv_S4 * P_Z_Curvmod_S4 
C     ' 
      DZ_S1 = ZC_Mode_1 * (P_Z_Curv_S1_eff*R_Att(1) / (R_Z_Curv_S0 + 
     *P_Z_Curv_S1_eff*R_Att(1))             - (P_Z_Curv_S1_eff / 
     *(R_Z_Curv_S0 + P_Z_Curv_S1_eff) ) ) 
      DZ_S2 = ZC_Mode_2 * (P_Z_Curv_S2_eff*R_Att(2) / (R_Z_Curv_S0 + 
     *P_Z_Curv_S2_eff*R_Att(2))              - (P_Z_Curv_S2_eff / 
     *(R_Z_Curv_S0 + P_Z_Curv_S2_eff) ) ) 
      DZ_S3 = ZC_Mode_3 * (P_Z_Curv_S3_eff*R_Att(3) / (R_Z_Curv_S0 + 
     *P_Z_Curv_S3_eff*R_Att(3))              - (P_Z_Curv_S3_eff / 
     *(R_Z_Curv_S0 + P_Z_Curv_S3_eff) ) ) 
      DZ_S4 = SIGN(1.0,ZC_Mode_4 - ZC_Mode_0) * ZC_Mode_4 * 
     *(P_Z_Curv_S4_eff*R_Att(4) / (R_Z_Curv_S0 + 
     *P_Z_Curv_S4_eff*R_Att(4))              - (P_Z_Curv_S4_eff / 
     *(R_Z_Curv_S0 + P_Z_Curv_S4_eff) ) ) 
C     ' 
C     ' Empirical shift of S2 channel at low excitation energy at scission 
C     ' for better reproduction of 238U(s,f) and some data for Th isotopes. 
C     ' Does not solve the problem of 229Th(nth,f). 
C     '   EtotS2 = Max(E_Exc_S2 + E_diss_Scission,0.0) 
C     '   If EtotS2 < 5.E0 Then 
C     '     DZ_S2 = DZ_S2 + (5.E0 - EtotS2) * 0.1 
C     '   End If 
C     ' 
C     '   DZ_S1 = 0 
C     '   DZ_S2 = 0 
C     '   DZ_S3 = 0 
C     '   DZ_S4 = 0 
C     ' 
      P_Z_Mean_S0 = ZC_Mode_0 
      ZC_Mode_1 = ZC_Mode_1 + DZ_S1 
      P_Z_Mean_S1 = ZC_Mode_1 
C     /' Copy to global parameter '/ 
      ZC_Mode_2 = ZC_Mode_2 + DZ_S2 
      P_Z_Mean_S2 = ZC_Mode_2 
C     /'             "            '/ 
      ZC_Mode_3 = ZC_Mode_3 + DZ_S3 
      P_Z_Mean_S3 = ZC_Mode_3 
C     '   ZC_Mode_4 = ZC_Mode_4 + DZ_S4 
C     ' shift is very small,because S4 exists only close to symmetry 
      P_Z_Mean_S4 = ZC_Mode_4 
C     '    End Scope 
C     ' 
C     ' 
C     /' Energy dependence of charge polarization '/ 
C     /' Due to washing out of shells '/ 
C     ' 
      DO I = 10 , I_A_CN - 10 
C     ' mass number 
      DO J = 1 , 4 
C     ' fission channel 
      DO K = 1 , 2 
C     ' light - heavy group 
      Zshift(J,K,I) = Zshift(0,K,I) + (Zshift(J,K,I) - Zshift(0,K,
     *I))*R_Att(J) 
      END DO 
      END DO 
      END DO 
C     ' 
C     ' 
C     /' Energy dependence of shell-induced deformation '/ 
C     /' Due to washing out of shells '/ 
C     /' (Under development) '/ 
C     /'For I = 10 To I_Z_CN - 10  ' mass number 
C     For J = 1 To 4           ' fission channel 
C     For K = 1 To 2         ' light - heavy group 
C     beta(J,K,I) = beta(0,K,I) + (beta(J,K,I) - beta(0,K,I))*R_Att_Sad(J) 
C     if beta(J,K,I) < 0 Then 
C     beta(J,K,I) = 0 
C     End If 
C     Z1 = I 
C     Z2 = I_Z_CN - Z1 
C     A1 = Z1 / Csng(I_Z_CN) * Csng(I_A_CN) 
C     A2 = I_A_CN - A1 
C     E_defo = Lymass(Z1,A1,beta(J,K,I)) - Lymass(Z1,A1,0.0) 
C     Edefo(J,K,I) = E_defo 
C     Next 
C     Next 
C     Next  '/ 
C     ' 
C     ' 
C     ' 
C     ' 
C     /' General relations between Z and A of fission channels '/ 
C     /' 2nd iteration '/ 
C     ' 
      RZpol = 0 
C     ' calculations for the heavy fragment 
      DO I = 1 , 3 
      RA = (ZC_Mode_0 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(0,2,NINT(RA)) 
      END DO 
      AC_Mode_0 = (ZC_Mode_0 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
C     /' mean position in mass '/ 
      NC_Mode_0 = AC_Mode_0 - ZC_Mode_0 
C     ' 
      RZpol = 0 
C     ' calculations for the heavy fragment 
      DO I = 1 , 3 
      RA = (ZC_Mode_1 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(1,2,NINT(RA)) 
      END DO 
      AC_Mode_1 = (ZC_Mode_1 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      NC_Mode_1 = AC_Mode_1 - ZC_Mode_1 
C     ' 
      RZpol = 0 
C     ' calculations for the heavy fragment 
      DO I = 1 , 3 
      RA = (ZC_Mode_2 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(2,2,NINT(RA)) 
      END DO 
      AC_Mode_2 = (ZC_Mode_2 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      NC_Mode_2 = AC_Mode_2 - ZC_Mode_2 
C     ' 
      RZpol = 0 
C     ' calculations for the heavy fragment 
      DO I = 1 , 3 
      RA = (ZC_Mode_3 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(3,2,NINT(RA)) 
      END DO 
      AC_Mode_3 = (ZC_Mode_3 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      NC_Mode_3 = AC_Mode_3 - ZC_Mode_3 
C     ' 
      RZpol = 0 
C     ' calculations for the light(!!!) fragment 
      DO I = 1 , 3 
      RA = (ZC_Mode_4 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      RZpol = Zshift(4,1,NINT(RA)) 
      END DO 
      AC_Mode_4 = (ZC_Mode_4 - RZPol) * REAL(I_A_CN) / REAL(I_Z_CN) 
      NC_Mode_4 = AC_Mode_4 - ZC_Mode_4 
C     ' 
C     /' Yields of the fission modes '/ 
C     ' 
      Yield_Mode_0 = Getyield(E_exc_S0,E_exc_S0,0.0,0.0,T_low_SL,
     *TEgidy(REAL(I_A_CN),0.E0,Tscale),TEgidy(REAL(I_A_CN),0.E0,Tscale),
     *0) 
C     ' 
      Yield_Mode_1 = Getyield(E_exc_S1,E_exc_S0,
     *R_Shell_S1_eff+dE_Defo_S1,dE_Defo_S1,T_low_S1_used,
     *TEgidy(REAL(I_A_CN),R_Shell_S1_eff + dE_Defo_S1,Tscale),
     *TEgidy(REAL(I_A_CN),0.0,Tscale),1) 
C     /'  - Getyield(E_exc_S0 - E_ld_S1,T_low,T_high) '/ 
C     ' 
      Yield_Mode_2 = Getyield(E_exc_S2,E_exc_S0,R_Shell_S2_eff + 
     *dE_Defo_S2,dE_Defo_S2,T_low_S2,TEgidy(REAL(I_A_CN),R_Shell_S2_eff 
     *+ dE_Defo_S2,Tscale),TEgidy(REAL(I_A_CN),0.0,Tscale),2) 
C     /'  - Getyield(E_exc_S0 - E_ld_S2,T_low,T_high) '/ 
C     ' 
C     'Print 6237,"T_low_S2,TEgidy()";T_low_S2,TEgidy(Csng(I_A_CN),R_Shell_S2_eff + dE_Defo_S2,Tscale) 
C     'Print 6216,"E_exc_S2,Yield_Mode_2",E_exc_S2,Yield_Mode_2 
      Yield_Mode_3 = Getyield(E_exc_S3,E_exc_S0,R_Shell_S3_eff + 
     *dE_Defo_S3,dE_Defo_S3,T_low_S3,TEgidy(REAL(I_A_CN),R_Shell_S3_eff 
     *+ dE_Defo_S3,Tscale),TEgidy(REAL(I_A_CN),0.0,Tscale),3) 
C     /'  - Getyield(E_exc_S0 - E_ld_S3,T_low,T_high) '/ 
C     ' 
      Yield_Mode_4 = Getyield(E_exc_S4,E_exc_S0,R_Shell_S4_eff + 
     *dE_Defo_S4,dE_Defo_S4,T_low_S4,TEgidy(REAL(I_A_CN),R_Shell_S4_eff 
     *+ dE_Defo_S4,Tscale),TEgidy(REAL(I_A_CN),0.0,Tscale),4) 
C     /'   - Getyield(E_exc_S0 - E_ld_S4,T_low,T_high) '/ 
C     ' 
C     ' 
C     '   If B_S11 > B_S1 Then 
C     '     Yield_Mode_11 = 0.0 
C     '   Else 
      Yield_Mode_11 = Getyield(E_exc_S11,E_exc_S0,R_Shell_S1_eff + 2 * 
     *dE_Defo_S1,2 * dE_Defo_S1,T_low_S11,TEgidy(REAL(I_A_CN),
     *R_Shell_S1_eff + 2.E0 * dE_Defo_S1,Tscale),TEgidy(REAL(I_A_CN),
     *0.0,Tscale),11) 
C     '   End If 
C     'Print 6237,"T_low_S11,TEgidy()";T_low_S11,TEgidy(Csng(I_A_CN),R_Shell_S1_eff + 2.E0 * dE_Defo_S1,Tscale) 
C     'Print 6237,"E_exc_S11,Yield_Mode_11",E_exc_S11,Yield_Mode_11 
C     'sleep 
      IF (  B_S22 .GT. B_S2  ) THEN 
      Yield_Mode_22 = 0.0 
      Else 
      Yield_Mode_22 = Getyield(E_exc_S22,E_exc_S0,R_Shell_S2_eff,0.0,
     *T_low_S2,TEgidy(REAL(I_A_CN),R_Shell_S2_eff,Tscale),
     *TEgidy(REAL(I_A_CN),0.0,Tscale),22) 
      End If 
C     ' 
      Yield_Norm = Yield_Mode_0 + Yield_Mode_1 + Yield_Mode_2 + 
     *Yield_Mode_3 + Yield_Mode_4 + Yield_Mode_11 + Yield_Mode_22 
      Yield_Mode_0 = Yield_Mode_0 / Yield_Norm 
      Yield_Mode_1 = Yield_Mode_1 / Yield_Norm 
      Yield_Mode_2 = Yield_Mode_2 / Yield_Norm 
      Yield_Mode_3 = Yield_Mode_3 / Yield_Norm 
      Yield_Mode_4 = Yield_Mode_4 / Yield_Norm 
      Yield_Mode_11 = Yield_Mode_11 / Yield_Norm 
      Yield_Mode_22 = Yield_Mode_22 / Yield_Norm 
C     ' 
      P_selected = 1.0 
C     ' 
      Select CASE( I_Mode_selected) 
      CASE( 0) 
      P_selected = Yield_Mode_0 
      CASE( 1) 
      P_selected = Yield_Mode_1 
      CASE( 2) 
      P_selected = Yield_Mode_2 
      CASE( 3) 
      P_selected = Yield_Mode_3 
      CASE( 4) 
      P_selected = Yield_Mode_4 
      CASE( 5) 
      P_selected = Yield_Mode_11 
      CASE( 6) 
      P_selected = Yield_Mode_22 
      CASE( -1) 
      P_selected = 1.0 
      End Select 
C     ' 
      IF (  P_selected .EQ. 0  ) THEN 
C     '      Print "<I> Yield of the selected fission mode too low." 
C     '      Print "    No calculation performed." 
      End If 
C     ' 
C     /' Mass widhts of the fission channels '/ 
C     ' 
      SigA_Mode_0 = SigZ_Mode_0 * REAL(I_A_CN) / REAL(I_Z_CN) 
C     /' width in mass '/ 
      SigA_Mode_1 = SigZ_Mode_1 * REAL(I_A_CN) / REAL(I_Z_CN) 
      SigA_Mode_1 = Min(SigA_Mode_1,SigA_Mode_0) 
C     ' not broader than liquid-drop 
      SigA_Mode_2 = SigZ_Mode_2 * REAL(I_A_CN) / REAL(I_Z_CN) 
      SigA_Mode_2 = Min(SigA_Mode_2,SigA_Mode_0) 
C     ' not broader than liquid-drop 
      SigA_Mode_3 = SigZ_Mode_3 * REAL(I_A_CN) / REAL(I_Z_CN) 
      SigA_Mode_3 = Min(SigA_Mode_3,SigA_Mode_0) 
      SigA_Mode_4 = SigZ_mode_4 * REAL(I_A_CN) / REAL(I_Z_CN) 
      SigA_Mode_4 = Min(SigA_Mode_4,SigA_Mode_0) 
      SigA_Mode_11 = SigZ_Mode_1 * SQRT(2.E0) * REAL(I_A_CN) / 
     *REAL(I_Z_CN) 
      SigA_Mode_11 = Min(SigA_Mode_11,SigA_Mode_0) 
      SigA_Mode_22 = SigZ_Mode_2 * SQRT(2.E0) * REAL(I_A_CN) / 
     *REAL(I_Z_CN) 
      SigA_Mode_22 = Min(SigA_Mode_22,SigA_Mode_0) 
C     ' 
C     ' 
C     ' 
C     /' Shell effects of different fission channels '/ 
C     /' This is the "real" microscopic shell effect,not the effective shell-correction energy '/ 
C     /' EShell acts on the level density and determines the T parameter '/ 
C     ' 
      DO I = 1 , I_A_CN - 1 
      DO J = 0 , 4 
      EShell(J,1,I) = 0 
C     /' Shells in "light" fragment assumed to be zero '/ 
      END DO 
      DU0 = 0 
      EShell(0,2,I) = 0 
C     /' Shell = 0 in symmetric mode '/ 
C     ' 
      DU1 = R_Shell_S1_eff + dE_Defo_S1 
C     /' + R_A_Curv1_S1 * (AC_Mode_1 - Float(I,6))**2; '/ 
      DU1 = MIN(DU1,0.E0) 
C     /' Technical limit '/ 
      EShell(1,2,I) = DU1 
C     ' 
      DU2 = R_Shell_S2_eff + dE_Defo_S2 
C     /' + R_A_Curv1_S2 * (AC_Mode_2 - Float(I,6))**2; '/ 
      DU2 = Min(DU2,0.E0) 
C     /' Technical limit '/ 
      EShell(2,2,I) = DU2 
C     ' 
      DU3 = R_Shell_S3_eff + dE_Defo_S3 
C     /' + R_A_Curv1_S3 * (AC_Mode_3 - Float(I,6))**2; '/ 
      DU3 = Min(DU3,0.E0) 
C     /' Technical limit '/ 
      EShell(3,2,I) = DU3 
C     ' 
      DU4 = R_Shell_S4_eff + dE_Defo_S4 
C     /' + R_A_Curv1_S4 * (AC_Mode_4 - Float(I,6))**2; '/ 
      DU4 = Min(DU4,0.E0) 
C     /' Technical limit '/ 
      EShell(4,2,I) = DU4 
C     ' 
      END DO 
C     ' 
C     ' 
C     /' Intrinsic temperatures of fragments at scission '/ 
C     ' 
C     /' Mean values '/ 
      T_intr_Mode_0 = TEgidy(AC_Mode_0,0.0,0.8) 
      T_intr_Mode_1_heavy = TEgidy(AC_Mode_1,R_Shell_S1_eff + 
     *dE_Defo_S1,Tscale) 
      T_intr_Mode_1_light = TEgidy(REAL(I_A_CN) - AC_Mode_1,0.0,Tscale) 
      T_intr_Mode_2_heavy = TEgidy(AC_Mode_2,R_Shell_S2_eff + 
     *dE_Defo_S2,Tscale) 
      T_intr_Mode_2_light = TEgidy(REAL(I_A_CN) - AC_Mode_2,0.0,Tscale) 
      T_intr_Mode_3_heavy = TEgidy(AC_Mode_3,R_Shell_S3_eff + 
     *dE_Defo_S3,Tscale) 
      T_intr_Mode_3_light = TEgidy(REAL(I_A_CN) - AC_Mode_3,0.0,Tscale) 
      T_intr_Mode_4_heavy = TEgidy(AC_Mode_4,R_Shell_S4_eff + 
     *dE_Defo_S4,Tscale) 
      T_intr_Mode_4_light = TEgidy(REAL(I_A_CN) - AC_Mode_4,0.0,Tscale) 
C     ' 
C     ' 
C     /' Mass-dependent values of individual fragments '/ 
C     /' Mode 0 '/ 
      DO I = 1 , I_A_CN - 1 
      T = TEgidy(REAL(I),EShell(0,1,I),Tscale) 
      Temp(0,1,I) = T 
C     /' "light" fragment at freeze-out (somewhere before scission) '/ 
      T = TEgidy(REAL(I),EShell(0,2,I),Tscale) 
      Temp(0,2,I) = T 
C     /' "heavy" fragment at freeze-out (somewhere before scission) '/ 
C     ' 
      T = TEgidy(REAL(I),0.0,1.0) 
      TempFF(0,1,I) = T 
C     ' FF in their ground state 
      TempFF(0,2,I) = T 
C     ' FF in their ground state 
      END DO 
C     ' 
C     /' Mode 1 '/ 
      DO I = 1 , I_A_CN - 1 
      T = TEgidy(REAL(I),EShell(1,1,I),Tscale) 
      Temp(1,1,I) = T 
C     /' "light" fragment '/ 
      T = TEgidy(REAL(I),EShell(1,2,I),Tscale) 
      Temp(1,2,I) = T 
C     /' "heavy" fragment '/ 
C     ' 
      T = TEgidy(REAL(I),0.0,1.0) 
      TempFF(1,1,I) = T 
C     ' FF in their ground state 
      TempFF(1,2,I) = T 
C     ' FF in their ground state 
      END DO 
C     ' 
C     /' Mode 2 '/ 
      DO I = 1 , I_A_CN - 1 
      T = TEgidy(REAL(I),EShell(2,1,I),Tscale) 
      Temp(2,1,I) = T 
C     /' "light" fragment '/ 
      T = TEgidy(REAL(I),EShell(2,2,I),Tscale) 
      Temp(2,2,I) = T 
C     /' "heavy" fragment '/ 
C     ' 
C     /' The next section is introduced,because energy sorting is not strong enough, 
C     when shells are only introduced in the heavy fragment. 
C     Ad hoc assumption: For Mode 2 there are shells in both fragments of about 
C     equal size. Technically,we neglect the shells in both fragments. 
C     This has about the same effect for the energy sorting. '/ 
      T = TEgidy(REAL(I),0.0,Tscale) 
C     ' FF at scssion 
      Temp(2,1,I) = T 
C     /' "light" fragment '/ 
      T = TEgidy(REAL(I),0.0,Tscale) 
C     ' FF at scission 
      Temp(2,2,I) = T 
C     /' "heavy" fragment '/ 
C     ' 
      T = TEgidy(REAL(I),0.0,1.0) 
C     ' shell effect neglected 
      TempFF(2,1,I) = T 
C     ' FFs in their ground state 
      TempFF(2,2,I) = T 
C     ' FFs in their ground state 
      END DO 
C     ' 
C     /' Mode 3 '/ 
      DO I = 1 , I_A_CN -1 
      T = TEgidy(REAL(I),0.0,Tscale) 
      Temp(3,1,I) = T 
      T = TEgidy(REAL(I),0.0,Tscale) 
      Temp(3,2,I) = T 
C     ' 
      T = TEgidy(REAL(I),0.0,1.0) 
      TempFF(3,1,I) = T 
C     ' FF in their ground state 
      TempFF(3,2,I) = T 
C     ' FF in their ground state 
      END DO 
C     ' 
C     /' Mode 4 '/ 
      DO I = 1 , I_A_CN -1 
      T = TEgidy(REAL(I),0.0,Tscale) 
      Temp(4,1,I) = T 
      T = TEgidy(REAL(I),0.0,Tscale) 
      Temp(4,2,I) = T 
C     ' 
      T = TEgidy(REAL(I),0.0,1.0) 
      TempFF(4,1,I) = T 
C     ' FF in their ground state 
      TempFF(4,2,I) = T 
C     ' FF in their ground state 
      END DO 
C     ' 
C     ' 
C     /'** Intrinsic excitation energy at saddle and at scission as well as   **'/ 
C     /'** Even-odd effect in proton and neutron number for each fission mode **'/ 
      DO I_Mode = 0 , 6 
      E_coll_saddle(I_Mode) = 0 
      IF (  I_Mode .EQ. 0  )  Etot = E_exc_S0 
      IF (  I_Mode .EQ. 1  )  Etot = E_exc_S1 
      IF (  I_Mode .EQ. 2  )  Etot = E_exc_S2 
      IF (  I_Mode .EQ. 3  )  Etot = E_exc_S3 
      IF (  I_Mode .EQ. 4  )  Etot = E_exc_S4 
      IF (  I_Mode .EQ. 5  )  Etot = E_exc_S11 
      IF (  I_Mode .EQ. 6  )  Etot = E_exc_S22 
C     ' 
      IF (   MOD(I_Z_CN,2)  +  MOD(I_N_CN,2)  .EQ. 0  ) THEN 
C     /' Even-even CN '/ 
      IF (  Etot .GT. 0 .AND. Etot .LT. 2.E0 * 14.E0/SQRT(REAL(I_A_CN)) 
     * ) THEN 
      E_coll_saddle(I_Mode) = Etot 
      Etot = 0 
C     /' Excitation below the pairing gap in even-even CN goes into collective excitations '/ 
      End If 
      End If 
C     ' 
C     '    If I_Z_CN Mod 2 + I_N_CN Mod 2 = 0 Then    ' even-even 
C     '      Ediff = Min(Etot,14.0/sqr(Csng(I_A_CN))) 
C     '    End If 
C     '    If I_Z_CN Mod 2 + I_N_CN Mod 2 = 1 Then    ' even-odd or odd-even 
C     '       Ediff = Min(Etot,2.0 * 14.0/sqr(Csng(I_A_CN))) 
C     '    End If 
C     '    Ediff = Max(Ediff,0.0) 
C     '    Etot = Etot - Ediff 
C     ' 
C     ' 
      IF (  Etot .LT. 0  ) THEN 
      E_tunn = -Etot
      Else
      E_tunn = 0
      END IF
      Etot = Max(Etot,0.0) 
C     ' 
      E_pot_scission = (De_Saddle_Scission(REAL(I_Z_CN),REAL(I_A_CN),
     *ESHIFTSASCI_intr) ) 
      E_diss_Scission = EDISSFRAC * (E_pot_scission - E_tunn) + 
     *Epot_shift 
      IF (  E_diss_Scission .LT. 0  )  E_diss_Scission = 0 
      Etot = Etot + E_diss_Scission 
C     /' All excitation energy at saddle and part of the potential-energy gain to scission 
C     go into intrinsic excitation energy at scission '/ 
C     ' 
C     ' 
C     ' 
C     ' 
      IF (  I_Mode .EQ. 2  ) THEN 
      EINTR_SCISSION = Etot 
C     /' (For Mode 2) Global parameter '/ 
      End If 
C     ' 
      DO IA1 = 40 , I_A_CN - 40 
C     ' 
      IA2 = I_A_CN - IA1 
      IF (  I_Mode .LE. 4  ) THEN 
      T1 = Temp(I_Mode,1,IA1) 
      T2 = Temp(I_Mode,2,IA2) 
      End If 
      IF (  I_Mode .EQ. 5  ) THEN 
      T1 = Temp(1,2,IA1) 
      T2 = Temp(1,2,IA2) 
      End If 
      IF (  I_Mode .EQ. 6  ) THEN 
      T1 = Temp(2,2,IA1) 
      T2 = Temp(2,2,IA2) 
      End If 
      DT = ABS(T2 - T1) 
C     ' 
C     /' Even-odd effect '/ 
      IF (   MOD(I_Z_CN,2)  .EQ. 0  ) THEN 
      Rincr1P = Exp(-Etot/PZ_EO_symm) 
      Else 
      Rincr1P = 0 
      End If 
      IF (   MOD(I_N_CN,2)  .EQ. 0  ) THEN 
      Rincr1N = Exp(-Etot/PN_EO_symm) 
      Else 
      Rincr1N = 0 
      End If 
      PEOZ(I_Mode,1,IA1) = Rincr1P 
      PEOZ(I_Mode,2,IA2) = Rincr1P 
      PEON(I_Mode,1,IA1) = Rincr1N 
      PEON(I_Mode,2,IA2) = Rincr1N 
C     ' 
      IF (  Etot .GT. 0  ) THEN 
      Rincr2 = Gaussintegral(DT/Etot-R_EO_Thresh,
     *R_EO_Sigma*(DT+0.0001)) 
C     /' even-odd effect due to asymmetry '/ 
      Else 
C     ' even-odd effect is already 100% 
      Rincr2 = 0 
      End If 
      Rincr2P = (R_EO_MAX - Rincr1P) * Rincr2 
      Rincr2N = (R_EO_MAX - Rincr1N) * Rincr2 
C     ' 
      IF (  IA1 .LE. IA2  ) THEN 
C     ' A1 is lighter or equal to A2 
      PEOZ(I_Mode,1,IA1) = PEOZ(I_Mode,1,IA1) + Rincr2P 
      IF (   MOD(I_Z_CN,2)  .EQ. 0  ) THEN 
      PEOZ(I_Mode,2,IA2) = PEOZ(I_Mode,2,IA2) + Rincr2P 
      Else 
      PEOZ(I_Mode,2,IA2) = PEOZ(I_Mode,2,IA2) - Rincr2P 
      End if 
      PEON(I_Mode,1,IA1) = PEON(I_Mode,1,IA1) + Rincr2N 
      IF (   MOD(I_N_CN,2)  .EQ. 0  ) THEN 
      PEON(I_Mode,2,IA2) = PEON(I_Mode,2,IA2) + Rincr2N 
      Else 
      PEON(I_Mode,2,IA2) = PEON(I_Mode,2,IA2) - Rincr2N 
      End if 
      Else 
      PEOZ(I_Mode,1,IA1) = PEOZ(I_Mode,2,IA1) 
      PEON(I_Mode,1,IA1) = PEON(I_Mode,2,IA1) 
      PEOZ(I_Mode,2,IA2) = PEOZ(I_Mode,1,IA2) 
      PEON(I_Mode,2,IA2) = PEON(I_Mode,1,IA2) 
      End If 
C     ' 
C     ' 
C     /'  Else 
C     PEOZ(I_Mode,2,IA2) =                PEOZ(I_Mode,1,IA2) + Rincr2P 
C     IF I_Z_CN Mod 2 = 0 Then 
C     PEOZ(I_Mode,1,IA1) =                 PEOZ(I_Mode,1,IA1) + Rincr2P 
C     Else 
C     PEOZ(I_Mode,1,IA1) =                 PEOZ(I_Mode,1,IA1) - Rincr2P 
C     End if 
C     PEON(I_Mode,2,IA2) =              PEON(I_Mode,2,IA2) + Rincr2N 
C     IF I_N_CN Mod 1 = 0 Then 
C     PEON(I_Mode,1,IA1) =                 PEON(I_Mode,1,IA1) + Rincr2N 
C     Else 
C     PEON(I_Mode,1,IA1) =                 PEON(I_Mode,1,IA1) - Rincr2N 
C     End if 
C     End If  '/ 
C     ' 
      PEOZ(I_Mode,1,IA1) = PEOZ(I_Mode,1,IA1) * EOscale 
      PEOZ(I_Mode,2,IA2) = PEOZ(I_Mode,2,IA2) * EOscale 
      PEON(I_Mode,1,IA1) = PEON(I_Mode,1,IA1) * EOscale 
      PEON(I_Mode,2,IA2) = PEON(I_Mode,2,IA2) * EOscale 
C     ' 
C     ' 
C     /'  For T1 = 0.5 To 1 Step 0.05 
C     T2 = 1 - T1 
C     '      Print T1,T2,1.E - Gaussintegral(T2-T1,0.1) 
C     Next T1 
C     Sleep  '/ 
C     ' 
C     /' Energy sorting '/ 
C     /' E1 = Etot * Gaussintegral(T2-T1,0.03); '/ 
      IF (  Abs(T1-T2) .LT. 1.E-6  ) THEN 
      E1 = 0.5E0 * Etot 
      Else 
C     '   E1ES = Csort * T1 * T2 / ( Abs(T1 - T2) ) 
      IF (  I_Mode .EQ. 0  ) THEN 
      E1ES = Etot * Gaussintegral(T2-T1,Esort_Slope_S0) 
      Else 
      E1ES = Etot * Gaussintegral(T2-T1,Esort_Slope) 
      End If 
      E1ES = Min(E1ES,0.5E0*Etot) 
C     /' Asymptotic value after "complete" energy sorting '/ 
      E1FG = Etot * IA1 / I_A_CN 
C     /' in Fermi-gas regime '/ 
C     ' 
C     /'  The following section assumes T=const in the superfluid regime 
C     If Etot < 13 Then E1 = E1ES  ' complete energy sorting 
C     If Etot >= 13 and Etot <= 20 Then  ' transition region 
C     E1 = E1ES + (Etot-13)/7*(E1FG-E1ES) 
C     End If 
C     If Etot > 20 Then E1 = E1FG   ' Fermi-gas regime   '/ 
C     ' 
C     /' The following section extends energy sorting to higher energies '/ 
      IF (  Etot .LT. 13 * Esort_extend  )  E1 = E1ES 
C     ' complete energy sorting 
      IF (  Etot .GE. 13 * Esort_extend .AND. Etot .LE. 20 * 
     *Esort_extend  ) THEN 
C     ' transition region 
      E1 = E1ES + (Etot-13 * Esort_extend)/7*(E1FG-E1ES) 
      End If 
      IF (  Etot .GT. 20 * Esort_extend  )  E1 = E1FG 
C     ' Fermi-gas regime 
C     ' 
      End If 
      E2 = Etot - E1 
      EPART(I_Mode,1,IA1) = Max(E1,0.0) 
C     /' Mean E* in light fragment '/ 
      EPART(I_Mode,2,IA2) = Max(E2,0.0) 
C     /' Mean E* in heavy fragment '/ 
      END DO 
      END DO 
C     ' 
C     ' 
C     /'** RMS angular momentum of fission fragments **'/ 
C     /' Following Naik et al.,EPJ A 31 (2007) 195 and  '/ 
C     /' S. G. Kadmensky,Phys. At. Nucl. 71 (2008) 1193 '/ 
C     ' 
C     '   Scope 
      Spin_CN = P_J_CN 
      P_I_rms_CN = P_J_CN 
C     ' 
      DO IZ1 = 10 , I_Z_CN - 10 
      AUCD = Int(REAL(IZ1) * REAL(I_A_CN) / REAL(I_Z_CN)) 
      DO IA1 = Int(AUCD - 15) , Int(AUCD + 15) 
      IN1 = IA1 - IZ1 
      IF (  IA1 - IZ1 .GE. 10  ) THEN 
C     /' Rigid momentum of inertia for spherical nucleus '/ 
      I_rigid_spher = 1.16E0**2 * REAL(IA1)**1.6667E0 / 103.8415E0 
C     /' unit: hbar^2/MeV '/ 
      DO I_Mode = 0 , 6 
C     ' 
C     /' First (normally light) fission fragment: '/ 
C     ' 
      beta1 = Beta(I_Mode,1,IZ1) 
      alph = beta1 / SQRT(4.E0 * pi / 5.E0) 
      I_rigid = I_rigid_spher * (1.E0 + 0.5E0*alph + 9.E0/7.E0*alph**2) 
C     /' From Hasse & Myers,Geometrical Relationships ... '/ 
      E_exc = EPART(I_Mode,1,IA1) 
      IF (  E_exc .LT. 0  )  E_exc = 0 
      T = U_Temp(REAL(IZ1),REAL(IA1),E_exc,1,1,Tscale,Econd,Etrans) 
C     '   T = sqr(T^2 + 0.8^2)       ' For ZPM 
C     '   T = T_orbital 
C     '   T =  sqr(T^2 + T_orbital^2) 
      IF (  T_orbital .GT. 0.1  ) THEN 
      T = T_orbital / tanh(T_orbital/T) 
C     ' T_orbital represents the ZPM 
      End If 
      I_eff = I_rigid * (1.E0 - 0.8E0 * exp(-0.693E0 * E_exc / 5.E0)) 
C     'Nucl. Phys. A 263 (1976) 141 
      J_rms = SQRT(2.E0 * I_eff * T) 
C     ' 
      J_rms = J_rms * Jscaling 
C     ' 
      IF (   MOD(IZ1,2)  .EQ. 1 .OR.  MOD(IN1,2)  .EQ. 1  )  J_rms = 
     *J_rms + Spin_odd * (REAL(IA1)/140.0)**0.66667 
C     '                * Max(0,1 - (E_exc-1)/9) /' empirical '/ 
C     /' Additional angular momentum of unpaired proton. '/ 
C     /' See also Tomar et al.,Pramana 68 (2007) 111 '/ 
C     ' 
C     ' Print Z1,I_Mode,beta1,T,E_exc,Spin_CN 
C     ' Print " ",I_rigid_spher,I_rigid,I_eff,J_rms 
C     ' 
      J_rms = SQRT(J_rms**2 + (IA1/I_A_CN * Spin_CN)**2) 
C     ' 
      SpinRMSNZ(I_Mode,1,IA1-IZ1,IZ1) = J_rms 
C     ' 
C     '     Print 
C     '     Print IA1,T,E_exc,I_rigid_spher,I_rigid,I_eff,J_rms 
C     ' 
C     /' Second (normally heavy) fission fragment: '/ 
C     ' 
      beta2 = Beta(I_Mode,2,IZ1) 
      alph = beta2 / SQRT(4.E0 * pi / 5.E0) 
      I_rigid = I_rigid_spher * (1.E0 + 0.5E0*alph + 9.E0/7.E0*alph**2) 
C     /' From Hasse & Myers,Geometrical Relationships ... '/ 
      E_exc = EPART(I_Mode,2,IA1) 
      IF (  E_exc .LT. 0  )  E_exc = 0 
      T = U_Temp(REAL(IZ1),REAL(IA1),E_exc,1,1,Tscale,Econd,Etrans) 
C     '    T = sqr(T^2 + 0.8^2)       ' For ZPM 
C     '    T = T_orbital 
C     '    T =  sqr(T^2 + T_orbital^2) 
      IF (  T_orbital .GT. 0.1  ) THEN 
      T = T_orbital / tanh(T_orbital/T) 
C     ' T_orbital represents the ZPM 
      End If 
      I_eff = I_rigid * (1.E0 - 0.8E0 * exp(-0.693E0 * E_exc / 5.E0)) 
      J_rms = SQRT(2.E0 * I_eff * T) 
C     ' 
      J_rms = J_rms * Jscaling 
C     ' 
      IF (   MOD(IZ1,2)  .EQ. 1 .OR.  MOD(IN1,2)  .EQ. 1  )  J_rms = 
     *J_rms + Spin_odd * (REAL(IA1)/140.0)**0.66667 
C     '                 * Max(0,1 - (E_exc-1)/9) /' empirical '/ 
C     /' Additional angular momentum of unpaired proton. '/ 
C     /' See also Tomar et al.,Pramana 68 (2007) 111 '/ 
C     ' 
      J_rms = SQRT(J_rms**2 + (IA1/I_A_CN * Spin_CN)**2) 
C     ' 
      SpinRMSNZ(I_Mode,2,IA1-IZ1,IZ1) = J_rms 
C     ' 
C     '      Print IA1,T,E_exc,I_rigid_spher,I_rigid,I_eff,J_rms 
C     ' 
      END DO 
      End If 
      END DO 
      END DO 
C     '   End Scope 
C     ' 
C     ' **************************************************************** 
C     ' *** Filling arrays with results in the folding mode (GEFSUB) *** 
C     ' **************************************************************** 
C     ' Scope 
      DO I_short = 10 , I_A_CN - P_Z_CN - 10 
      DO J_short = 10 , P_Z_CN - 10 
      DO K_short = 0 , 6 
      NZMPRE(K_short,I_short,J_short) = 0.0 
      END DO 
      END DO 
      END DO 
C     ' 
C     ' Mode 0 
      DO I_short = 20 , I_A_CN - 20 
      Ic = I_A_CN - I_short 
      R_Help = Yield_Mode_0 * (U_Gauss_mod(AC_Mode_0 - REAL(I_short),
     *SigA_Mode_0)                  + U_Gauss_mod(AC_Mode_0 - REAL(Ic),
     *SigA_Mode_0)) 
C     ' Mass yield 
      IF (  I_short .LT. Ic  ) THEN 
      Zs = ZShift(0,1,I_short) 
      Else 
      Zs = -ZShift(0,1,Ic) 
      End If 
      DO J_short = 10 , P_Z_CN - 10 
      Jc = P_Z_CN - J_short 
      IF (  I_short-J_short .GE. 0 .AND. Ic-Jc .GE. 0 .AND. 
     *I_short-J_short .LE. 200 .AND. Ic-Jc .LE. 200  ) THEN 
      NZMPRE(0,I_short-J_short,J_short) = R_Help * 
     *U_Gauss_mod(REAL(P_Z_CN)/REAL(I_A_CN)*REAL(I_short) + Zs -        
     *    REAL(J_short),SigPol_Mode_0) * U_Even_Odd(J_short,PEOZ(0,1,
     *I_short)) * U_Even_Odd(I_short-J_short,PEON(0,1,I_short)) 
      End If 
      END DO 
      END DO 
C     ' 
C     ' Mode 1 
      DO I_short = 20 , I_A_CN - 20 
      Ic = I_A_CN - I_short 
      R_Help = Yield_Mode_1 * (U_Gauss_mod(AC_Mode_1 - REAL(I_short),
     *SigA_Mode_1)                + U_Gauss_mod(AC_Mode_1 - REAL(Ic),
     *SigA_Mode_1)) 
C     ' Mass yield 
      IF (  I_short .LT. Ic  ) THEN 
      Zs = ZShift(1,1,I_short) 
      Else 
      Zs = -ZShift(1,1,Ic) 
      End If 
      DO J_short = 10 , P_Z_CN - 10 
      Jc = P_Z_CN - J_short 
      IF (  I_short-J_short .GE. 0 .AND. Ic-Jc .GE. 0 .AND. 
     *I_short-J_short .LE. 200 .AND. Ic-Jc .LE. 200  ) THEN 
      NZMPRE(1,I_short-J_short,J_short) = R_Help * 
     *U_Gauss_mod(REAL(P_Z_CN)/REAL(I_A_CN)*REAL(I_short) + Zs - 
     *REAL(J_short),SigPol_Mode_1)* U_Even_Odd(J_short,PEOZ(1,1,
     *I_short)) * U_Even_Odd(I_short-J_short,PEON(1,1,I_short)) 
      End If 
      END DO 
      END DO 
C     ' 
C     ' Mode 2 
      DO I_short = 20 , I_A_CN - 20 
      Ic = I_A_CN - I_short 
      R_Help = Yield_Mode_2 * (U_Box2(AC_Mode_2 - REAL(I_short),
     *SQRT(2.0)*S2leftmod*SigA_Mode_2,SQRT(2.0)*SigA_Mode_2,
     *P_A_Width_S2) +             U_Box2(AC_Mode_2 - REAL(Ic),
     *SQRT(2.0)*S2leftmod*SigA_Mode_2,SQRT(2.0)*SigA_Mode_2,
     *P_A_Width_S2)) 
      IF (  I_short .LT. Ic  ) THEN 
      Zs = ZShift(2,1,I_short) 
      Else 
      Zs = -ZShift(2,1,Ic) 
      End If 
      DO J_short = 10 , P_Z_CN - 10 
      Jc = P_Z_CN - J_short 
      IF (  I_short-J_short .GE. 0 .AND. Ic-Jc .GE. 0 .AND. 
     *I_short-J_short .LE. 200 .AND. Ic-Jc .LE. 200  ) THEN 
      R_Cut1 = R_Help 
      R_Cut2 = R_Help 
      IF (  J_short .GT. Jc  ) THEN 
      R_Cut1 = R_Help * Gaussintegral(REAL(J)-ZTRUNC50,
     *FTRUNC50*SigZ_Mode_2) 
      Else 
      R_Cut2 = R_Help * Gaussintegral(REAL(J)-ZTRUNC50,
     *FTRUNC50*SigZ_Mode_2) 
      End If 
      NZMPRE(2,I_short-J_short,J_short) = R_Help * 
     *U_Gauss_mod(REAL(P_Z_CN)/REAL(I_A_CN)*REAL(I_short) + Zs - 
     *REAL(J_short),SigPol_Mode_2) * U_Even_Odd(J_short,PEOZ(2,1,
     *I_short)) * U_Even_Odd(I_short-J_short,PEON(2,1,I_short)) 
      End If 
      END DO 
      END DO 
C     ' 
C     ' Mode 3 
      DO I_short = 20 , I_A_CN - 20 
      Ic = I_A_CN - I_short 
      R_Help = Yield_Mode_3 * (U_Gauss_mod(AC_Mode_3 - REAL(I_short),
     *SigA_Mode_3) +                     U_Gauss_mod(AC_Mode_3 - 
     *REAL(Ic),SigA_Mode_3)) 
C     ' Mass yield 
      IF (  I_short .LT. Ic  ) THEN 
      Zs = ZShift(3,1,I_short) 
      Else 
      Zs = -ZShift(3,1,Ic) 
      End If 
      DO J_short = 10 , P_Z_CN - 10 
      Jc = P_Z_CN - J_short 
      IF (  I_short-J_short .GE. 0 .AND. Ic-Jc .GE. 0 .AND. 
     *I_short-J_short .LE. 200 .AND. Ic-Jc .LE. 200  ) THEN 
      NZMPRE(3,I_short-J_short,J_short) = R_Help * 
     *U_Gauss_mod(REAL(P_Z_CN)/REAL(I_A_CN)*REAL(I_short) + Zs - 
     *REAL(J_short),SigPol_Mode_3) * U_Even_Odd(J_short,PEOZ(3,1,
     *I_short)) * U_Even_Odd(I_short-J_short,PEON(3,1,I_short)) 
      End If 
      END DO 
      END DO 
C     ' 
C     ' Mode 4 
      DO I_short = 20 , I_A_CN - 20 
      Ic = I_A_CN - I_short 
      R_Help = Yield_Mode_4 * (U_Gauss_mod(AC_Mode_4 - REAL(I_short),
     *SigA_Mode_4) +                     U_Gauss_mod(AC_Mode_4 - 
     *REAL(Ic),SigA_Mode_4)) 
      IF (  I_short .LT. Ic  ) THEN 
      Zs = ZShift(3,1,I_short) 
C     ' light fragment 
      Else 
      Zs = -ZShift(3,1,Ic) 
C     ' heavy fragment 
      End If 
      DO J_short = 10 , P_Z_CN - 10 
      Jc = P_Z_CN - J_short 
      IF (  I_short-J_short .GE. 0 .AND. Ic-Jc .GE. 0 .AND. 
     *I_short-J_short .LE. 200 .AND. Ic-Jc .LE. 200  ) THEN 
      NZMPRE(4,I_short-J_short,J_short) = R_Help * 
     *U_Gauss_mod(REAL(P_Z_CN)/REAL(I_A_CN)*REAL(I_short) + Zs - 
     *REAL(J_short),SigPol_Mode_4) * U_Even_Odd(J_short,PEOZ(4,1,
     *I_short)) * U_Even_Odd(I_short-J_short,PEON(4,1,I_short)) 
      End If 
      END DO 
      END DO 
C     ' 
C     ' Mode 11 
      DO I_short = 20 , I_A_CN - 20 
      Ic = I_A_CN - I_short 
      R_Help = Yield_Mode_11 * (U_Gauss_mod(AC_Mode_0 - REAL(I_short),
     *SigA_Mode_11) +                     U_Gauss_mod(AC_Mode_0 - 
     *REAL(Ic),SigA_Mode_11)) 
C     ' Mass yield 
      DO J_short = 10 , P_Z_CN - 10 
      Jc = P_Z_CN - J_short 
      IF (  I_short-J_short .GE. 0 .AND. Ic-Jc .GE. 0 .AND. 
     *I_short-J_short .LE. 200 .AND. Ic-Jc .LE. 200  ) THEN 
      NZMPRE(5,I_short-J_short,J_short) = R_Help * 
     *U_Gauss_mod(REAL(P_Z_CN)/REAL(I_A_CN)*REAL(I_short) - 
     *REAL(J_short),SigPol_Mode_0) * U_Even_Odd(J_short,PEOZ(5,1,
     *I_short)) * U_Even_Odd(I_short-J_short,PEON(5,1,I_short)) 
      End If 
      END DO 
      END DO 
C     ' 
C     ' Mode 22 
      DO I_short = 20 , I_A_CN - 20 
      Ic = I_A_CN - I_short 
      R_Help = Yield_Mode_22 * (U_Gauss_mod(AC_Mode_0 - REAL(I_short),
     *SigA_Mode_22) +                     U_Gauss_mod(AC_Mode_0 - 
     *REAL(Ic),SigA_Mode_22)) 
C     ' Mass yield 
      DO J_short = 10 , P_Z_CN - 10 
      Jc = P_Z_CN - J_short 
      IF (  I_short-J_short .GE. 0 .AND. Ic-Jc .GE. 0 .AND. 
     *I_short-J_short .LE. 200 .AND. Ic-Jc .LE. 200  ) THEN 
      NZMPRE(6,I_short-J_short,J_short) = R_Help * 
     *U_Gauss_mod(REAL(P_Z_CN)/REAL(I_A_CN)*REAL(I_short) - 
     *REAL(J_short),SigPol_Mode_0) * U_Even_Odd(J_short,PEOZ(6,1,
     *I_short)) * U_Even_Odd(I_short-J_short,PEON(6,1,I_short)) 
      End If 
      END DO 
      END DO 
C     ' 
C     ' 
C     ' Normalization 
      R_Sum = 0 
      DO I_short = 10 , (I_A_CN - P_Z_CN) - 10 
      DO J_short = 10 , P_Z_CN - 10 
      NZPRE(I_short,J_short) = 0 
      DO K_short = 0 , 6 
      IF (  NZMPRE(K_short,I_short,J_short) .GT. 0  ) THEN 
      R_Sum = R_Sum + NZMPRE(K_short,I_short,J_short) 
      NZPRE(I_short,J_short) = NZPRE(I_short,J_short) + NZMPRE(K_short,
     *I_short,J_short) 
C     ' sum of all modes 
      End If 
      END DO 
      END DO 
      END DO 
C     ' Print R_Sum 
      DO I_short = 10 , (I_A_CN - P_Z_CN) - 10 
      DO J_short = 10 , P_Z_CN - 10 
      NZPRE(I_short,J_short) = NZPRE(I_short,J_short) / R_Sum 
      DO K_short = 0 , 6 
      NZMPRE(K_short,I_short,J_short) = NZMPRE(K_short,I_short,J_short) 
     */ R_Sum 
      END DO 
      END DO 
      END DO 
C     ' End Scope 
C     ' 
C     ' Calculate and store distributions of fragment excitation energy and spin 
C     ' 
      N_cases = 0 
      DO N_index = 10 , (P_A_CN - P_Z_CN) - 10 
C     ' Neutron number 
      DO Z_index = 10 , P_Z_CN - 10 
C     ' Atomic number 
      DO M_index = 0 , 6 
C     ' Fission channel 
      IF (  NZMPRE(M_index,N_index,Z_index) .GT. Ymin  ) THEN 
      N_cases = N_cases + 1 
      IF (  N_cases .EQ. Ubound(NZMkey,1)  ) THEN 
C     '           Print "Upper bound of NZkey reached" 
C     '           Print "Result will be incomplete" 
      End If 
      NZMkey(N_cases,1) = M_index 
C     ' Fission mode 
      NZMkey(N_cases,2) = N_index 
C     ' Neutron number of fragment 
      NZMkey(N_cases,3) = Z_index 
C     ' Atomic number of fragment 
      End If 
      END DO 
      END DO 
      END DO 
C     ' Print "N_cases  ",N_cases 
      WRITE (*,*) "N_cases ",N_cases 
C     ' 
      DO K = 1 , N_cases 
      M_index = NZMkey(K,1) 
C     ' fission mode 
      N_index = NZMkey(K,2) 
C     ' neutron number 
      Z_index = NZMkey(K,3) 
C     ' atomic number 
      A_index = N_index + Z_index 
C     ' 
C     ' Yield 
      Ytab(K) = NZMpre(M_index,N_index,Z_index) 
C     ' 
C     ' Angular momentum: 
      DO I = 1 , 100 
      IF (  M_index .LE. 4  ) THEN 
      IF (  Z_index .LT. 0.5 * P_Z_CN  ) THEN 
      Jtab(K,I) = U_LinGauss(REAL(I),SpinRMSNZ(M_index,1,N_index,
     *Z_index)/SQRT(2.0)) 
      Else 
      Jtab(K,I) = U_LinGauss(REAL(I),SpinRMSNZ(M_index,2,N_index,
     *Z_index)/SQRT(2.0)) 
      End If 
      End If 
      IF (  M_index .EQ. 5  ) THEN 
      Jtab(K,I) = U_LinGauss(REAL(I),SpinRMSNZ(1,2,N_index,
     *Z_index)/SQRT(2.0)) 
      End If 
      IF (  M_index .EQ. 6  ) THEN 
      Jtab(K,I) = U_LinGauss(REAL(I),SpinRMSNZ(2,2,N_index,
     *Z_index)/SQRT(2.0)) 
      End If 
      END DO 
C     ' 
C     ' Normalize numerically (due to non-continuous values) 
C     '   Scope 
      Rint = 0 
      DO I = 1 , 100 
      Rint = Rint + Jtab(K,I) 
      END DO 
      IF (  Rint .GT. 0  ) THEN 
      DO I = 1 , 100 
      Jtab(K,I) = Jtab(K,I) / Rint 
      END DO 
      End If 
C     '   End Scope 
C     ' 
C     ' 
C     ' Excitation energy: 
C     ' 1. Deformation energy at scission 
C     '   Scope 
      IF (  M_index .EQ. 0  ) THEN 
      EtotS0 = Max(E_Exc_S0 + E_diss_Scission,0.0) 
C     ' Transition from shell-defined to macroscopic shape with increasing E* 
C     ' RW_mac = relative macroscopic influence 
      RW_mac = Gaussintegral(EtotS0-20.0,5.0) 
      IF (  Z_index .LT. 0.5 * P_Z_CN  ) THEN 
      Eexc_mean = (1.0 - RW_mac) * Edefo(-1,1,Z_index) + RW_mac * 
     *Edefo(0,1,Z_index) 
      Eexc_sigma = ( Lymass(REAL(Z_index),REAL(A_index),beta(0,1,
     *Z_index) + SIGDEFO_0) -             Lymass(REAL(Z_index),
     *REAL(A_index),beta(0,1,Z_index) )) 
      Else 
      Eexc_mean = (1.0 - RW_mac) * Edefo(-1,2,Z_index) + RW_mac * 
     *Edefo(0,2,Z_index) 
      Eexc_sigma = ( Lymass(REAL(Z_index),REAL(A_index),beta(0,2,
     *Z_index) + SIGDEFO_0) -             Lymass(REAL(Z_index),
     *REAL(A_index),beta(0,2,Z_index) )) 
      End If 
      End If 
      IF (  M_index .GT. 0 .AND. M_index .LE. 4  ) THEN 
      IF (  Z_index .LT. 0.5 * P_Z_CN  ) THEN 
      Eexc_mean = Edefo(M_index,1,Z_index) 
C     '    RS = SIGDEFO/Sqr(R_Att_Sad(M_index)) 
      RS = SIGDEFO 
      Eexc_sigma = ( Lymass(REAL(Z_index),REAL(A_index),beta(M_index,1,
     *Z_index) + RS) -             Lymass(REAL(Z_index),REAL(A_index),
     *beta(M_index,1,Z_index) )) 
      Else 
      Eexc_mean = Edefo(M_index,2,Z_index) 
C     '    RS = SIGDEFO/Sqr(R_Att_Sad(M_index)) 
      RS = SIGDEFO 
      Eexc_sigma = ( Lymass(REAL(Z_index),REAL(A_index),beta(M_index,2,
     *Z_index) + RS) -             Lymass(REAL(Z_index),REAL(A_index),
     *beta(M_index,2,Z_index) )) 
      End If 
      End If 
      IF (  M_index .EQ. 5  ) THEN 
      Eexc_mean = Edefo(1,2,Z_index) 
C     '  RS = SIGDEFO/Sqr(R_Att_Sad(M_index)) 
      RS = SIGDEFO 
      Eexc_sigma = ( Lymass(REAL(Z_index),REAL(A_index),beta(1,2,
     *Z_index) + RS) -             Lymass(REAL(Z_index),REAL(A_index),
     *beta(1,2,Z_index) )) 
      End If 
      IF (  M_index .EQ. 6  ) THEN 
      Eexc_mean = Edefo(2,2,Z_index) 
C     '  RS = SIGDEFO/Sqr(R_Att_Sad(M_index)) 
      RS = SIGDEFO 
      Eexc_sigma = ( Lymass(REAL(Z_index),REAL(A_index),beta(2,2,
     *Z_index) + RS) -             Lymass(REAL(Z_index),REAL(A_index),
     *beta(2,2,Z_index) )) 
      End If 
      Eexc_mean = Max(Eexc_mean,0.0) 
C     '   End Scope 
C     ' 
C     ' 2. Intrinsic excitation energy at scission 
      IF (  Z_index .LT. 0.5 * REAL(P_Z_CN)  ) THEN 
      Eexc_intr = EPART(M_index,1,A_index) 
      Else 
      Eexc_intr = EPART(M_index,2,A_index) 
      End If 
      IF (  M_index .EQ. 0  ) THEN 
C     ' add shell and pairing of final fragment 
      Eexc_intr = Eexc_intr - AME2012(Z_index,A_index) + 
     *LDMass(REAL(Z_index),REAL(A_index),0.) - 2.0 * 12.0 / 
     *SQRT(REAL(A_index)) 
C     ' general shift 
      End If 
      Eexc_intr = Max(Eexc_intr,0.0) 
      Eexc_mean = Eexc_mean + Eexc_intr 
      Eexc_sigma = SQRT(Eexc_sigma**2 + (EexcSIGrel * 
     *E_diss_Scission)**2) 
C     ' 
C     ' 3. Pairing staggering 
      Eexc_mean = Eexc_mean - Lypair(Z_index,A_index) 
C     ' 
C     ' 4. Collective energy 
      Eexc_coll = 0.5 * ECOLLFRAC * (De_Saddle_Scission(REAL(P_Z_CN),
     *REAL(I_A_CN),ESHIFTSASCI_coll) - E_tunn) 
      Eexc_coll = Max(Eexc_coll,0.0) 
      Eexc_sigma = SQRT(Eexc_sigma**2 + 0.5*(EexcSIGrel*Eexc_coll)**2) 
      Eexc_mean = Eexc_mean + Eexc_coll + 0.5 * E_coll_saddle(M_index) 
C     ' 
C     ' 5. Total excitation energy distribution of fragments (all contributions summed up) 
C     ' This is the value above the yrast line. Erot must be added! 
      DO I = 0 , 1000 
C     ' 100 keV bins up to 100 MeV 
      Etab(K,I) = exp(-(0.1*REAL(I)-Eexc_mean)**2/(2.0 * Eexc_sigma)) 
      END DO 
C     ' 
C     ' Normalize excitation-energy distribution 
C     '   Scope 
      RintE = 0 
      DO I = 0 , 1000 
      RintE = RintE + Etab(K,I) 
      END DO 
      IF (  RintE .GT. 0  ) THEN 
      DO I = 0 , 1000 
      Etab(K,I) = Etab(K,I) / RintE 
      END DO 
      End If 
C     '   End Scope 
C     ' 
      END DO 
C     ' 
C     ' 
C     ' 
      End  
C     ' 
C     ' 
C     ' 
C     /' Subroutines '/ 
C     ' 
C     ' 
C     ' 
C     ' 
      Include "BEexp.FOR" 
      Include "BEldmTF.FOR" 
      Include "ShellMO.FOR" 
C     ' 
C     ' 
      INTEGER*4 FUNCTION U_Valid(I_Z,I_A)
      IMPLICIT NONE
      INTEGER*4 I_Z
      INTEGER*4 I_A
      INTEGER*4  Ivalid
      Ivalid = 1 
C     '   If I_A / I_Z < 210.E0/90.E0 
      IF (  I_A / I_Z .LT. 160.E0 / 76.E0 .OR. I_A / I_Z .GT. 
     *250.E0/90.E0  ) THEN 
      Ivalid = 0 
      End If 
      IF (  I_Z .LT. 76 .OR. I_Z .GT. 120  ) THEN 
      Ivalid = 0 
      End If 
      U_Valid = Ivalid 
C     ' U_Valid = 1 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION U_Delta_S0(I_Z,I_A)
      IMPLICIT NONE
      INTEGER*4 I_Z
      INTEGER*4 I_A
C     ' I_Z and I_A refer to the fissioning nucleus 
      REAL*4  Delta
      Delta = 0 
C     ' 
      IF (  I_Z .EQ. 89  ) THEN 
      IF (  I_A .EQ. 226  )  Delta = -0.3 
      End If 
C     ' 
      IF (  I_Z .EQ. 90  ) THEN 
      IF (  I_A .EQ. 228  )  Delta = 0.2 
      IF (  I_A .EQ. 229  )  Delta = 0.4 
      IF (  I_A .EQ. 230  )  Delta = 0.7 
      IF (  I_A .EQ. 231  )  Delta = 0.8 
      IF (  I_A .EQ. 232  )  Delta = 0.9 
      IF (  I_A .EQ. 233  )  Delta = 0.9 
      End If 
C     ' 
      IF (  I_Z .EQ. 92  )  Delta = 0.2 
C     'x 
      IF (  I_Z .EQ. 92 .AND. I_A .EQ. 233  )  Delta = 0.4 
C     'x 
      IF (  I_Z .EQ. 92 .AND. I_A .EQ. 234  )  Delta = 0.4 
C     'x 
C     ' 
      IF (  I_Z .GE. 93  )  Delta = -0.3 
C     'x 
C     ' 
      U_Delta_S0 = Delta 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION Getyield(E_rel,E_ref,E_shell,dE_defo,T_low,T_high,
     *T_high_mac,I_Mode)
      IMPLICIT NONE
      REAL*4 E_rel
      REAL*4 E_ref
      REAL*4 E_shell
      REAL*4 dE_defo
      REAL*4 T_low
      REAL*4 T_high
      REAL*4 T_high_mac
      INTEGER*4 I_Mode
C     /' E_rel: Energy relative to the fission-channel-specific barrier. '/ 
C     /' E_ref: technical quantity,avoids numerical problems. '/ 
C     /' E_shell: microscopic shell effect (washed out at high E*) '/ 
C     /' T_low: Effective temperature below barrier '/ 
C     /' T_high: Effective temperature above barrier '/ 
      REAL*4  Exp1
      REAL*4  Yield
      REAL*4  E_trans
C     ' Transition energy from CT to FG 
      DATA E_trans/8.0/
      REAL*4  E_backshift
      DATA E_backshift/3/
      REAL*4  F_trans,F_mod
      REAL*4  Rho_mac
      REAL*4  S_mac_CT,S_mac_FG,S_CT,S_FG,S_mac_trans,S_trans,DS_trans,
     *DS
C     ' 
      Exp1 = E_rel/T_low - E_ref/0.4 
C     ' energy far below barrier 
C     ' Subtraction of E_ref/0.4 to prevent numerical problems. 
      IF (  Exp1 .LT. -50  ) THEN 
      Yield = 0 
      Else 
      Yield = Exp(E_rel / T_high - E_ref/0.4) * 1.E0 / (1.E0 + 
     *Exp(-E_rel/ (T_high*T_low/(T_high-T_low) ) ) ) 
      End If 
C     ' The following block was an attempt to use a matching Fermi-gas level density 
C     ' above the critical pairing energy. It is not used,because it was not possible 
C     ' to match the temperatures (below and above) at the matching energy sufficiently well. 
C     /'     If I_Mode = 4 Then 
C     If E_rel > E_trans Then 
C     S_trans = E_trans/T_high            ' const. T entropy (with shell) at transition energy from real g.s. 
C     S_mac_trans = (E_trans + E_shell)/T_high_mac  ' const. T entropy (without shell) from macrosc. g.s. 
C     DS_trans = S_trans - S_mac_trans    ' remaining shell effect at transition energy in const. T. regime 
C     ' (difference in S = ratio in level density) 
C     DS = DS_trans            * exp(- (E_rel - E_trans) / 18.5 ) _    ' washing out with increasing E* 
C     * (TRusanov(E_trans+E_shell,I_A_CN) / TRusanov(E_rel+E_shell,I_A_CN) ) 
C     ' 
C     S_mac_FG = 2 * sqr(0.094 * I_A_CN * (E_rel + E_shell))                       + S_mac_trans - 2 * sqr(0.094 * I_A_CN * (E_trans + E_shell))                       - E_ref/0.4 
C     ' 
C     S_FG = S_mac_FG + DS 
C     ' 
C     'Print "*",DS_trans,DS 
C     'S_FG = S_mac_FG + DS_trans 
C     ' 
C     ' print "*"; E_rel;E_shell;E_backshift 
C     ' print "*";  2 * sqr(0.094 * I_A_CN *(E_rel + E_shell - E_backshift)); '              2 * sqr(0.094 * I_A_CN * (E_trans + E_shell - E_backshift));"*" 
C     ' print E_rel;" ";E_shell;T_high;T_high_mac;S_trans;S_mac_trans;DS;DS_trans;S_mac_FG;S_FG; '   (TRusanov(E_trans - E_backshift,I_A_CN) / TRusanov(E_rel - E_backshift,I_A_CN) ) 
C     ' Print E_backshift;I_A_CN;E_trans;E_shell 
C     ' sleep 
C     ' Print "*",Yield,exp(S_FG) 
C     Yield = exp(S_FG) 
C     End If 
C     '    End If   '/ 
      Getyield = Max(Yield,0.0) 
C     ' 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION F1(Z_S_A)
      IMPLICIT NONE
      REAL*4 Z_S_A
C     /' Fit to the lower part of the data '/ 
      REAL*4  Result
      Result = exp(-9.05E0 + 4.58E0 * Log(Z_S_A/2.3E0)) 
      F1 = Result 
      END
      REAL*4 FUNCTION F2(Z_S_A)
      IMPLICIT NONE
      REAL*4 Z_S_A
C     /' Fit to the upper part of the data '/ 
      REAL*4  Result
      Result = exp(12.08E0 - 3.27E0 * Log(Z_S_A/2.3E0)) 
      F2 = Result 
      END
C     ' 
      REAL*4 FUNCTION Masscurv(Z,A,RL,kappa)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      REAL*4 RL
      REAL*4 kappa
C     /'  Fit to  Data of Fig. 7 of                                             '/ 
C     /'  "Shell effect in the symmetric-modal fission of pre-actinide nuclei"  '/ 
C     /'  S. I. Mulgin,K.-H. Schmidt,A. Grewe,S. V. Zhdanov                  '/ 
C     /'  Nucl. Phys. A 640 (1998) 375 
C     /' (From fit of the width of the mass distributions.) '/                                         '/ 
      REAL*4  RI,Result1,Result2,Result
      REAL*4  Z_square_over_A
      REAL*4  ZsqrA
      REAL*4  c_rot
      DATA c_rot/600.0/
      REAL*4 F1 
      REAL*4 F2 
C     ' 
      Z_square_over_A = Z**2/A 
      RI = (A - 2*Z)/A 
      ZsqrA = Z_square_over_A * (1.E0 - kappa * RI**2) / (1.E0 - kappa 
     ** ((226.E0 - 2.E0*91.E0)/226.E0)**2) + c_rot * RL**2 / 
     *A**(7.0/3.0) 
C     ' Hasse & Myers 
C     '      + 0.0017 * RL^2 
C     ' 
      Result1 = F1(ZsqrA) 
      Result2 = F2(ZsqrA) 
      Result = Min(Result1,Result2) 
      Masscurv = Result 
C     ' 
      END
C     ' 
      REAL*4 FUNCTION Masscurv1(Z,A,RL,kappa)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      REAL*4 RL
      REAL*4 kappa
C     /'  Fit to  Data of Fig. 7 of                                             '/ 
C     /'  "Shell effect in the symmetric-modal fission of pre-actinide nuclei"  '/ 
C     /'  S. I. Mulgin,K.-H. Schmidt,A. Grewe,S. V. Zhdanov                  '/ 
C     /'  Nucl. Phys. A 640 (1998) 375 
C     /' (The left part assumed to be valid for the yields of the fission channels.) '/                                         '/ 
      REAL*4  RI,Result1,Result2,Result
C     '    Dim As Single A,A_central,Z 
      REAL*4  Z_square_over_A
      REAL*4  ZsqrA
      REAL*4  c_rot
      DATA c_rot/600.0/
      REAL*4 F1 
      REAL*4 F2 
C     ' 
C     'A_central = -28.8156 + Z * 2.86587  ' Stability line for heavy nuclei 
C     ' 
      Z_square_over_A = Z**2/A 
      RI = (A - 2*Z)/A 
      ZsqrA = Z_square_over_A * (1.E0 - kappa * RI**2) / (1.E0 - kappa 
     ** ((226.E0 - 2.E0*91.E0)/226.E0)**2) + c_rot * RL**2 / 
     *A**(7.0/3.0) 
C     ' Hasse & Myers 
C     '      + 0.0017 * RL^2 
C     ' 
C     'If ZsqrA < 36.0 Then   ' adjusted to Y(S2) in light nuclei (80<Z<92) 
C     '  ZsqrA = ZsqrA + 0.9 * (36.0 - ZsqrA) 
C     'End If 
C     ' 
      Result1 = F1(ZsqrA) 
      Result2 = F2(ZsqrA) 
      Result = Min(Result1,Result2) 
      Masscurv1 = Result1 
C     '  Masscurv1 = Result 
C     ' 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION De_Saddle_Scission(Z_CN_in,A_CN_in,ESHIFTSASCI)
      IMPLICIT NONE
      REAL*4 Z_CN_in
      REAL*4 A_CN_in
      REAL*4 ESHIFTSASCI
C     /' Energy release between saddle and scission '/ 
C     /' M. Asghar,R. W. Hasse,J. Physique C 6 (1984) 455 '/ 
      REAL*4  Zsquare_over_Athird
      REAL*4  Result
      REAL*4  R_odd_even
      Zsquare_over_Athird = Z_CN_in**2 / A_CN_in**0.333333 
      Result = (31.E0 - 11.E0) / (1550.E0 - 1300.E0) * 
     *(Zsquare_over_Athird - 1300.E0 + ESHIFTSASCI) + 11.E0 
C     ' This formula with ESHIFTSASCI = 0 is the parameterisation of the results 
C     ' of Ashgar and Hasse,JPC 6 (1984) 455,see 
C     ' F. Rejmund,A. V. Ignatyuk,A. R. Junghans,K.-H. Schmidt 
C     ' Nucl. Phys. A 678 (2000) 215 
      Result = max(Result,0.0) 
      De_Saddle_Scission = Result 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION TEgidy(A,DU,Fred)
      IMPLICIT NONE
      REAL*4 A
      REAL*4 DU
      REAL*4 Fred
C     /' Temperature parameter of the constant-temperature formula for the 
C     nuclear level density. 
C     Input parameters: A = Mass number of nucleus 
C     DU = Shell effect (corrected for pairing:P=0 for odd-A nuclei) 
C     From "Correlations between the nuclear level density parameters" 
C     Dorel Bucurescu,Till von Egidy 
C     Phys. Rev. C 72 (2005) 067304    and 
C     "Systematics of nuclear level density parameters" 
C     Dorel Bucurescu,Till von Egidy 
C     J. Phys. G: Nucl. Part. Phys. 31 (2005) S1675 and 
C     "Systematics of nuclear level density parameters" 
C     Till von Egidy,Dorel Bucurescu 
C     Phys. Rev. C 72 (2005) 044311 '/ 
      REAL*4  Temp_smooth,Temp,T_Fac
C     ' Temp_smooth = 17.45E0 / (A^0.666667E0) 
C     ' Temp = (17.45E0 - 0.51E0 * DU + 0.051 * DU^2) / (A^0.666667E0) 
      Temp_smooth = 1.0 / (0.0570 * A**0.6666667) 
      Temp = 1.0 / ( (0.0570 + 0.00193*DU) * A**0.6666667) 
C     ' from  PRC 80 (2009) 054310 
      T_Fac = Temp / Temp_smooth 
      Temp = Temp * Fred 
C     /' (For influence of deformation) '/ 
      TEgidy = Temp 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION TRusanov(E,A)
      IMPLICIT NONE
      REAL*4 E
      REAL*4 A
C     /' Fermi-gas level density,parameterisation of Rusanov et al. '/ 
      REAL*4  Emin
C     ' critical pairing energy 
      DATA Emin/8/
      REAL*4  Eeff
      IF (  E .LT. Emin  ) THEN 
      Eeff = Emin 
C     ' Introduced Sept. 2021 
      Else 
      Eeff = E 
      END IF 
      TRusanov = SQRT(E / (0.094E0 * A) ) 
      END
C     ' 
      REAL*4 FUNCTION LyMass(Z,A,beta)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      REAL*4 beta
C     ' 
C     /' liquid-drop mass,Myers & Swiatecki,Lysekil,1967  '/ 
C     /' pure liquid drop,without pairing and shell effects '/ 
C     ' 
C     /' On input:    Z     nuclear charge of nucleus        '/ 
C     /'              N     number of neutrons in nucleus    '/ 
C     /'              beta  deformation of nucleus           '/ 
C     /' On output:   binding energy of nucleus              '/ 
C     ' 
      REAL*4  pi
      PARAMETER (pi=3.14159)
      REAL*4  N
      REAL*4  alpha
      REAL*4  XCOM,XVS,XE,EL
C     ' 
      N = A - Z 
      alpha = SQRT(5.E0/(4.E0*pi)) * beta 
      XCOM = 1.E0 - 1.7826E0 * ((A - 2.E0*Z)/A)**2 
C     /' factor for asymmetry dependence of surface and volume term '/ 
      XVS = - XCOM * (15.4941E0*A                    - 
     *17.9439E0*A**(2.E0/3.E0)*(1.E0+0.4E0*Alpha**2)) 
C     /' sum of volume and surface energy '/ 
      XE = Z**2 * (0.7053E0/A**(1.E0/3.E0)*(1.E0-0.2E0*Alpha**2)        
     *           - 1.1529E0/A) 
      EL = XVS + XE 
C     /'   EL = EL + LyPair(Z,A); '/ 
      LyMass = EL 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION LyPair(Z,A)
      IMPLICIT NONE
      INTEGER*4 Z
      INTEGER*4 A
C     /' Calculates pairing energy '/ 
C     /' odd-odd nucleus:   Lypair = 0 '/ 
C     /' even-odd nucleus:  Lypair = -12/sqr(A) '/ 
C     /' even-even nucleus: Lypair = -2*12/sqr(A) '/ 
      REAL*4  E_PAIR
C     ' 
      E_PAIR = - 12.E0 / SQRT(REAL(A)) * REAL( ( MOD((Z+1) , 2) + 
     *MOD((A-Z+1) , 2)) ) 
C     ' 
      Lypair = E_PAIR 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION TFPair(Z,A)
      IMPLICIT NONE
      INTEGER*4 Z
      INTEGER*4 A
C     /' Pairing energy from Thomas-Fermi model of Myers and Swiatecki '/ 
C     /' Shifted that TFPair is zero for odd-odd nuclei '/ 
      INTEGER*4  N
      REAL*4  E_Pair
      N = A - Z 
      IF (   MOD(Z,2)  .EQ. 0 .AND.  MOD(N,2)  .EQ. 0  ) THEN 
C     /' even-even '/ 
      E_Pair = - 4.8E0 / Z**0.333333E0 - 4.8E0 / N**0.333333E0 + 6.6E0 
     */ A**0.666666E0 
      END IF 
      IF (   MOD(Z,2)  .EQ. 0 .AND.  MOD(N,2)  .EQ. 1  ) THEN 
C     /' even Z,odd N '/ 
      E_Pair = - 4.8E0 / Z**0.333333E0 + 6.6E0 / A**0.666666E0 
      END IF 
      IF (   MOD(Z,2)  .EQ. 1 .AND.  MOD(N,2)  .EQ. 0  ) THEN 
C     /' odd Z,even N '/ 
      E_Pair = - 4.8E0 / N**0.333333E0 + 6.6E0 / A**0.666666E0 
      END IF 
      IF (   MOD(Z,2)  .EQ. 1 .AND.  MOD(N,2)  .EQ. 1  ) THEN 
C     /' odd N,odd N '/ 
      E_Pair = 0.0 
      END IF 
      TFPair = E_Pair 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION Pmass(Z,A,beta)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      REAL*4 beta
C     /' Liquid-drop model of Pearson,2001 '/ 
      REAL*4  N,EA,BE
      REAL*4  avol
      DATA avol/-15.65/
      REAL*4  asf
      DATA asf/17.63/
      REAL*4  r0
      DATA r0/1.233/
      REAL*4  asym
      DATA asym/27.72/
      REAL*4  ass
      DATA ass/-25.60/
      REAL*4  alpha
      REAL*4  pi
      PARAMETER (pi=3.14159)
C     ' 
      N = A - Z 
      alpha = SQRT(5.E0/(4.E0*pi)) * beta 
      EA = avol + asf * A**(-0.333333)*(1.E0+0.4E0*Alpha**2) + 0.6E0 * 
     *1.44E0 * Z**2 / (A**1.333333 * r0 )*(1.E0-0.2E0*Alpha**2) + (asym 
     *+ ass * A**(-0.333333)) * (N-Z)**2 / A**2 
      BE = EA * A 
      Pmass = BE 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION FEDEFOP(Z,A,beta)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      REAL*4 beta
C     /' According to liquid-drop model of Pearson 2001 '/ 
      REAL*4  asf
      DATA asf/17.63/
      REAL*4  r0
      DATA r0/1.233/
      REAL*4  N,Alpha
      REAL*4  pi
      PARAMETER (pi=3.14159)
C     ' 
      N = A - Z 
      alpha = SQRT(5.E0/(4.E0*pi)) * beta 
      FEDEFOP = asf * A**(0.666667)*(0.4E0*Alpha**2) - 0.6E0 * 1.44E0 * 
     *Z**2 / (A**0.333333 * r0 )*(0.2E0*Alpha**2) 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION FEDEFOLys(Z,A,beta)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      REAL*4 beta
      REAL*4 LYMASS 
      FEDEFOLys = Lymass(Z,A,beta) - Lymass(Z,A,0.0) 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION LDMass(Z,A,beta)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      REAL*4 beta
      REAL*4  N,BEtab
      REAL*4 LYMASS 
      REAL*4 FEDEFOLYS 
      REAL*4 BEldmTF 
      N = A - Z 
      BEtab = BEldmTF(NINT(N),NINT(Z)) + 2.0 * 12.0 / SQRT(REAL(A)) - 
     *0.00001433*Z**2.39 
C     ' The values in BEtab are the negative binding energies! 
C     ' Pairing in Thomas Fermi masses is zero for Z,N even ! 
      IF (  BEtab .EQ. 0.0  ) THEN 
      BEtab = Lymass(Z,A,0.0) 
C     '         Print "Warning: Binding energy of Z=";Z;",A=";A;" not in mass table,";                         " replaced by LYMASS" 
C     '         Print "I_Mode = ";I_Mode 
      End If 
      LDMASS = BEtab + FEDEFOLys(Z,A,beta) 
      END
C     ' 
      REAL*4 FUNCTION AME2012(IZ,IA)
      IMPLICIT NONE
      INTEGER*4 IZ
      INTEGER*4 IA
C     ' Masses from the 2003 mass evaluation,complemented by TF masses 
C     ' and Lysekil masses. 
      REAL*4  BEexpval
      REAL*4  Z,A,N
      INTEGER*4  INeu
      REAL*4 LYPAIR 
      REAL*4 U_SHELL 
      REAL*4 LDMASS 
      REAL*4 BEexp 
      INeu = IA - IZ 
      A = REAL(IA) 
      Z = REAL(IZ) 
      N = A - Z 
      BEexpval = BEexp(INeu,IZ) 
      IF (  BEexpval .GT. -1.E10  ) THEN 
      AME2012 = BEexpval 
      Else 
      AME2012 = Ldmass(Z,A,0.0) + U_SHELL(IZ,IA) + Lypair(IZ,IA) 
      End If 
      END
C     ' 
      REAL*4 FUNCTION U_SHELL(Z,A)
      IMPLICIT NONE
      INTEGER*4 Z
      INTEGER*4 A
      INTEGER*4  N
      REAL*4  Res
      REAL*4 ShellMO 
      N = A - Z 
      Res = ShellMO(N,Z) 
      IF (  Res .GT. 0.0  )  Res = 0.3 * Res 
C     ' KHS (12. Feb. 2012) 
C     '      ' The positive shell effects for deformed nuclei seem to be too positive 
C     ' This gives too many high-energetic prompt neutrons. 
      U_SHELL = Res 
      END
C     ' 
      REAL*4 FUNCTION U_SHELL_exp(IZ,IA)
      IMPLICIT NONE
      INTEGER*4 IZ
      INTEGER*4 IA
      REAL*4  Res
      REAL*4  Z,A
      REAL*4 LDMASS 
      REAL*4 LYPAIR 
      REAL*4 AME2012 
      Z = REAL(IZ) 
      A = REAL(IA) 
C     '   Res = 2.0 * ( AME2012(IZ,IA) - Lypair(IZ,IA) - LDMass(Z,A,0.0) )    '          - 0.25 * ( AME2012(IZ,IA-1) - Lypair(IZ,IA-1) - LDMass(Z,A-1.0,0.0) )    '          - 0.25 * ( AME2012(IZ,IA+1) - Lypair(IZ,IA+1) - LDMass(Z,A+1.0,0.0) )    '          - 0.25 * ( AME2012(IZ+1,IA+1) - Lypair(IZ+1,IA+1) - LDMass(Z+1.0,A+1.0,0.0) )    '          - 0.25 * ( AME2012(IZ-1,IA-1) - Lypair(IZ-1,IA-1) - LDMass(Z-1.0,A-1.0,0.0) ) 
      Res = 0.5 * ( AME2012(IZ,IA) - Lypair(IZ,IA) - LDMass(Z,A,0.0) ) 
     *+ 0.125 * ( AME2012(IZ,IA-1) - Lypair(IZ,IA-1) - LDMass(Z,A-1.0,
     *0.0) ) + 0.125 * ( AME2012(IZ,IA+1) - Lypair(IZ,IA+1) - LDMass(Z,
     *A+1.0,0.0) ) + 0.125 * ( AME2012(IZ+1,IA+1) - Lypair(IZ+1,IA+1) - 
     *LDMass(Z+1.0,A+1.0,0.0) ) + 0.125 * ( AME2012(IZ-1,IA-1) - 
     *Lypair(IZ-1,IA-1) - LDMass(Z-1.0,A-1.0,0.0) ) 
      U_SHELL_exp = Res 
      END
C     ' 
      REAL*4 FUNCTION U_SHELL_EO_exp(IZ,IA)
      IMPLICIT NONE
      INTEGER*4 IZ
      INTEGER*4 IA
C     ' Returns experimental shell and even-odd staggering, 
C     ' just the difference of experimental and macroscopic mass. 
      REAL*4  Res
      REAL*4  Z,A
      REAL*4 LDMASS 
      REAL*4 LYPAIR 
      REAL*4 AME2012 
      Z = REAL(IZ) 
      A = REAL(IA) 
      Res = AME2012(IZ,IA) - LDMass(Z,A,0.0) 
      U_SHELL_EO_exp = Res 
      END
C     ' 
C     ' 
C     ' 
      REAL*4 FUNCTION U_MASS(Z,A)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
C     /' LD + congruence energy + shell (no pairing) '/ 
      REAL*4  BE
      REAL*4 U_SHELL 
      REAL*4 LDMASS 
      IF (  Z .LT. 0 .OR. A .LT. 0  ) THEN 
C     '       Print "U_Mass: Z,A",Z,A 
      End If 
      BE = Ldmass(Z,A,0.0) + U_SHELL(NINT(Z),NINT(A)) 
C     '    BE = AME2012(Cint(Z),Cint(A)) - Lypair(Z,A) 
C     '    BE = Lymass(Z,A,0.0) + U_Shell(CInt(Z),CInt(A)) 
C     '    BE = Lymass(Z,A,0.0) 
      U_MASS = BE 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION ECOUL(Z1,A1,beta1,Z2,A2,beta2,d)
      IMPLICIT NONE
      REAL*4 Z1
      REAL*4 A1
      REAL*4 beta1
      REAL*4 Z2
      REAL*4 A2
      REAL*4 beta2
      REAL*4 d
C     ' 
C     /' Coulomb potential between two nuclei                    '/ 
C     /' surfaces are in a distance of d                         '/ 
C     /' in a tip to tip configuration                           '/ 
C     ' 
C     /' approximate formulation                                 '/ 
C     /' On input: Z1      nuclear charge of first nucleus       '/ 
C     /'           A1      mass number of irst nucleus   '/ 
C     /'           beta1   deformation of first nucleus          '/ 
C     /'           Z2      nuclear charge of second nucleus      '/ 
C     /'           A2      mass number of second nucleus  '/ 
C     /'           beta2   deformation of second nucleus         '/ 
C     /'           d       distance of surfaces of the nuclei    '/ 
C     ' 
      REAL*4  N1,N2,recoul
      REAL*4  dtot
      REAL*4  r0
      DATA r0/1.16/
C     ' 
      N1 = A1 - Z1 
      N2 = A2 - Z2 
      dtot = r0 *( (Z1+N1)**0.3333333E0 * (1.E0+0.6666667E0*beta1)      
     *        + (Z2+N2)**0.3333333E0 * (1.E0+0.6666667E0*beta2) ) + d 
      REcoul = Z1 * Z2 * 1.44E0 / dtot 
C     ' 
      ECOUL = REcoul 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION beta_light(Z,betaL0,betaL1)
      IMPLICIT NONE
      INTEGER*4 Z
      REAL*4 betaL0
      REAL*4 betaL1
C     /' Deformation of light fission fragment for S1 and S2 '/ 
C     /' Systematic correlation Z vs. beta for deformed shells '/ 
C     /' Z of fission fragment '/ 
      REAL*4  beta
      beta = (Z - betaL0) * betaL1/20.E0 
      beta_light = beta 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION beta_heavy(Z,betaH0,betaH1)
      IMPLICIT NONE
      INTEGER*4 Z
      REAL*4 betaH0
      REAL*4 betaH1
C     /' Deformation of heavy fission fragment for S2 '/ 
C     /' Systematic correlation Z vs. beta for deformed shells '/ 
C     /' Z of fission fragment '/ 
      REAL*4  beta
      beta = (Z - betaH0) * betaH1/20.E0 
      beta_heavy = beta 
      END
C     ' 
C     ' 
C     ' 
      REAL*4 FUNCTION Z_equi(ZCN,A1,A2,beta1,beta2,d,Imode)
      IMPLICIT NONE
      INTEGER*4 ZCN
      INTEGER*4 A1
      INTEGER*4 A2
      REAL*4 beta1
      REAL*4 beta2
      REAL*4 d
      INTEGER*4 Imode
C     /' Determines the minimum potential of the scission-point configuration 
C     represented by two deformed nuclei divided by a tip distance d. 
C     A1,A2,beta1,beta2,d are fixed,Z1 is searched for and returned on output.  '/ 
C     ' 
C     /' ZCN: Z of fissioning nucleus '/ 
C     /' A1: A of first fission fragment '/ 
C     /' A2: A of second fission fragment '/ 
C     /' beta1: deformation of first fission fragment '/ 
C     /' beta2: deformation of second fission fragment '/ 
C     /' d: tip distance '/ 
C     ' 
      REAL*4  RZ_equi
      REAL*4  RA1,RA2,RZCN,RACN
      REAL*4  Z1UCD,Z2UCD
      REAL*4  re1,re2,re3,eps1,eps2,DZ_Pol
C     /' help variables '/ 
      REAL*4 ECOUL 
      REAL*4 LYMASS 
C     ' 
      RA1 = REAL(A1) 
      RA2 = REAL(A2) 
      RZCN = REAL(ZCN) 
      RACN = RA1 + RA2 
      Z1UCD = RA1 / (RA1 + RA2) * RZCN 
      Z2UCD = RZCN - Z1UCD 
      re1 = LyMass( Z1UCD-1.E0,RA1,beta1 ) + LyMass( Z2UCD+1.E0,RA2,
     *beta2 ) + ECoul( Z1UCD-1.E0,RA1,beta1,Z2UCD+1.E0,RA2,beta2,d ) 
      re2 = LyMass( Z1UCD,RA1,beta1) + LyMass( Z2UCD,RA2,beta2) + 
     *ECoul( Z1UCD,RA1,beta1,Z2UCD,RA2,beta2,d ) 
      re3 = LyMass( Z1UCD+1.E0,RA1,beta1 ) + LyMass( Z2UCD-1.E0,RA2,
     *beta2 ) + ECoul( Z1UCD+1.E0,RA1,beta1,Z2UCD-1.E0,RA2,beta2,d ) 
      eps2 = ( re1 - 2.E0*re2 + re3 ) / 2.E0 
      eps1 = ( re3 - re1 ) / 2.E0 
      DZ_Pol = -eps1 / ( 2.E0 * eps2 ) 
C     ' 
      IF (  DZ_Pol .GT. 2 .OR. DZ_Pol .LT. -2  )  DZ_Pol = 0 
C     ' 
      RZ_equi = Z1UCD + DZ_POL 
      Z_equi = RZ_equi 
      END
C     ' 
C     ' 
      SUBROUTINE Beta_opt_light(A1,A2,Z1,Z2,d,beta2_imposed,beta1_opt)
      IMPLICIT NONE
      REAL*4 A1
      REAL*4 A2
      REAL*4 Z1
      REAL*4 Z2
      REAL*4 d
      REAL*4 beta2_imposed
      REAL*4 beta1_opt
C     /' Determines the optimum deformation of the light fragment when the deformation of the 
C     heavy fragment is imposed. '/ 
C     ' 
      REAL*4  beta1,dbeta1,beta1_prev,beta1_next
      REAL*4  Uguess,Uplus,Uminus,Uprev,Unext
      INTEGER*4  I
      REAL*4 ECOUL 
      REAL*4 LYMASS 
C     ' 
C     /' List('Beta_opt_light called with '); 
C     List(A1,A2,Z1,Z2,d,beta2_imposed,beta1_opt); 
C     DCL Byes Bit(1) aligned; 
C     Call GPYES('Continue',Byes); '/ 
      beta1 = 0.5 
      dbeta1 = 0.01 
      Uguess = LyMass(Z1,A1,beta1) + Lymass(Z2,A2,beta2_imposed) + 
     *ECoul(Z1,A1,beta1,Z2,A2,beta2_imposed,d) 
      Uplus = LyMass(Z1,A1,beta1 + dbeta1) + Lymass(Z2,A2,
     *beta2_imposed) + ECoul(Z1,A1,beta1 + dbeta1,Z2,A2,beta2_imposed,
     *d) 
      Uminus = LyMass(Z1,A1,beta1 - dbeta1) + Lymass(Z2,A2,
     *beta2_imposed) + ECoul(Z1,A1,beta1 - dbeta1,Z2,A2,beta2_imposed,
     *d) 
      IF (  Uplus .GT. Uguess .AND. Uminus .GT. Uguess  ) THEN 
      beta1_opt = beta1 
      Else 
      IF (  Uplus .LT. Uguess  )  dbeta1 = 0.01 
      IF (  Uminus .LT. Uguess  )  dbeta1 = -0.01 
      Unext = Uguess 
      beta1_next = beta1 
      DO I = 1 , 10000 
      beta1_prev = beta1_next 
      Uprev = Unext 
      beta1_next = beta1_prev + dbeta1 
      Unext = LyMass(Z1,A1,beta1_next) + Lymass(Z2,A2,beta2_imposed) + 
     *ECoul(Z1,A1,beta1_next,Z2,A2,beta2_imposed,d) 
      IF (  Unext .GE. Uprev  )  Exit 
      END DO 
      beta1_opt = beta1_prev 
      END IF 
C     ' 
      END
C     ' 
C     ' 
      SUBROUTINE Beta_Equi(A1,A2,Z1,Z2,d,beta1prev,beta2prev,beta1opt,
     *beta2opt)
      IMPLICIT NONE
      REAL*4 A1
      REAL*4 A2
      REAL*4 Z1
      REAL*4 Z2
      REAL*4 d
      REAL*4 beta1prev
      REAL*4 beta2prev
      REAL*4 beta1opt
      REAL*4 beta2opt
C     /' Determines the minimum potential of the scission-point configuration 
C     represented by two deformed nuclei,divided by a tip distance d. 
C     A1,A2,Z1,Z2,d are fixed,beta1 and beta2 are searched for and returned on output '/ 
C     ' 
      INTEGER*4  B_analytical
      DATA B_analytical/0/
C     ' Switch to use the analytical approximation 
C     ' that replaces the long numerical calculation. 
      REAL*4  x,y,xcoul
      REAL*4  xcoul236U
      DATA xcoul236U/1369.64/
C     ' 
      REAL*4  beta1,beta2
C     ' 
C     '      Dim As Double U,Uprev,Ulast,Ubest,Uopt 
      REAL*4  U,Uprev,Ulast,Ubest,Uopt
C     ' 
C     '      Dim As Double sbeta1,sbeta2 
      REAL*4  sbeta1
      DATA sbeta1/0/
      REAL*4  sbeta2
      DATA sbeta2/0/
C     ' 
      INTEGER*4  N,N1,N2
      INTEGER*4  Nopt
      DATA Nopt/0/
C     ' 
C     '      Dim As Double eps = 5.E-4 
      REAL*4  eps
      DATA eps/5.E-4/
C     ' 
      INTEGER*4  I
      REAL*4 LYMASS 
      REAL*4 ECOUL 
C     ' 
      IF (  B_analytical .EQ. 0  ) THEN 
C     ' Numerical algorithm 
C     ' 
      beta1 = beta1prev 
      beta2 = beta2prev 
      Uprev = LyMass(Z1,A1,beta1) + LyMass(Z2,A2,beta2) + ECoul(Z1,A1,
     *beta1,Z2,A2,beta2,d) 
      Uopt = Uprev 
C     ' 
C     /' Test slope of variation of U '/ 
      beta1 = beta1prev + eps 
      U = 1.E30 
C     ' 
      beta2 = beta2prev 
C     '     For beta2 = beta2prev to 0 Step -eps 
      DO I = 1 , Int(beta2prev/eps) 
      beta2 = beta2 - eps 
      Ulast = U 
      U = LyMass(Z1,A1,beta1) + LyMass(Z2,A2,beta2) + ECoul(Z1,A1,beta1,
     *Z2,A2,beta2,d) 
      IF (  U .GT. Ulast  ) THEN 
      Exit 
      Else 
      Ubest = U 
      END IF 
      END DO 
      IF (  Ubest .LT. Uopt  ) THEN 
      Uopt = Ubest 
      sbeta1 = eps 
      sbeta2 = -eps 
      END IF 
C     ' 
      U = 1.E30 
      beta2 = beta2prev 
C     '   For beta2 = beta2prev To 1 Step eps 
      DO I = 1 , Int((1 - beta2prev)/eps) 
      beta2 = beta2 + eps 
      Ulast = U 
      U = LyMass(Z1,A1,beta1) + LyMass(Z2,A2,beta2) + ECoul(Z1,A1,beta1,
     *Z2,A2,beta2,d) 
      IF (  U .GT. Ulast  ) THEN 
      Exit 
      Else 
      Ubest = U 
      END IF 
      END DO 
      IF (  Ubest .LT. Uopt  ) THEN 
      Uopt = Ubest 
      sbeta1 = eps 
      sbeta2 = eps 
      End If 
C     ' 
      beta1 = beta1prev - eps 
      U = 1.E30 
      beta2 = beta2prev 
C     '   For beta2 = beta2prev To 0 Step -eps 
      DO I = 1 , Int(beta2prev/eps) 
      beta2 = beta2 - eps 
      Ulast = U 
      U = LyMass(Z1,A1,beta1) + LyMass(Z2,A2,beta2) + ECoul(Z1,A1,beta1,
     *Z2,A2,beta2,d) 
      IF (  U .GT. Ulast  ) THEN 
      Exit 
      Else 
      Ubest = U 
      End If 
      END DO 
      IF (  Ubest .LT. Uopt  ) THEN 
      Uopt = Ubest 
      sbeta1 = -eps 
      sbeta2 = -eps 
      END IF 
C     ' 
      U = 1.E30 
      beta2 = beta2prev 
C     '   For beta2 = beta2prev To 1 Step eps 
      DO I = 1 , Int((1-beta2prev)/eps) 
      beta2 = beta2 + eps 
      Ulast = U 
      U = LyMass(Z1,A1,beta1) + LyMass(Z2,A2,beta2) + ECoul(Z1,A1,beta1,
     *Z2,A2,beta2,d) 
      IF (  U .GT. Ulast  ) THEN 
      Exit 
      Else 
      Ubest = U 
      END IF 
      END DO 
      IF (  Ubest .LT. Uopt  ) THEN 
      Uopt = Ubest 
      sbeta1 = -eps 
      sbeta2 = eps 
      END IF 
C     ' 
C     ' 
      Ubest = Lymass(Z1,A1,beta1prev) + Lymass(Z2,A2,beta2prev) + 
     *ECoul(Z1,A1,beta1prev,Z2,A2,beta2prev,d) 
      U = Lymass(Z1,A1,beta1prev+REAL(sbeta1)) + Lymass(Z2,A2,
     *beta2prev+REAL(sbeta2)) + ECoul(Z1,A1,beta1prev+sbeta1,Z2,A2,
     *beta2prev+REAL(sbeta2),d) 
C     ' 
C     '   L1: 
      DO N = 1 , 1000 
C     ' 
C     '   L2: 
      DO N1 = 1 , N 
      N2 = N-N1 
      beta1 = beta1prev + sbeta1*N1 
      beta2 = beta2prev + sbeta2*N2 
      U = LyMass(Z1,A1,beta1) + LyMass(Z2,A2,beta2) + ECoul(Z1,A1,beta1,
     *Z2,A2,beta2,d) 
      IF (  U .LT. Ubest  ) THEN 
      Ubest = U 
      beta1opt = beta1 
      beta2opt = beta2 
      Nopt = N 
      END IF 
      END DO 
      IF (  N-Nopt .GT. 2  )  Exit 
      END DO 
C     ' 
C     ' 
      Else 
C     ' Analytical approximation 
C     ' Must be adapted if the relevant parameters of GEF are modified! 
      xcoul = (Z1 + Z2)**2 / (A1 + A2)**(1.0/3.0) 
      x = (Z1 / (Z1 + Z2))**(xcoul/xcoul236U) 
      y = 1.2512E-4 + 0.00122851*x - 0.00267707*x**2 + 0.00372901*x**3 
     *- 0.00219903*x**4 
      beta1opt = y * xcoul 
C     ' 
      x = (Z2 / (Z1 + Z2))**(xcoul/xcoul236U) 
      y = 1.2512E-4 + 0.00122851*x - 0.00267707*x**2 + 0.00372901*x**3 
     *- 0.00219903*x**4 
      beta2opt = y * xcoul 
C     ' 
      End If 
C     ' 
      END
C     ' 
      REAL*4 FUNCTION U_Ired(Z,A)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
C     ' Effective moment of inertia by pairing with correction for excitation energy 
      REAL*4  I_rigid_spher,IfragEff
C     ' 
C     ' 
      I_rigid_spher = 1.16E0**2 * A**1.6667E0 / 103.8415E0 
C     '   IfragEff = I_rigid_spher + 0.003 * A^(4.0/3.0) * U_shell(Cint(Z),Cint(A)) 
C     '   IfragEff = I_rigid_spher + 0.005 * A^(4.0/3.0) * U_shell(Cint(Z),Cint(A)) 
C     ' reduction due to shell (Deleplanque et al. PRC 69 (2004) 044309) 
      IfragEff = 0.45 * I_rigid_spher 
C     ' Effect of superfluidity 
C     '   IfragEff = 0.65 * IfragEff   ' Average effect of superfluidity and deformation 
C     ' 
      U_Ired = IfragEff 
      END
C     ' 
      REAL*4 FUNCTION U_IredFF(Z,A)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
C     ' Effective moment of inertia by pairing with correction for excitation energy 
C     ' of final fission fragments 
C     ' 
      REAL*4 U_Ired 
      REAL*4 U_I_Shell 
C     ' 
      U_IredFF = U_Ired(Z,A) * U_I_Shell(Z,A) 
      END
C     ' 
      REAL*4 FUNCTION U_I_Shell(Z,A)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      INTEGER*4  N_shells(6)
C     ' Shell effect on the effective moment of inertia 
      INTEGER*4  I
      REAL*4  dNmin,dZmin,dNsubmin
      REAL*4  Inv_add
      DATA Inv_add/0/
      REAL*4  I_inv_add_Z
      DATA I_inv_add_Z/0/
      REAL*4  I_inv_add_N
      DATA I_inv_add_N/0/
      REAL*4  I_inv_add_Nsub
      DATA I_inv_add_Nsub/0/
      N_shells(1) = 20 
      N_shells(2) = 28 
      N_shells(3) = 50 
      N_shells(4) = 82 
      N_shells(5) = 126 
      N_shells(6) = 56 
      dNmin = 100 
      dZmin = 100 
      dNsubmin = 100 
      DO I = 1 , 5 
      dZmin = Min(dZmin,Abs(N_shells(I) - Z)) 
      END DO 
C     ' 
      DO I = 1 , 5 
      dNmin = Min(dNmin,Abs(N_shells(I) - (A-Z))) 
      END DO 
C     ' 
      dNsubmin = Abs(N_shells(6) - (A-Z)) 
C     ' 
C     ' Effect of shells: 
      IF (  dZmin .LT. 10.0  ) THEN 
C     '        I_inv_add_Z = 0.33 * (6.0 * sqr(A/140.) - dZmin) * sqr(140./A) 
      I_inv_add_Z = 0.33 * (6.0 * SQRT(A/140.0) - dZmin) * 
     *(140.0/A)**1.5 
C     ' A^(-1/3) dependence: "A simple phenomenology for 2gamma+ states", 
C     ' N. V. Zamfir,D. Bucurescu,R. F. Casten,M. Ivascu, 
C     ' Phys. Lett. B 241 (1990) 463 
      I_inv_add_Z = Max(I_inv_add_Z,0.0) 
      End If 
      IF (  dNmin .LT. 10.0  ) THEN 
C     '        I_inv_add_N = 0.42 * (8.0 * sqr(A/140.) - dNmin) * sqr(140./A) 
      I_inv_add_N = 0.42 * (8.0 * SQRT(A/140.0) - dNmin) * 
     *(140.0/A)**1.5 
      I_inv_add_N = Max(I_inv_add_N,0.0) 
      End If 
      IF (  DNsubmin .LT. 6.0  ) THEN 
C     '    I_inv_add_Nsub = 1.7 * (4.0 - dNsubmin) * (1.0 - 0.32 * Abs(40.0-Z)) 
      I_inv_add_Nsub = 1.7 * (4.0 - dNsubmin) * (1.0 - 0.18 * 
     *Abs(40.0-Z)) 
C     ' N = 56 subshell only around Z = 40 
      I_inv_add_Nsub = Max(I_inv_add_Nsub,0.0) 
      End If 
      U_I_shell = 1.0 / (1.0 + Max(I_inv_add_N,I_inv_add_Nsub) + 
     *I_inv_add_Z) 
C     'Print "*",I_inv_add_Z,I_inv_add_N,I_inv_add_Nsub,1.0 / (1.0 + Max(I_inv_add_N,I_inv_add_Nsub) + I_inv_add_Z) 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION U_alev_ld(Z,A)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
C     '  U_alev_ld = 0.073 * A + 0.095 * A^0.666667  'Ignatyuk (1970's) 
      U_alev_ld = 0.078 * A + 0.115 * A**0.6666667 
C     ' Ignatyuk (Bologna 2000) 
C     '  U_alev_ld = 0.089 * A    ' only volume term 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION U_Temp(Z,A,E,Ishell,Ipair,Tscale,Econd,Etrans)
      IMPLICIT NONE
      REAL*4 Z
      REAL*4 A
      REAL*4 E
      INTEGER*4 Ishell
      INTEGER*4 Ipair
      REAL*4 Tscale
      REAL*4 Econd
      REAL*4 Etrans
C     ' Temperature (modified Gilbert-Cameron composite level density) 
C     ' KHS (10. 2. 2012) 
      REAL*4  alev
      REAL*4  Eeff0,Eeff1,E1,Rho0,Rho1,TCT,TFG
      REAL*4  fgamma
      DATA fgamma/0.055/
      REAL*4  RShell,RPair,Res
      REAL*4 U_ALEV_LD 
      REAL*4 U_SHELL 
      REAL*4 LYPAIR 
      REAL*4 TEGIDY 
C     ' Used global parameters: Tscale 
C     '   alev = U_alev_ld(Z,A) * 1.1   ' Factor adjusted to high-energy prompt neutrons in U235(nth,f) 
      alev = U_alev_ld(Z,A) * 0.95 
C     ' " with the correction for non-constant T (FG range) 
C     '  alev = U_alev_ld(Z,A) 
C     ' 
      IF (  Ishell .EQ. 1  ) THEN 
      RShell = U_Shell(NINT(Z),NINT(A)) 
      Else 
      RShell = 0.0 
      End If 
      TCT = TEgidy(A,RShell,Tscale) 
C     ' 
      IF (  Ipair .EQ. 1  ) THEN 
      RPair = Lypair(NINT(Z),NINT(A)) 
      Else 
      Rpair = 0.0 
      End If 
      Eeff0 = E - Econd + RPair + Rshell*(1.0 - exp(-fgamma * E)) 
C     ' 
      IF (  Eeff0 .GT. 0.5  ) THEN 
C     '       Eeff1 = Eeff0 + 0.1 
      E1 = E + 0.1 
      Eeff1 = E1 - Econd + RPair + Rshell*(1.0 - exp(-fgamma * E1)) 
      Rho0 = 1.E0/Eeff0**1.25 * exp(2.E0 * SQRT(alev * Eeff0)) 
      Rho1 = 1.E0/Eeff1**1.25 * exp(2.E0 * SQRT(alev * Eeff1)) 
C     '         Rho0 = 1.E0/Eeff0 * exp(2.E0 * sqr(alev * Eeff0)) 
C     '         Rho1 = 1.E0/Eeff1 * exp(2.E0 * sqr(alev * Eeff1)) 
      TFG = 0.1E0 / (log(Rho1) - log(Rho0)) 
      Else 
      TFG = 0.0 
      End If 
      Res = TCT 
      IF (  TFG .GT. Res  )  Res = TFG 
C     ' 
C     ' If Res > 1.4 Then Res = 1.4 
C     ' 
      U_Temp = Res 
      END
C     ' 
      REAL*4 FUNCTION U_Even_Odd(I_Channel,PEO)
      IMPLICIT NONE
      INTEGER*4 I_Channel
      REAL*4 PEO
C     ' Creates even-odd fluctuations 
      REAL*4  R
      IF (   MOD(I_Channel,2)  .EQ. 0  ) THEN 
      R = 1.0 + PEO 
      Else 
      R = 1.0 - PEO 
      End If 
      U_Even_Odd = R 
      END
C     ' 
C     ' 
      REAL*4 FUNCTION BFTF(RZ,RA,I_Switch)
      IMPLICIT NONE
      REAL*4 RZ
      REAL*4 RA
      INTEGER*4 I_Switch
C     /' Fission barriers from Myers and Swiatecki,Thomas-Fermi model '/ 
C     /'  I_Switch: 0: liquid-drop; 1: with shells and pairing, 
C     2: averaged over pairing,3: with shell and pairing + pairing gap at barrier '/ 
C     ' 4: liquid-drop + g.s. shell,no Z correction 
      REAL*4  RN,RI,Rkappa,RS,RF,RX
      REAL*4  RX0
      DATA RX0/48.5428/
      REAL*4  RX1
      DATA RX1/34.15/
      REAL*4  RB
      INTEGER*4  IZ,IA
      REAL*4 U_SHELL_EXP 
      REAL*4 U_SHELL_EO_EXP 
      REAL*4 LYPAIR 
C     ' 
      IZ = NINT(RZ) 
      IA = NINT(RA) 
      RN = RA - RZ 
      RI = (RN-RZ) / RA 
      Rkappa = 1.9E0 + (RZ - 80.E0) / 75.E0 
      RS = RA**0.666667E0 * (1.E0 - Rkappa * RI**2) 
      RX = RZ**2 / (RA * (1.E0 - Rkappa * RI**2)) 
      IF (  RX .LT. 30  ) THEN 
C     /' out of range '/ 
      RF = 1.E10 
      End If 
      IF (  RX .GT. RX0  ) THEN 
C     /' out of range '/ 
      RF = 0.0 
      End If 
      IF (  RX .LT. RX1 .AND. RX .GT. 30  ) THEN 
      RF = 0.595553E0 - 0.124136E0 * (RX - RX1) 
      End If 
      IF (  RX .GE. RX1 .AND. RX .LE. RX0  ) THEN 
      RF = 0.000199749 * (RX0 - RX)**3 
      End If 
      RB = RF * RS 
C     ' 
      Select CASE( I_Switch) 
      CASE( 0) 
C     ' no shell,no pairing 
      BFTF = RB 
      CASE( 1) 
C     ' including even-odd staggering due to increased pairing strength at barrier 
C     ' Tentative modification from comparison with experimental fission barriers 
C     ' (shell correction at the barrier?) 
      IF (  RZ .GT. 86.5  )  RB = RB - 0.15 * (RZ - 86.5) 
C     '    If RZ > 90 Then RB = RB + 0.3 * (RZ - 90.0) 
C     '    If RZ > 98 Then RB = RB - 0.15 * (RZ - 98.0) 
      IF (  RZ .GT. 90  )  RB = RB + 0.35 * (RZ - 90.0) 
      IF (  RZ .GT. 93  )  RB = RB + 0.15 * (RZ - 93.0) 
      IF (  RZ .GT. 95  )  RB = RB - 0.25 * (RZ - 95.0) 
C     '    BFTF = RB - U_Shell(IZ,IA) 
C     '    BFTF = RB - U_Shell_exp(IZ,IA) 
      BFTF = RB - U_Shell_EO_exp(IZ,IA) + Lypair(IZ,IA) * 14.0/12.0 
C     '   BFTF = RB - U_Shell_EO_exp(RZ,RA) - 14.E0 / sqr(Csng(RA))    '       * Csng( ( (RZ+1) Mod 2 + (RA-RZ+1) Mod 2) ) 
      CASE( 2) 
C     ' averaged over even-odd staggering 
      IF (  RZ .GT. 86.5  )  RB = RB - 0.15 * (RZ - 86.5) 
      IF (  RZ .GT. 90  )  RB = RB + 0.35 * (RZ - 90.0) 
      IF (  RZ .GT. 93  )  RB = RB + 0.15 * (RZ - 93.0) 
      IF (  RZ .GT. 95  )  RB = RB - 0.25 * (RZ - 95.0) 
      BFTF = RB - U_Shell_exp(IZ,IA) 
      CASE( 3) 
C     ' like Case 1 but without increased pairing gap at barrier 
      IF (  RZ .GT. 86.5  )  RB = RB - 0.15 * (RZ - 86.5) 
      IF (  RZ .GT. 90  )  RB = RB + 0.35 * (RZ - 90.0) 
      IF (  RZ .GT. 93  )  RB = RB + 0.15 * (RZ - 93.0) 
      IF (  RZ .GT. 95  )  RB = RB - 0.25 * (RZ - 95.0) 
      BFTF = RB - U_Shell_EO_exp(IZ,IA) 
      CASE( 4) 
C     ' like case 3 but without Z correction 
C     ' This is the direct description from the topographic theorem. 
      BFTF = RB - U_Shell_exp(IZ,IA) 
      Case DEFAULT 
C     '         Print "Undefined option in BFTF" 
C     '         Sleep 
      End Select 
C     /'  If I_Switch = 0 Then 
C     BFTF = RB 
C     Else 
C     ' Tentative modification from comparison with experimental fission barriers 
C     ' (shell correction at the barrier?) 
C     If RZ > 86.5 Then RB = RB - 0.15 * (RZ - 86.5) 
C     '    If RZ > 90 Then RB = RB + 0.3 * (RZ - 90.0) 
C     '    If RZ > 98 Then RB = RB - 0.15 * (RZ - 98.0) 
C     If RZ > 90 Then RB = RB + 0.35 * (RZ - 90.0) 
C     If RZ > 93 Then RB = RB + 0.15 * (RZ - 93.0) 
C     If RZ > 95 Then RB = RB - 0.25 * (RZ - 95.0) 
C     ' 
C     '    BFTF = RB - U_Shell(IZ,IA) 
C     '    BFTF = RB - U_Shell_exp(IZ,IA) 
C     BFTF = RB - U_Shell_EO_exp(IZ,IA) + Lypair(IZ,IA) * 14.0/12.0 
C     End If '/ 
      END
C     ' 
      REAL*4 FUNCTION BFTFA(RZ,RA,I_Switch)
      IMPLICIT NONE
      REAL*4 RZ
      REAL*4 RA
      INTEGER*4 I_Switch
C     /' inner barrier height '/ 
      REAL*4  EA,BF0,Z4A,Z3A,DB
      REAL*4  coeff
      DATA coeff/0.5/
      REAL*4 BFTF 
      BF0 = BFTF(RZ,RA,I_Switch) 
C     ' Z4A = RZ^4 / RA 
C     '  EB - EA from fit to Smirenkin barriers: 
C     '  V. M. Kupriyanov,K. K. Istekov,B. I. Fursov,G. N. Smirenkin 
C     '  Sov. J. Nucl. Phys. 32 (1980) 184 
C     '  DB = -10.3517 + 1.6027E-5 * Z4A + 5.4945E-11 * Z4A^2  ' EA - EB 
C     ' 
C     '  EB - EA from fit to data from Dahlinger et al. (KHS,21. Dec. 2012) 
      Z3A = RZ**3 / RA 
      DB = -(5.40101 - 0.00666175*Z3A + 1.52531E-6*Z3A**2) 
      IF (  DB .GT. 0.0  ) THEN 
      EA = BF0 - DB 
      Else 
      EA = BF0 
      End If 
      BFTFA = EA 
      END
C     ' 
      REAL*4 FUNCTION BFTFB(RZ,RA,I_Switch)
      IMPLICIT NONE
      REAL*4 RZ
      REAL*4 RA
      INTEGER*4 I_Switch
C     /' outer barrier height '/ 
      REAL*4  EB,BF0,Z4A,Z3A,DB
      REAL*4  coeff
      DATA coeff/0.5/
      REAL*4 BFTF 
      BF0 = BFTF(RZ,RA,I_Switch) 
C     ' Z4A = RZ^4 / RA 
C     '  EB - EA from fit to Smirenkin barriers: 
C     '  V. M. Kupriyanov,K. K. Istekov,B. I. Fursov,G. N. Smirenkin 
C     '  Sov. J. Nucl. Phys. 32 (1980) 184 
C     '   DB = -10.3517 + 1.6027E-5 * Z4A + 5.4945E-11 * Z4A^2  ' EA - EB 
C     ' 
C     '  EB - EA from fit to data from Dahlinger et al. (KHS,21. Dec. 2012) 
      Z3A = RZ**3 / RA 
      DB = -(5.40101 - 0.00666175*Z3A + 1.52531E-6*Z3A**2) 
      IF (  DB .LT. 0.0  ) THEN 
      EB = BF0 + DB 
      Else 
      EB = BF0 
      End If 
      BFTFB = EB 
      END
C     ' 
C     ' 
C     ' 
C     /' Utility functions '/ 
C     ' 
C     ' 
      REAL*4 FUNCTION Gaussintegral(R_x,R_sigma)
      IMPLICIT NONE
      REAL*4 R_x
      REAL*4 R_sigma
C     /' Smoothed step function. Grows from 0 to 1 around R_x 
C     with a Gauss-integral function with given sigma'/ 
      REAL*4  R_ret
C     ' Note: The variable R_sigma = standard deviation / sqr(2) ! 
      REAL*4 ERF 
      R_ret = 0.5E0 + 0.5E0 * Erf(R_x / R_sigma) 
      Gaussintegral = R_ret 
      END
C     ' 
      REAL*4 FUNCTION Bell(xpos,xleft,xright)
      IMPLICIT NONE
      REAL*4 xpos
      REAL*4 xleft
      REAL*4 xright
C     ' Bell-shaped curve,maximum = 1,zero for x < xleft and x > xright 
      REAL*4  x,y
      IF (  xpos - xleft .GT. 1.E-3 .AND. xright - xpos .GT. 1.E-3  ) 
     *THEN 
      x = (xpos - xleft) / (xright - xleft) 
      y = (x**2 * (1-x)**2)/0.0625 
      Else 
      y = 0 
      End If 
      Bell = y 
      END
C     ' 
      REAL*4 FUNCTION U_Box(x,sigma,length)
      IMPLICIT NONE
      REAL*4 x
      REAL*4 sigma
      REAL*4 length
      REAL*4  y
C     ' Note: The variable sigma = standard deviation / sqr(2) ! 
      REAL*4 GAUSSINTEGRAL 
      y = Gaussintegral(x+0.5*length,sigma) - 
     *Gaussintegral(x-0.5*length,sigma) 
      U_Box = y/length 
      END
C     ' 
      REAL*4 FUNCTION U_Box2(x,sigma1,sigma2,length)
      IMPLICIT NONE
      REAL*4 x
      REAL*4 sigma1
      REAL*4 sigma2
      REAL*4 length
      REAL*4  y
C     ' Note: The variable sigma = standard deviation / sqr(2) ! 
      REAL*4 GAUSSINTEGRAL 
      y = Gaussintegral(x+0.5*length,sigma2) - 
     *Gaussintegral(x-0.5*length,sigma1) 
      U_Box2 = y/length 
      END
C     ' 
      REAL*4 FUNCTION U_Gauss(x,sigma)
      IMPLICIT NONE
      REAL*4 x
      REAL*4 sigma
      REAL*4  y
      REAL*4  pi
      PARAMETER (pi=3.14159)
C     ' 
      y = 1.0 / (SQRT(2.0 * pi) * sigma) * exp(-x**2/ ( 2.0 * sigma**2 
     *) ) 
      U_Gauss = y 
      END
C     ' 
      REAL*4 FUNCTION U_Gauss_abs(x,sigma)
      IMPLICIT NONE
      REAL*4 x
      REAL*4 sigma
      REAL*4  y
      REAL*4  pi
      PARAMETER (pi=3.14159)
C     ' 
      y = exp(-x**2/ ( 2.0 * sigma**2 ) ) 
      U_Gauss_abs = y 
      END
C     ' 
      REAL*4 FUNCTION U_Gauss_mod(x,sigma)
      IMPLICIT NONE
      REAL*4 x
      REAL*4 sigma
C     ' Gaussian with Sheppard correction 
      REAL*4  y
      REAL*4  sigma_mod
      REAL*4  pi
      PARAMETER (pi=3.14159)
      sigma_mod = SQRT(sigma**2 + 1./12.) 
C     ' 
      y = 1.0 / (SQRT(2.0 * pi) * sigma_mod) * exp(-x**2/ ( 2.0 * 
     *sigma_mod**2 ) ) 
      U_Gauss_mod = y 
      END
C     ' 
      REAL*4 FUNCTION U_LinGauss(x,R_Sigma)
      IMPLICIT NONE
      REAL*4 x
      REAL*4 R_Sigma
C     /' Gaussian times a linear function '/ 
C     /' Not normalized! '/ 
      REAL*4  R_Res
      IF (  R_Sigma .GT. 0.0  ) THEN 
      R_Res = x * exp(-x**2/(2.0 * R_Sigma**2)) 
      Else 
      R_Res = 0.0 
      End If 
      U_LinGauss = R_Res 
      END
C     ' 
